function READFILE,rdir,filename,ext,head
;+
; NAME:
;	READFILE
; PURPOSE:
;	read files with MPFS-images. Will also read zip compressed FTS-files
; DESCRIPTION:
;
; CALLING SEQUENCE:
;	Result= READFILE ( rdir, filename, ext, head)
;
; CATEGORY:
;	reduction MPFS-data
;
; INPUTS:
;	rdir - string name input directory for reading
;	filename - string name file withot extention
;	ext -	string name extention file for reading (value '.zip' or '.fts')
;		if extention e.q. '.zip' routine unzippiped files
; OUTPUTS:
;	Result = 2D ploat point array MPFS-image
;
; OPTIONAL OUTPUT:
;	head - string array contain FITS-header image
;
; OPTIONAL INPUT KEYWORDS:
;	no
;
; RESTRICTIONS:
;	no
;
; NOTES:
;	no
;
; PROCEDURES USED:
;	READ_FTS, SPAWN
;
; MODIFICATION HISTORY:
;       Written by Victor Afanasiev, Special Astrophysical Observatory RAS, Jul 1999
;-
head=0
if ext eq '.zip' or ext eq '.ZIP' then begin
file_zip=rdir+filename+ext

file_fts=strlowcase(filename)+'.fts'

if os_family() eq 'unix' then zip_pro='unzip ' else zip_pro='pkunzip '
print,zip_pro+file_zip
SPAWN,zip_pro+file_zip
result=READ_FTS(file_fts,head);,SILENT='silent')
if os_family() eq 'unix' then del_pro='rm -f ' else del_pro='del '
SPAWN,del_pro+file_fts
endif
if ext eq '.fts' then begin
print,rdir+filename+'.fts'
result=READ_FTS(rdir+filename+'.fts',head,SILENT='silent')

endif

return,result
end
