pro anacont,infile,wdir          
  field=[16,16]
  obj=double(readfits(wdir+infile,h))
  a=size(obj)
  dl=sxpar(h,'CDELT1')
  l0=sxpar(h,'CRVAL1')
  nx=a(1)                          ;  number of wavelengths 
  ny=a(2)			   ; number of fibers
  l=l0+dl*dindgen(nx)		; wavelength grid

  cube=reform(obj,nx,field[0],field[1])  
  flux=dblarr(nx)  &  fwhm=dblarr(nx)  &  cenx=dblarr(nx)  &  ceny=dblarr(nx)

  for k=0,nx-1 do begin
    slice=reform(cube(k,*,*))
    gfit=gauss2dfit(slice/total(slice),g)
    flux[k]=2.*!DPI*g[2]*g[3]*g[1]*total(slice)
    cenx[k]=g[4]  &  ceny[k]=g[5]
    fwhm[k]=sqrt((g[2]^2+g[3]^2)*.5)
  endfor

set_plot,'ps'
device,filename=wdir+'gaupars.ps',/portrait,xsize=20,ysize=28,yoffset=0,xoffset=0
!p.multi=[0,1,3]
  plot,l,flux*1.e+13,xst=1,yst=1,ytitle='flux, 1.e-13 erg/(cm^2 s A)',title='2D-gaussian fitting parameters',/ylog
  plot,l,cenx-median(cenx),xst=1,yst=1,ytitle='center position, arcsec'
  oplot,l,ceny-median(ceny),linestyle=3
  plot,l,fwhm*2.35,xst=1,yst=1,xtitle='wavelength,Angstroms',ytitle='image fwhm, arcsec'
!p.multi=0
device,/close
set_plot,'x'

end
