;**********************************
;* atmospher dispersion correction
;*program uses  file atm_dis.txt (from atm_dis.pro)
;***********************************

;name='obj'
;filein=name+'-sky.fts'   ; input file
;fileout=name+'-cor.fts'    ; output file
;fileref='atm_dis.txt' ;reference file with barycenter position

pro atm_cor,filein,fileout,fileref,w_dir
on_error,2
 CD,current=old_dir
 CD,w_dir
 obj=read_fts(filein,header) ; read OBJ
 n=sxpar(header,'NAXIS1')
 m=sxpar(header,'NAXIS2')
 w=2 ; border extention

 a=''
 refpos=dblarr(3,n)
 openr,1,fileref
 for i=1,3 do readf,1,a          ; skip header
 readf,1,refpos
 close,1

CD,old_dir

nx=16;\pupil array
ny=16;/


; array creation
x1=w
x2=x1+nx-1
y1=w
y2=y1+ny-1

map=dindgen(nx+2*w,ny+2*w)
x0=refpos(1,n/2) ;\refernce barycenter position
y0=refpos(2,n/2) ;/
FOR i=0,n-1 do BEGIN
   if i mod 100 eq 0 then print,'Channel ',i
   dx=x0-refpos(1,i)
   dy=y0-refpos(2,i)
   ; border extention:
   map(x1:x2,y1:y2)=obj(i,*)
   map(0:x1-1,y1:y2)=reverse(map(x1:x1+w-1,y1:y2),1)
   map(x2+1:*,y1:y2)=reverse(map(x2-w+1:x2,y1:y2),1)
   map(*,0:y1-1)=reverse(map(*,y1:y1+w-1),2)
   map(*,y2+1:*)=reverse(map(*,y2-w+1:y2),2)
   ;map=imshift(map,dx=dx,dy=dy)
   map=shift_image(map,dx,dy)
   obj(i,*)=map(x1:x2,y1:y2)
ENDFOR


CD,w_dir

sxaddhist,'ATM_COR.PRO: differencial  dispersion correction from file: '+fileref,header
writefits,fileout,obj,header
CD,old_dir

!p.multi=[0,1,1]
END
