;**********************************
;* atmospher dispersion determinaion
;* file atm_dis.txt will be constracted			; constricted?
;* Format : <channel>   <dX>    <dY>
;* dX, dY -- barycenter shift
;* and  rebinned to LOG-scale!!
;***********************************
pro atm_dis,filein,fileout,w_dir
;filein='obj-cor.fts'   ; input file
;fileout='atm_dis2.txt' ;output file
fileps='atm_dis.ps' ;output PS-file

deg=2 ; polynom degree
sig=1. ; rms for goodpoly
rad=5 ; radius of window
rad1=rad+1 ; r1 for sky
rad2=rad1+1 ; r2 for sky

;goto,fin
; read file
CD,current=old_dir
CD,w_dir
obj=read_fts(filein,header) ; read OBJ
a=size(obj)
;obj_t=obj(100:a[1]-100,*)
CD,old_dir

Sx=sxpar(header,'NAXIS1')
m=sxpar(header,'NAXIS2')
ld0 =sxpar(header,'CRVAL1',comment=c1)
dld0=sxpar(header,'CDELT1',comment=c2)
n=Sx ; wavelength range
lda=ld0+dld0*dindgen(n); wavelength grid
ch=dindgen(n)

nx=16;\pupil array
ny=16;/

x1=150  ;\skip borders
x2=n-150;/


; array creation
x_bar=dblarr(n)
y_bar=dblarr(n)
im=dblarr(nx,ny)
x=get_num(nx,ny,/x)
y=get_num(nx,ny,/y)


FOR i=x1,x2 do BEGIN
	im(*)=reform(obj(i,*))
	m=max(im,pos)
	x_old=x(pos)
	y_old=y(pos)
;	centrod,im,x_old,y_old,rad,rad1,rad2,sky,x_bar_i,y_bar_i,mass
;    centrod, image, xcen, ycen, radius, inradius, outradius, skyback, $
;             xbar, ybar, counts
        fim=gauss2dfit(im/max(im),bar)        
	x_bar(i)=bar(4)
	y_bar(i)=bar(5)
;print,bar(4),bar(5)

ENDFOR

fin:
window,0,xs=600,ys=600
!p.multi=[0,1,2]
rec=where( (ch ge x1)and(ch le x2))
fx=goodpoly(lda(rec),x_bar(rec),deg,sig)
x_pos=poly(lda,fx)
plot,lda(rec),x_bar(rec),xst=1,yst=1,xtit='WAVELENGTH',YTIT='X bar',tit='Barycenter for '+filein,yr=minmax(x_pos)
oplot,lda,x_pos,thick=3

fy=goodpoly(lda(rec),y_bar(rec),deg,sig)
y_pos=poly(lda,fy)
plot,lda(rec),y_bar(rec),xst=1,yst=1,xtit='WAVELENGTH',YTIT='Y bar',tit='Barycenter for '+filein,yr=minmax(y_pos)
oplot,lda,y_pos,thick=3


CD,w_dir
openw,1,fileout
printf,1,'Barycenter positions from file: '+filein
printf,1,'Rwin=',rad,'    Rsky1=',rad1,'    Rsky2=',rad2
printf,1,'wavelength  Xbar     Ybar'
for i=0,n-1 do printf,1,lda(i),x_pos(i),y_pos(i),format='(3F10.4)'
close,1
obj=read_fts(filein,header) ; read OBJ
obj=obj(1:*,*)



; PS-file
set_plot,'ps'
  plotsym,0,0.5,/fill
  device,file=fileps,xs=18,ys=22,/port,xoff=0,yoff=2

     plot,lda(rec),x_bar(rec),xst=1,yst=1,psym=8,xtit='WAVELENGTH',YTIT='X bar',tit='Barycenter for '+filein,yr=minmax(x_pos)
     oplot,lda,x_pos,thick=3

     plot,lda(rec),y_bar(rec),xst=1,psym=8,yst=1,xtit='WAVELENGTH',YTIT='Y bar',tit='Barycenter for '+filein,yr=minmax(y_pos)
     oplot,lda,y_pos,thick=3

  device,/close
  set_plot,'x'
  !p.multi=[0,1,1]
  CD,old_dir
END
