function chosum,x,y,l,freal,a,pders
         f0=2.*(2.*!DPI)^(-1.5)*exp(-.5*total(a^2))
  s=double(0)
  pders=double([0.,0.,0.])
  for k=0,n_elements(l)-1 do begin
    for j=0,n_elements(x)-1 do begin
      for i=0,n_elements(y)-1 do begin
         ftheor=f0*exp(-.5*((l[k])^2+(x[j])^2+(y[i])^2))*cosh(total(a*[l[k],x[j],y[i]]))
         S=S+(freal[j,i,k]/sqrt(ftheor)-sqrt(ftheor))^2
         pders=pders+[l[k],x[j],y[i]]*(ftheor-freal[j,i,k])*(1./ftheor-1.)*tanh(total(a*[l[k],x[j],y[i]]))
      endfor
    endfor
  endfor
  return,S
end

pro coshap,infile,lrange,cent,sig,field=field
         f0=2.*(2.*!DPI)^(-1.5)

if not(keyword_set(field)) then field=[16,16]

data=readfits(infile,header)
a=size(data)
; cube=reform(data,a[1],16,16)
cube=data
l0=sxpar(header,'CRVAL1')  &  dl=sxpar(header,'CDELT1')
l=l0+dl*dindgen(a[3])

ind=where(l gt min(lrange) and l lt max(lrange),cind)
area=cube(*,*,ind)
area=area/total(area)
lar=l(ind)
xar=dindgen(field[0])  &  yar=dindgen(field[1])

profile=total(total(area,1),1)
track_x=profile   &   track_y=profile
for k=0,cind-1 do begin
  track_x[k]=total(total(area(*,*,k),2)*xar)/total(area(*,*,k))
  track_y[k]=total(total(area(*,*,k),1)*yar)/total(area(*,*,k))
endfor

 cent[0]=total(profile*lar)/total(profile)

map=total(area,3)
mapx=total(map,2)  &   mapy=total(map,1)

cent[1]=total(mapx*xar)/total(mapx)  &  cent[2]=total(mapy*yar)/total(mapy)

lar_n=(lar-cent[0])/sig[0]
xar_n=(xar-cent[1])/sig[1]  &  yar_n=(yar-cent[2])/sig[2]

; minimizing S_(lar_n, xar_n, yar_n)(area - chosmo(lar_n,xar_n,yar_n, f0, deltal, deltax, deltay))^2

print,cent

a0=[.3,-.85,.1]
a=a0
v=a*0.
s0=chosum(xar_n,yar_n,lar_n,area,a0,pders)  
s=s0
for iter=0,100 do begin
  s=chosum(xar_n,yar_n,lar_n,area,a,pders)  
  a=a ;+v*1.e-4
  v=v*.99-pders*1.e-4
  if total(v*pders) lt 0. then v=v*.8
;  if s ge s0 then v=-v*.1
  print,a,'s=',s
endfor
s1=s
for iter=0L,100000 do begin
  s=s1
  s1=chosum(xar_n,yar_n,lar_n,area,a,pders)
  a=a ;+v*1.e-4
  v=v*.9-pders*1.e-3
  if total(v*pders) lt 0. then v=v*.5
;  if s ge s0 then v=-v*.1
  if (s1-s)/s lt 1.e-4 then goto,fin
  print,a,'s=',s
endfor

fin:

areasim=area
  for k=0,n_elements(lar_n)-1 do begin
    for j=0,n_elements(xar_n)-1 do begin
      for i=0,n_elements(yar_n)-1 do begin
        areasim[j,i,k]=f0*exp(-.5*total(a^2))*exp(-.5*((lar_n[k])^2+(xar_n[j])^2+(yar_n[i])^2))*cosh(total(a*[lar_n[k],xar_n[j],yar_n[i]]))/(sig[0]*sig[1]*sig[2])
      endfor
    endfor
  endfor
  profile_sim=total(total(areasim,1),1) ;/total(areasim)
track_xsim=profile   &   track_ysim=profile
for k=0,cind-1 do begin
  track_xsim[k]=total(total(areasim(*,*,k),2)*xar)/total(areasim(*,*,k))
  track_ysim[k]=total(total(areasim(*,*,k),1)*yar)/total(areasim(*,*,k))
endfor

wkiller
  plot,lar,profile
  oplot,lar,profile_sim,color=1000
window,/free
  plot,lar,track_x,yrange=[min([track_x,track_xsim]),max([track_x,track_xsim])],psym=2
  oplot,lar,track_xsim,color=1000
window,/free
  plot,lar,track_y,yrange=[min([track_y,track_ysim]),max([track_y,track_ysim])],psym=2
  oplot,lar,track_ysim,color=1000

message,'dlambda = '+string(sig[0]*a[0]+cent[0]),/cont
message,'dx = '+string(sig[1]*a[1]+cent[1]),/cont
message,'dy = '+string(sig[2]*a[2]+cent[2]),/cont


end
