function cosmetic,image_in,bad_column
;+
; NAME:
;	COSMETIC
; PURPOSE:
;	replace  bad column in CCD-frame
; DESCRIPTION: 
;	
; CALLING SEQUENCE:
;	Result=COSMETIC(image_in,bad_column)
; CATEGORY:
;	reduction MPFS-data		
;
; INPUTS:
;	image_in = 2-dimensional float array  CCD-frame MPFS-data
;	bad_column = 1-dimensional integer array value bad column
;
; OUTPUTS:
;	Result = 2-dimensional float array 
;		
; OPTIONAL OUTPUT:
;	no
;
; OPTIONAL INPUT KEYWORDS:
;	no	
;
; RESTRICTIONS:
;	no
;
; NOTES:
;	no
;
; PROCEDURES USED:
;	no
;
; MODIFICATION HISTORY:
;       Written by Victor Afanasiev, Special Astrophysical Observatory RAS, Jul 1999
;-

on_error,2
b=size(bad_column)
a=size(image_in)
N_x=a(1)  & N_y=a(2)
N_bad=b(1)
image_tmp=fltarr(N_x,N_y)
image_tmp=image_in
for k=0,N_bad-1 do begin
  col=bad_column(k)
  image_tmp(col,*)=(image_tmp(col-1,*)+image_tmp(col+1,*))/2.
endfor
return,image_tmp
END
