; convert MPFS data cube
; from 2D FITS to 3D FITS

PRO CUB2TO3,filein,fileout,w_dir=w_dir
 nx=16
 if not(keyword_set(w_dir)) then cd,current=w_dir

cd,current=old_dir

; read data
cd,w_dir
im=readfits(filein,header)
 crval1=sxpar(header,'CRVAL1',comment=c1)
 cdelt1=sxpar(header,'CDELT1',comment=c2)
 ; new cube size determination
 Sx=sxpar(header,'NAXIS1')
 Sy=sxpar(header,'NAXIS2')
 ny=sy/nx
 nz=sx

 cub=fltarr(nx,ny,nz)
  for i=0,Sy-1 do begin
   y=i/nx
   x=i mod nx
   cub(x,y,*)=im(*,i)
  endfor

 sxaddpar,header,'CRVAL1' ,1
 sxaddpar,header,'CDELT1' ,1
 sxaddpar,header,'CRPIX1' ,1,after='CDELT1'
 sxaddpar,header,'CRVAL2' ,1,after='CRPIX1'
 sxaddpar,header,'CDELT2' ,1,after='CRVAL2'
 sxaddpar,header,'CRPIX2' ,1,after='CDELT1'
 sxaddpar,header,'CRVAL3' ,crval1,after='CRPIX2'
 sxaddpar,header,'CDELT3' ,cdelt1,after='CRVAL3',c1
 sxaddpar,header,'CRPIX3' ,1,after='CDELT3',c2

writefits,fileout,cub,header
cd,old_dir
END
