function CUBE_CLE,image,tresh
;+
; NAME:
;	CUBE_CLE
; PURPOSE:
;	cleaning cosmic hits in data cube
; DESCRIPTION: 
;	
; CALLING SEQUENCE:
;	Result = CUBE_CLE( image, trash )
;
; CATEGORY:
;	reduction MPFS-data		
;
; INPUTS:
;	image - cube of data in 2D-view : array Nz x (Nx*Ny) elements for cleaning
;	tresh - level discrimination data in sigma (typical value 10)
; OUTPUTS:
;	Result - cleaned cube
;		
; OPTIONAL OUTPUT:
;	no
;
; OPTIONAL INPUT KEYWORDS:
;	no	
;
; RESTRICTIONS:
;	no
;
; NOTES:
;	no
;
; PROCEDURES USED:
;	
;
; MODIFICATION HISTORY:
;       Written by Victor Afanasiev, Special Astrophysical Observatory RAS, Jul 1999
;       Commented in their own way by P.Abolmasov and A.Shipulin, Jul 2003
;-

on_error,2
a=size(image)
Nz=a(1) & Nx=16 & Ny=15

cube=fltarr(Nz,Nx,Ny)
cube(*,*,*)=image(*,*)

k=0
ima=fltarr(Nx,Ny)

for z=0,Nz-1 do begin                 ; POR QUE???
	ima(*,*)=cube(z,*,*)

	ima_lis=median(ima,3)

	ima_sub=ima-ima_lis
	sigma = STDEV(ima_sub)

	b=where(abs(ima_sub) gt tresh*sigma,index)      ; index is the number of points above the limit
 if index ne 0 then begin
   im=fltarr(Nx+2,Ny+2)
   im(1:Nx,1:Ny)=ima_sub(*,*)
   x=b-(b/Nx)*Nx
   y=b/Nx
   ima_sub(x,y)=im(x,y+2)+im(x,y+1)+im(x,y)+$
			 im(x+2,y+2)+im(x+2,y+1)+im(x+2,y)+$
			 im(x+1,y+2)+im(x+1,y)
  ima(x,y)=ima_lis(x,y)+ima_sub(x,y)/8
  k=k+1
 endif
 cube(z,*,*)=ima(*,*)
endfor                                   ; POR QUE NO?...

MESSAGE,'replaced '+string(k)+' point',/cont
image(*,*)=cube(*,*,*)
cube=0
return,image
END
