function ima_cor,im1,im2,xar=xar,yar=yar

a1=size(im1)
xc=dindgen(a1[1])  &  yc=dindgen(a1[2])
im1_mean=total(im1)/double(a1[1]*a1[2])
im2_mean=total(im2)/double(a1[1]*a1[2])

corr=dblarr(n_elements(xar),n_elements(yar))
 for i=0,n_elements(xar)-1 do begin
   for j=0,n_elements(yar)-1 do begin
    im1_shifted=interpolate(im1,xc+xar[i],yc+yar[j],/grid)
    im2_shifted=interpolate(im2,xc-xar[i],yc-yar[j],/grid)
    corr[i,j]=.5*(total((im1_shifted-total(im1_shifted)/double(a1[1]*a1[2]))*(im2-im2_mean))+$
  total((im2_shifted-total(im2_shifted)/double(a1[1]*a1[2]))*(im1-im1_mean)))
   endfor
 endfor

 tvscl,corr
corfit=sfit(corr,2,kx=kx)
maxv=max(corfit,wmax)

dx=xar[wmax mod n_elements(yar)]  &  dy=yar[round(wmax/n_elements(yar))]

return,[dx,dy]
end

pro cube_correlate,infile
field=[16,16]

cube=readfits(infile,h)
dl=sxpar(h,'CDELT1')  &  l0=sxpar(h,'CRVAL1')   &  z=sxpar(h,'Z')
ptb=(37.-sxpar(h,'ROTANGLE'))*!DPI/180.
a=size(cube)
l=dindgen(a[1])*dl+l0

cube=reform(cube,a[1],field[0],field[1])

slice0=smooth(total(cube(round(a[1]/2)-100:round(a[1]/2)+100,*,*),1),3)

xshift=dblarr(a[1])  &  yshift=dblarr(a[1])

xshar=(dindgen(500)-250.)*.01
yshar=(dindgen(500)-250.)*.01

c=20
w=where(indgen(a[1]) mod c eq 0,nw)

for k=0,nw-1 do begin
  slice=smooth(total(cube(round(k*c)-100>0:round(k*c)+100<a[1]-1,*,*),1),3)
  coor_tmp=ima_cor(slice0,slice,xar=xshar,yar=yshar)
  xshift[w[k]]=coor_tmp[0]  &  yshift[w[k]]=coor_tmp[1]
endfor
  plot,l(w),xshift(w),yrange=[-.5,.5]
  oplot,l(w),yshift(w)

ang=ptb
sh=xshift*cos(ang)+yshift*sin(ang)

shpars=goodpoly(l(w),sh(w),2,2.)

shpars=shpars/tan(z*!DPI/180.)

sent=readfits(wdir+'sent.fts',hsent)
sxaddpar,hsent,'ADR1',shpars[1]/dl
sxaddpar,hsent,'ADR2',shpars[2]/dl^2
writefits,wdir+'sent.fts',sent,hsent
end
