pro de6678,infile
c=double(2.9979e+5)

  lambda=6678.151

  sp=readfits(infile,hin)
  wdir=exdir(infile)
  dl=sxpar(hin,'CDELT1')  &  l0=sxpar(hin,'CRVAL1')
  l=dindgen(n_elements(sp))*dl+l0

  spar=sp(where(l ge lambda-30. and l le lambda+30.))
  lar=l(where(l ge lambda-30. and l le lambda+30.))

set_plot,'ps'
device,filename=wdir+'span2_6678.ps',/land,xsize=23,ysize=18,xoffset=0
loadct,0

  resp=multigaus(lar,spar,lambda+[-1.,1.]*4.*dl,fwhm=[7.,7.],sigma=sig,yfit=spfit,/plot)

  velt=(-double(1.)+resp.center/lambda)*c
    flux=resp.flux
    dflux=sig.flux
    dcent=sig.center   
    fwhm=resp.fwhm
    dfwhm=sig.fwhm
  wv=fwhm*c/lar
  dvelt=dcent*c/lar

sar=sort(resp.center)
lar=lar(sar)  &  velt=velt(sar)  &  wv=wv(sar)  &  dvelt=dvelt(sar)
flux=flux(sar)  &  dflux=dflux(sar)  &  fwhm=fwhm(sar)

lof=floor(alog10(flux))

for k=0,1 do begin
  xyouts,.2,.9-.04*k,'F!D'+strtrim(string(k+1),2)+'!N = ('+strtrim(string(flux[k]/10.^lof[k],format='(F5.3)'),2)+string("261B)+$
        strtrim(string(dflux[k]/10.^lof[k],format='(F5.3)'),2)+') 10!U'+strtrim(string(lof[k],format='(I5)'),2)+$
        '!Nerg/cm!U2!Ns ',/norm,charsize=1.2,charthick=3.
  xyouts,.65,.8-.04*k,'v!D'+strtrim(string(k+1),2)+'!N = ('+strtrim(string(velt[k],format='(F10.2)'),2)+string("261B)+$
        strtrim(string(dvelt[k],format='(F10.2)'),2)+') km/s ',/norm,charsize=1.2,charthick=3.
  xyouts,.2,.6-.04*k,'FWHM!D'+strtrim(string(k+1),2)+'!N = ('+strtrim(string(fwhm[k],format='(F10.2)'),2)+string("261B)+$
        strtrim(string(dfwhm[k],format='(F10.2)'),2)+')'+string("305B),/norm,charsize=1.2,charthick=3.
;  xyouts,.6,.6-.04*k,'FWHM!D'+strtrim(string(k+1),2)+'!N = ('+strtrim(string(sqrt((fwhm[k]*c/lar[k])^2-dva^2>0.),format='(F10.2)'),2)+string("261B)+$
;        strtrim(string(dfwhm[k]*c/lar[k],format='(F10.2)'),2)+') km/s',/norm,charsize=1.2,charthick=3.
endfor

device,/close
set_plot,'x'

end
