pro dispind,LOGFILE,Ndeg=Ndeg,PLOT=plot,l0=l0

;  
;

tabfile='/users/pasha/std/lines.tab'

if not(keyword_set(Ndeg)) then Ndeg=3

wdir=DEF_WDIR(LOGFILE)
neon_ima=readfits(wdir+'neon_s.fts',h,/silent)
Nx=sxpar(h,'NAXIS1') & Ny=sxpar(h,'NAXIS2')
;  bin=sxpar(h,'BINNING') & bin=str_sep(bin,'x') & bin=float(bin(0))

x=dindgen(Nx)
neon_vec=total(neon_ima(*,Ny/2-Ny/4:Ny/2+Ny/4),2)  ;
neon_vec1=neon_vec-poly(x,goodpoly(x,med_ext(min_ext(neon_vec,5),5),Ndeg+1,.5,neop,newx,newy))   ;coeff = goodpoly(x,y,order,thresh,yfit,newx,newy) 
neon_vecsm=smooth(smooth(neon_vec1,5),10)

; ** 

lp=disperman(neon_vec,[3888.648,4471.479,4921.931,5015.678,5080.08,5400.562,5852.49,6143.06,6678.15])
cxc=replicate(double(0.),Ndeg+1)
cxc(0:2)=lp

neonmo,x,cxc,sfit
l=poly(x,cxc)

plot,l,neon_vec*1.e-6
oplot,l,sfit,color=1000

neon_ind=(neon_vec gt 2.*median(neon_vec,20))
sfit_ind=(sfit gt 2.*median(sfit,20))

plot,neon_ind,yrange=[-.5,1.5]
oplot,sfit_ind,color=1000

m=50
crsprod,neon_ind,sfit_ind,m,corr
tmp=max(corr,mx)
w0=!d.window
window,/free,xsize=200,ysize=180
plot,corr
wset,w0
cxc[0]=cxc[0]-cxc[1]*double(mx-m+1)

 close,1
 openr,1,tabfile
 a=' '
 readf,1,a
 table=a
 WHILE NOT EOF(1) do begin
   readf,1,a
   table=[table,a]
 ENDWHILE

 lines=double(strmid(table,0,7))                                ; wavelength array
 weigth=double(strmid(table,8,1))                                  ;  
 intensity=double(strmid(table,10,4))

wmin=.1
index=where(weigth ge wmin)
lines=lines(index)  &  weigth=weigth(index)  & intensity=intensity(index)

l=poly(x,cxc)
xc=dblarr(n_elements(index))
nk=intarr(n_elements(index))

for k=0,n_elements(index)-1 do begin
  regk=where(abs(l-lines[k]) le 30.,nkk)
  nk[k]=nkk
  if nkk gt 2 then begin
    lfit=gaussfit(x(regk),neon_vec1(regk),g,nterms=3)
    xc[k]=g[1]
    plot,l(regk),neon_vec1(regk)
    oplot,l(regk),lfit,color=1000
  endif
endfor
xc=xc(where(nk)) & lines=lines(where(nk))

plot,xc,lines,psym=2

cxc=goodpoly(xc,lines,Ndeg,1.,lfit,newx,newl)

oplot,xc,poly(xc,cxc),color=1000
window,/free
neonmo,x,cxc,sfit
l=poly(x,cxc)

plot,l,neon_vec
oplot,l,sfit*1.e+6,color=1000
print,lines-lfit

coeff=dblarr(Ndeg+1,Ny)
for j=0,Ny-1 do coeff(*,j)=reverse(cxc)
N_lin=ceil((max(l)-min(l))/cxc[1])

mkhdr,h,coeff
sxaddpar,h,'lambda_0',cxc[0]

sxaddpar,h,'d_lambda',cxc[1]
sxaddpar,h,'N_lin',N_lin
sxaddpar,h,'order2',cxc[2]
writefits,wdir+'disper.fts',coeff,h

message,'enddisp...',/cont
end
