pro extracor,wdir,image_type,w

starf=''
if image_type eq 'star' or image_type eq 'test' then starf='_star'

; 1: fwhm mapping from etalon

etwa=readfits(wdir+'eta'+starf+'_sig.fts',hw)

OPENR, UNIT, '~/idllib/mpfs.lib/etalon.pos', /GET_LUN
a=' '
READF,UNIT,a
eta_pos=a                          ; eta_tra - traectories according to etalon
WHILE NOT EOF(UNIT) do begin        ; eta_pos - traectories according to 'ETALON.pos'
  READF,UNIT,a
  eta_pos=[eta_pos,a]
ENDWHILE
close, UNIT
FREE_LUN, UNIT
eta_pos=double(eta_pos)
a=size(eta_pos)

OPENR, UNIT, '~/idllib/mpfs.lib/fiber.pos', /GET_LUN
a=double(0)
READF,UNIT,a
fib_pos=a
WHILE NOT EOF(UNIT) do begin
  READF,UNIT,a
  fib_pos=[fib_pos,a]
ENDWHILE
close, UNIT
FREE_LUN, UNIT

ae=size(etwa)
etwa_field=dblarr(ae[1],n_elements(fib_pos))
etwa_flat=dblarr(ae[1],n_elements(fib_pos)+n_elements(eta_pos))

for x=0,ae[1]-1 do etwa_field(x,*)=interpol(etwa(x,*),eta_pos,fib_pos,/spline)

srt=sort([fib_pos,eta_pos])
for x=0,ae[1]-1 do begin
  tmp=[reform(etwa(x,*)),reform(etwa_field(x,*))]
  etwa_flat(x,*)=tmp(srt)
endfor

; **********

image_flat=readfits(wdir+image_type+'_s.fts',h_flat)
image_obj=readfits(wdir+image_type+'_os.fts',h_obj)
image_eta=readfits(wdir+image_type+'_ns.fts',h_eta)

image_raw=readfits(wdir+image_type+'_i.fts',h_flat)

tra=readfits(wdir+'flat_tra.fts',htra)
tra_eta=readfits(wdir+'eta_tra.fts',htra)
tras=size(tra)

tra_diff_plus=tra  &  tra_diff_minus=tra

for y=0,tras[2]-1 do begin
  if y gt 0 then tra_diff_minus(*,y)=tra(*,y)-tra(*,y-1)
  if y lt tras[2]-1 then tra_diff_plus(*,y)=-tra(*,y)+tra(*,y+1)
endfor
tra_diff_minus(*,0)=tra_diff_plus(*,0)
tra_diff_plus(*,tras[2]-1)=tra_diff_minus(*,tras[2]-1)

srate_plus=exp(-(tra_diff_plus^2*(0.*w^(-2)+etwa_flat^(-2)))*.5)
srate_minus=exp(-(tra_diff_minus^2*(0.*w^(-2)+etwa_flat^(-2)))*.5)

srate_plus(where(srate_plus gt .5))=0.
srate_minus(where(srate_minus gt .5))=0.

image_flat(*,0:tras[2]-2)=image_flat(*,0:tras[2]-2)-srate_plus(*,0:tras[2]-2)*image_flat(*,1:tras[2]-1)
image_flat(*,1:tras[2]-1)=image_flat(*,1:tras[2]-1)-srate_minus(*,1:tras[2]-1)*image_flat(*,0:tras[2]-2)

image_obj=image_flat(*,where(indgen(tras[2]) mod 17 ne 0))
image_eta=image_flat(*,where(indgen(tras[2]) mod 17 eq 0))

xcheck=1000
tra=tra-w
tra_eta=tra_eta-w

set_plot,'ps'
 device,filename=wdir+'extracor_'+image_type+'.ps'
vector=image_raw(xcheck,*)
sf=5          ; stretch factor
ys=dindgen(n_elements(vector)*sf)/double(sf)
  vector=interpol(total(image_raw(xcheck-10>0:xcheck+10<n_elements(vector)-1,*),1)/21.,$
                    dindgen(n_elements(vector)),ys)
;  ys=dindgen(n_elements(vector))
              gsim=vector*0.
              gsim_sky=vector*0.
              for k=0,tras[2]-1 do begin
                gsim=gsim+exp(-((ys-tra[xcheck,k])/etwa_flat[xcheck,k])^2/2.)*$
                   image_flat[xcheck,k]/sqrt(!DPI*2.*etwa_flat[xcheck,k]^2)*1.5
              endfor
              for k=0,16 do begin
                gsim_sky=gsim_sky+exp(-((ys-tra_eta[xcheck,k])/etwa[xcheck,k])^2/2.)*$
                   image_eta[xcheck,k]/sqrt(!DPI*2.*etwa[xcheck,k]^2)*1.5
              endfor
               !p.multi=[0,1,4]
              plot,ys,vector,xrange=[300,500],xst=1,yst=1
             loadct,27
              oplot,ys,gsim,color=1000
              oplot,ys,gsim_sky,color=10500
             loadct,0
              plot,ys,vector,xrange=[800,1000],xst=1,yst=1
             loadct,27
              oplot,ys,gsim,color=1000
              oplot,ys,gsim_sky,color=10500
             loadct,0
              plot,ys,vector,xrange=[1300,1500],xst=1,yst=1
             loadct,27
              oplot,ys,gsim,color=1000
              oplot,ys,gsim_sky,color=10500
             loadct,0
              plot,ys,vector,xrange=[1800,2000],xst=1,yst=1
             loadct,27
              oplot,ys,gsim,color=1000
              oplot,ys,gsim_sky,color=10500
             loadct,0
             !p.multi=0
 device,/close
set_plot,'x'

sxaddhist,'extraction corrected post-factum by extracor',h_flat
sxaddhist,'extraction corrected post-factum by extracor',h_obj
sxaddhist,'extraction corrected post-factum by extracor',h_eta

writefits,wdir+image_type+'_s.fts',image_flat,h_flat
writefits,wdir+image_type+'_os.fts',image_obj,h_obj
writefits,wdir+image_type+'_ns.fts',image_eta,h_eta

end
