function fibspect,datacube,fibnum
;+
; NAME:
;	FIBSPECT
; PURPOSE:
;       extracting single fiber spectrum from a datacube
;	
; DESCRIPTION:
;       no comments
; CALLING SEQUENCE:
;	result = fibspect(datacube,fibnum, [l0, dl])
;
; CATEGORY:
;	reduction MPFS-data
;
; INPUTS:
;	datacube - fts file with data 
;       fibnum - number of the fiber from wich the spectrum is extracted
; OUTPUTS:
;	1D spectrum
; OPTIONAL OUTPUT:
;	l0 - initial wavelength, dl - linear dispersion (A/pxl)
;
; OPTIONAL INPUT KEYWORDS:
;       no
; RESTRICTIONS:
;	no
;
; NOTES:
;	no
;
; PROCEDURES USED:
;       med_ext2, acre
; MODIFICATION HISTORY:
;       Written by Pavel Abolmasov, Special Astrophysical Observatory RAS, Jul 2003
;-      revised by A.Shipulin Special Astrophysical Observatory RAS, Jul 2003

on_error,2
 a=size(datacube)
 spect=fltarr(n_elements(fibnum),a(2))
 spect=datacube(*,fibnum)
 return,spect
end
