pro fluvel_plot,flux,vel,wdir,out=out,dne=dne,colt=colt,sb=sb,dvel=dvel,yrange=yrange

if not(keyword_set(sb)) then sb=1

if not(keyword_set(colt)) then colt=0.
if not(keyword_set(out)) then out='ox'
field=[16,16]
  f=rotate(readfits(flux,hf),7)
  v=rotate(readfits(vel,hv),7)
  if not(keyword_set(dvel)) then dvel=strreplace(vel,'_V','_dv',/nrep)
dv=rotate(readfits(dvel,hdv),7)

f1=med_xy(f,3)

;v(where(f1 lt 2.0*median(f1)))=sqrt(-1)
 v1=med_ext2(v,3)
w1=where(finite(v))
; f(where(abs(v-v1) gt 20.))=f1(where(abs(v-v1) gt 20.))
; wwv=where(finite(v,/NaN) or f1 lt 1.5*median(f1),nwv)
; if nwv gt 0 then v(wwv)=v1(wwv)
; v=med_ext2(v,3)
; v=smooth(v1,3)
 ; v(where(finite(v1,/NaN)))=v1(where(finite(v1,/NaN)))
; v[7,2]=v[7,3]  &  v[11,3]=v[11,4]  &  v[8,3]=v[8,4]
 ; v[11,7]=sqrt(-1)
;  v[12,3]=sqrt(-1)
 ; v[11,8]=sqrt(-1)
  posang=sxpar(hf,'POSANG')
xa=rebin(dindgen(field[1]),field[0],field[1],/sample)
ya=transpose(xa)

if keyword_set(yrange) then w1=w1(where(ya(w1) le max(yrange) and ya(w1) ge min(yrange)))
;v(where(f le median(f)*0.5))=sqrt(-1)

posar=posang*!DPI/180.
ra0=sxpar(hf,'RA') & dec0=sxpar(hf,'DEC')
; ra='20 35 0.75'  &  dec='+60 11 30.9'
ra='03 45 55.77'  &  dec='+68 04 55.2'

xch=-(ratos(ra)-ratos(ra0))*cos(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*sin(posar)+double(field[0])/2.
ych=(ratos(ra)-ratos(ra0))*sin(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*cos(posar)+double(field[1])/2.

  flux_plot=-reform(f)/median(f(where(f gt 0.)))
  flev=reverse(-.2*dindgen(1500))
  flev=flev(where(flev gt min(1.5*flux_plot)))
  uni=sxpar(hf,'BUNIT')  &  l=sxpar(hf,'LINE')

post=[3.,4.,3.+field[0],4.+field[1]]*1000.

set_plot,'ps'
  device,filename=wdir+out+'_fv.ps',xsize=field[0]+5.,ysize=field[1]+5.,/color,/land ;,set_c=[100,100]
loadct,colt
    tvscl,flux_plot,3.,3.,xsize=field[0],ysize=field[1],/centim
    contour,flux_plot,xa,ya,charsize=2.5,/fill,levels=flev,charthick=3.,$
             xstyle=5,ystyle=5,pos=post,/device,/nodata
loadct,0
;  contour1,vel_plot,xa,ya,vellev,post,ylim=10
   contour,v(w1),xa(w1),ya(w1),levels=dindgen(100)*10.-250.,/over,/irr,/down,c_thick=2.,c_charsize=1.5,$
        c_annotation=strtrim(string(dindgen(100)*10.-250.,format='(F10.2)'),2),c_charthick=2.
   if keyword_set(dne) then drawne,.8,.75,posang,r=.08,color=sb
   plotsym,0,4,color=-1,thick=10.
   plots,xch,ych,psym=8,/data,color=1,symsize=1.
  device,/close

loadct,colt
  device,filename=wdir+out+'_f.ps',xsize=field[0]+5.,ysize=field[1]+5.,/color,/port,$
    xoffset=0,yoffset=0
    if colt gt 0. then flux_plot=-flux_plot
;    tvscl,-alog(-flux_plot-median(flux_plot)),3.,3.,xsize=field[0],ysize=field[1],/centim
    tv,bytscl(flux_plot,min(flux_plot)*1.5,max(flux_plot)*1.),3.,3.,xsize=field[0],ysize=field[1],/centim
loadct,0.
    contour,v(w1),xa(w1),ya(w1),charsize=2.5,levels=dindgen(10)*50-530.,/downhill,c_labels=replicate(0,10),$
 ;    c_annotation=(strtrim(string(dindgen(100)*10.-100.,format='(I10)'),2)),$
      xstyle=1,ystyle=1,pos=post,/noer,/device,xrange=[min(xa-.5),max(xa+.5)],yrange=[min(ya-.5),max(ya+.5)],$
      charthick=3.,c_charthick=4.,c_charsize=0.5,/irr,c_thick=3. ;,c_color=-1
;  contour1,v,xa,ya,dindgen(10)*10.-100.,post
   !p.color=-1
   if keyword_set(dne) then drawne,.75,.75,posang,r=.08,color=sb
   plotsym,0,4,color=-1,thick=10.
   plots,xch,ych,psym=8,/data,color=1,symsize=1.
   !p.color=0
;   scalp,f,uni,/expf
  device,/close
loadct,colt
  device,filename=wdir+out+'_v.ps',xsize=field[0]+5.,ysize=field[1]+5.,/color,/land,yoffset=field[1]+5.,xoffset=0.
    tv,255-bytscl(v,/NaN),3.,4.,xsize=field[0],ysize=field[1],/centim
loadct,0.
    contour,v,xa,ya,charsize=2.5,levels=dindgen(200)*10.-500.,/downhill,c_annotation=strtrim(string(dindgen(100)*10.-500.,format='(F10.2)'),2),$
      xstyle=1,ystyle=1,pos=post,/noer,/device,xrange=[min(xa-.5),max(xa+.5)],yrange=[min(ya-.5),max(ya+.5)],$
      charthick=3.,/noda
   !p.color=-1
   if keyword_set(dne) then drawne,.75,.75,posang,r=.08,color=sb
   plotsym,0,4,color=-1,thick=10.
   plots,xch,ych,psym=8,/data,color=-1,symsize=1.,thick=50.
   !p.color=0
   scalp,v,'km/s',/expf
  device,/close
set_plot,'x'
end
