
PRO gau, X, A, F, pder ; function for gaussian curvefit
  COMMON CURPRF,Ycur
  COMMON FAILED,flag
  F=a(0)*exp(-(x-a(1))^2/(2*a(2)^2))
     rec=where( finite(f) eq 0,counts)
    if counts GT 0 then begin f=Ycur & print, '!!!'  & flag=1 & end

  IF N_PARAMS() GE 4 THEN BEGIN ;	If the procedure is called with four parameters,
                          ;calculate the partial derivatives.
          pder=[[F/a(0)],[F*(x-a(1))/a(2)^2],[F*(x-a(1))^2/a(2)^3]]
    rec=where( finite(pder) eq 0,counts)
    if counts GT 0 then begin pder(rec)=0. & print, '!!!' &flag=1 & a(*)=0.& end

                     ENDIF
END;gau


Function gaus_fit,x,y,fwhm,LIMMAX=limmax,LIMMIN=limmin,sigma=sigma,plot=plot
COMMON CURPRF,Ycur
COMMON FAILED,flag

;1D fitting by gaussian
;***************************************
; output = vector [amplitude,center,fwhm]
; X - wavelenght scale
; Y -- line profile
; FWHM - approximation value for FWHM
; LIMMAX, LIMMIT -- limits for calculation
;SIGMA = sigma values  on  output
;*************************************

flag=0
none=[-32000,-32000,-32000]
IF not(keyword_set(limmax)) then limmax=max(x)
IF not(keyword_set(limmin)) then limmin=min(x)
rec=where((x LE limmax)and(x GE limmin),N)
if N  EQ 0 then BEGIN message,'LIMITS are out of range!!',/contin & return,none & END

  lda=float(x(rec))
  prf=float(y(rec))
  mul=2*sqrt(2*alog(2)) ; convert from sigma to FWHM
  maxprf=max(prf,maxpos) ; position of line center

  a=fltarr(3)
  A(0)=float(maxprf)
  A(1)=float(lda(maxpos))
  A(2)=FWHM/mul
  W=fltarr(n)
  W(*)=1./n
  Ycur=prf
  ;W=(prf>0)^2

  Result =CURVEFIT(lda,prf,W,A,Sigma,function_name='gau',itmax=300,tol=1e-5)

if keyword_set(plot) then begin
  window,15
  plot,lda,prf,psym=1
  oplot,x,gaussian(x,[A,0])
                       endif
  sigma(2)=sigma(2)*mul
  a(2)=a(2)*mul

  if flag eq 0 then return,a else return,none
END
