; MPFS data reduction
; Calculation of the ghost-model

w_dir='f:\mpfs\mp001130\sbs_blue\' ; data path

filein='flat_o.fts' ; input flat-image
fileout='flat_i.fts' ; output image
file_pos=['ghost.pos','ghost2.pos']  ;  border positions (ASCII-files)
npos=n_elements(file_pos)

mul=2 ; multiplicative factor
x0=[10,700]  ;\image limit
x1=[350,890];/
Xstep=10 ; step for model claculation


; read data
; ** image
im=readfits(w_dir+filein,header)
xs=sxpar(header,'NAXIS1')
ys=sxpar(header,'NAXIS2')

;draw data
window,0,xs=xs/mul,ys=ys/mul
m1=0
m2=median(im)
tv,bytscl(-rebin(im,xs/mul,ys/mul),min=-m2,max=-m1)

for k=0,npos-1 do begin

; ** files wih borders
num=numlines(w_dir+file_pos(k))
data=fltarr(3,num)
 openr,1,w_dir+file_pos(k)
  readf,1,data
 close,1
plots,data(0,*)/mul,data(1,*)/mul,/dev,psym=1

; creation borders coordinate
spline_p,data(1,*),data(0,*),yp,xp,interval=0.5
plots,xp/mul,yp/mul,/dev
y0=ceil(min(yp))
y1=floor(max(yp))

; flat approximation:
model=im
n_nodes=(x1(k)-x0(k))/Xstep
nodes=findgen(n_nodes)*Xstep+x0(k)
x=indgen(x1(k))

FOR y=y0+1,y1-1 DO BEGIN
  vec=im(*,y)
  recid=where(fix(yp) eq y)
  lim1=min(xp(recid)) ;\ghost X-coordinates
  lim2=max(xp(recid)) ;/
  rec=where( (nodes lt lim1 )or (nodes gt lim2),nn)
  cur_nodes=nodes(rec)
  Ivec=fltarr(nn)
  for j=0,nn-1 do Ivec(j)=median(vec(cur_nodes(j)-Xstep/2:cur_nodes(j)+Xstep/2))

  ;model(0:x1(k)-1,y)=spline(cur_nodes,Ivec,x)
  f=poly_fit(cur_nodes,Ivec,3-k)
  model(0:x1(k)-1,y)=poly(x,f)
ENDFOR

ghost=im-model

; ghost image preparation:

ghost=smooth(ghost,5)
ghost(0:x0(k),*)=0
ghost(floor(max(xp)):*,*)=0
model=im-ghost
im=model
ENDFOR


old=model
; filter of the flat-image
for i=0,ys-1 do begin
    model(*,i)=median(model(*,i),7)
    model(*,i)=smooth(model(*,i),15)
endfor


;draw result
window,1,xs=xs/mul,ys=ys/mul
tv,bytscl(-rebin(model,xs/mul,ys/mul),min=-m2,max=-m1)


; write result
mkhdr,head,model
sxaddpar,head,'OBJECT','MPFS flat'
sxaddhist,'GHOST.PRO: remove ghost from '+w_dir+filein,head
sxaddhist,'GHOST.PRO: filtered along X ',head
writefits,w_dir+fileout,model,head
END