function INP_WAVE,FILELOG

;+
; NAME:
;	INP_WAVE
; PURPOSE:
;	DEFINIRION CENTRAL WAVELENGTH AND DISPERSION FROM LOG FILE
; DESCRIPTION: 
;	
; CALLING SEQUENCE:
;	Result = INP_WAVE ( FILELOG )
;
; CATEGORY:
;	reduction MPFS-data		
;
; INPUTS:
;	LOGFILE = file name of LOG observation (in format FITS-header)
;	
; OUTPUTS:
;	Result = 2 element vector, were first element - central wavelength in A
;		second - dprevius value dispersion in A/px
; OPTIONAL OUTPUT:
;	no
;
; OPTIONAL INPUT KEYWORDS:
;	no	
;
; RESTRICTIONS:
;	no
;
; NOTES:
;	no
;
; PROCEDURES USED:
;	SXPAR
;
; MODIFICATION HISTORY:
;       Written by Victor Afanasiev, Special Astrophysical Observatory RAS, Jul 1999
;-

openr,UNIT,FILELOG,/GET_LUN
a=' '
readf,UNIT,a
TABLE=a
WHILE NOT EOF(UNIT) do begin
readf,UNIT,a
TABLE=[TABLE,a]
ENDWHILE
close,UNIT
FREE_LUN, UNIT
RESULT=sxpar(TABLE,'INP_WAVE')
RESULT=FLOAT(STR_SEP(RESULT,','))
RETURN,RESULT
END
