pro linall_2,wdir,file=file,llist=llist

c=2.997925e5

if not(keyword_set(llist)) then llist=[4685.7,4861.33,4958.91,5006.84,5200.7]     ;,6678.151]
  nl=n_elements(llist)
flus1=dblarr(nl)  &  flus2=dblarr(nl) 
vels1=dblarr(nl)  &  vels2=dblarr(nl) 
fwhms1=dblarr(nl)  &  fwhms2=dblarr(nl) 
dflus1=dblarr(nl)  &  dflus2=dblarr(nl) 
dvels1=dblarr(nl)  &  dvels2=dblarr(nl) 
dfwhms1=dblarr(nl)  &  dfwhms2=dblarr(nl) 

if not(keyword_set(file)) then file='spect_obj_abs0.fts'
 sp=wdir+file
spar=readfits(sp,hsp)
  l=dindgen(n_elements(spar))*sxpar(hsp,'CDELT1')+sxpar(hsp,'CRVAL1')

for k=0,nl-1 do begin
  ; w1=where(l le llist[k]+5. and l ge llist[k]-5.)
  ; sp1=smooth(sp(w1),3)
   span,wdir+file,[llist[k],llist[k]],flux=flutmp,ston=stotmp,velt=veltmp,$
       dflux=dflutmp,dvelt=dveltmp,fwhm=fwhmtmp,dfwhm=dfwhmtmp
   spawn,'cp '+wdir+'span.ps '+wdir+'span2_'+strtrim(string(llist[k],format='(I10)'),2)+'.ps'

   flus1[k]=flutmp[0]  &  flus2[k]=flutmp[1]
   dflus1[k]=dflutmp[0]  &  dflus2[k]=dflutmp[1]
    vels1[k]=veltmp[0]  &  vels2[k]=veltmp[1]
   dvels1[k]=dveltmp[0]  &  dvels2[k]=dveltmp[1]
   fwhms1[k]=fwhmtmp[0]  &  fwhms2[k]=fwhmtmp[1]
   dfwhms1[k]=dfwhmtmp[0]  &  dfwhms2[k]=dfwhmtmp[1] 
endfor

vw=sqrt(abs(fwhms1^2-fwhms2^2))*c/llist
dvw=vw*0.5*(abs(dfwhms1/fwhms1)+abs(dfwhms2/fwhms2))

hb_tmp=min(abs(llist-4861.33),hbeta)

openw,1,wdir+'linepars_2comp.tex'
printf,1,'\documentclass[10]{article}'
printf,1,'\usepackage{times}'
printf,1,'\textwidth=100mm'
printf,1,'\textheight=230mm'
printf,1,'\topmargin=-10mm'
printf,1,'\evensidemargin=-1pt'
printf,1,'\oddsidemargin=-20pt'
printf,1,'\begin{document}'
printf,1,''
printf,1,'\title{MF16 two-component emission lines intensities}'
printf,1,'\maketitle'
printf,1,''
printf,1,'\center{'
printf,1,'\begin{tabular}{lccccccrr}'
printf,1,'$\lambda, \rm \AA$ & $F_1(\lambda)/F(H_\beta)$ & $V_1,km/s$ & $FWHM_1$,$\rm \AA $ & $F_2(\lambda)/F(H_\beta)$ & $V_2,km/s$ & $FWHM_2$,$\rm \AA$ & $\Delta v, km/s$ & $v_w, km/s$\\'
for k=0,n_elements(llist)-1 do begin
  printf,1,string(llist[k])+'&'+strtrim(string(flus1[k]/(flus1[hbeta]+flus2[hbeta]),format='(F7.3)'),2)+'$\pm$'+$
          strtrim(string(dflus1[k]/(flus1[hbeta]+flus2[hbeta]),format='(F7.3)'),2)+$
          '&'+strtrim(string(vels1[k],format='(F8.2)'),2)+'$\pm$'+$
	   strtrim(string(dvels1[k],format='(F8.2)'),2)+$
          '&'+strtrim(string(fwhms1[k],format='(F8.2)'),2)+'$\pm$'+$
           strtrim(string(dfwhms1[k],format='(F7.2)'),2)+'&'+$
          strtrim(string(flus2[k]/(flus1[hbeta]+flus2[hbeta]),format='(F7.3)'),2)+'$\pm$'+$
          strtrim(string(dflus2[k]/(flus1[hbeta]+flus2[hbeta]),format='(F7.3)'),2)+$
          '&'+strtrim(string(vels2[k],format='(F8.2)'),2)+'$\pm$'+$
	   strtrim(string(dvels2[k],format='(F8.2)'),2)+$
          '&'+strtrim(string(fwhms2[k],format='(F8.2)'),2)+'$\pm$'+$
           strtrim(string(dfwhms2[k],format='(F7.2)'),2)+$
           '&'+strtrim(string(abs(vels2[k]-vels1[k]),format='(F8.2)'),2)+'$\pm$'+$
           strtrim(string((dvels2[k]+dvels1[k]),format='(F8.2)'),2)+$
           '&'+strtrim(string(vw[k],format='(F8.2)'),2)+'$\pm$'+$
           strtrim(string(dvw[k],format='(F8.2)'),2)+'\\'
endfor
printf,1,'\end{tabular}}'
printf,1,''
printf,1,'total $H_\beta$ integral flux:'+string(flus1[hbeta]+flus2[hbeta],format='(E10.3)')+'$\pm$'+$
    string(dflus1[hbeta]+dflus2[hbeta],format='(E10.3)')+' $erg/cm^2 s$'
printf,1,''
printf,1,''
printf,1,'\end{document}'
close,1
cd,wdir,current=curd
spawn,'latex linepars_2comp.tex'
spawn,'dvips -olinepars_2comp.ps linepars_2comp.dvi'
cd,curd


end
