pro linall_lbv,wdir,file=file,sulfur=sulfur,hg=hg

if not(keyword_set(file)) then file='spect_obj_abs0.fts'

spect_unred,wdir+file,wdir+'spect_unred.fts'
sp=readfits(wdir+file,hsp)
larray=dindgen(n_elements(sp))*sxpar(hsp,'CDELT1')+sxpar(hsp,'CRVAL1')

llist=[4340.74,4861.33,5015.,5876.,$
  6562.82,6678.151,4101.33,5015.]
llist=[6562.82,4861.33,5755.,4101.33,5876.]
llist=llist(where(llist gt min(larray)-20. and llist lt max(larray)+20.))
flust=dblarr(n_elements(llist))
flust_unred=dblarr(n_elements(llist))
dflust=dblarr(n_elements(llist))
dflust_unred=dblarr(n_elements(llist))
stol=dblarr(n_elements(llist))
stol_unred=dblarr(n_elements(llist))
vels=dblarr(n_elements(llist))
dvels=dblarr(n_elements(llist))
fwhms=dblarr(n_elements(llist))  &  dfwhms=dblarr(n_elements(llist))
for k=0,n_elements(llist)-1 do begin
  span,wdir+file,[llist[k]],flux=flutmp,ston=stotmp,velt=veltmp,fwhm=fwhm_tmp,$
       dvelt=dveltmp,dflux=dflutmp,dfwhm=dfwhm_tmp
  spawn,'cp '+wdir+'span.ps '+wdir+'span_'+strtrim(string(llist[k],format='(I10)'),2)+'.ps'
  vels[k]=veltmp  &  dvels[k]=dveltmp  &  fwhms[k]=fwhm_tmp
  flust[k]=flutmp  & dflust[k]=dflutmp  &  stol[k]=stotmp &  dfwhms[k]=dfwhm_tmp
  span,wdir+'spect_unred.fts',[llist[k]],flux=flutmp,ston=stotmp,dflux=dflutmp
  flust_unred[k]=flutmp  & dflust_unred[k]=dflutmp  &  stol_unred[k]=stotmp
endfor
if keyword_set(sulfur) then begin
span,wdir+file,[6717.0,6731.3],flux=flus,ston=stos,velt=veltmp,fwhm=fwhm_tmp,$
    dvelt=dveltmp,dflux=dflus,dfwhm=dfwhm_tmp
  spawn,'cp '+wdir+'span.ps '+wdir+'span_sulf.ps'
span,wdir+'spect_unred.fts',[6717.0,6731.3],flux=flus_unred,ston=stos_unred,dflux=dflus_unred
  vels=[vels,veltmp]  &   dvels=[dvels,dveltmp]  &  fwhms=[fwhms,fwhm_tmp] &  dfwhms=[dfwhms,dfwhm_tmp]
flust=[flust,flus]  &  flust_unred=[flust_unred,flus_unred]  & llist=[llist,6717.0,6731.3]
stol=[stol,stos]  &  stol_unred=[stol_unred,stos_unred]  
dflust=[dflust,dflus]  &  dflust_unred=[dflust_unred,dflus_unred]
endif
if keyword_set(hg) then begin
span,wdir+file,[4340.74,4363.53,4363.53],flux=flus,ston=stos,velt=veltmp,fwhm=fwhm_tmp,$
    dvelt=dveltmp,dflux=dflus,dfwhm=dfwhm_tmp
  spawn,'cp '+wdir+'span.ps '+wdir+'span_hg.ps'
span,wdir+'spect_unred.fts',[4340.74,4363.53,4363.53],flux=flus_unred,ston=stos_unred,dflux=dflus_unred
  vels=[vels,veltmp]  &   dvels=[dvels,dveltmp]  &  fwhms=[fwhms,fwhm_tmp] &  dfwhms=[dfwhms,dfwhm_tmp]
flust=[flust,flus]  &  flust_unred=[flust_unred,flus_unred]  & llist=[llist,4340.74,4363.53,4363.53]
stol=[stol,stos]  &  stol_unred=[stol_unred,stos_unred]  
dflust=[dflust,dflus]  &  dflust_unred=[dflust_unred,dflus_unred]
endif
close,1

sist=sort(llist)
flust=flust(sist)  &  flust_unred=flust_unred(sist)
dflust=dflust(sist)  &  dflust_unred=dflust_unred(sist)
vels=vels(sist)  &  dvels=dvels(sist)  &  fwhms=fwhms(sist) &  dfwhms=dfwhms(sist)
llist=llist(sist)

hb_tmp=min(abs(llist-4861.33),hbeta)  &  ha_tmp=min(abs(llist-6562.82),halpha)

av=hahb_to_av([flust[halpha]/flust[hbeta]])

openw,1,wdir+'linepars.tex'
printf,1,'\documentclass[12]{article}'
printf,1,'\usepackage{times}'
printf,1,'\textwidth=170mm'
printf,1,'\textheight=230mm'
printf,1,'\topmargin=-10mm'
printf,1,'\begin{document}'
printf,1,''
printf,1,'\title{Var A emission lines intensities, $A_V \simeq '+strtrim(string(av,format='(F5.2)'),2)+'$}'
printf,1,'\maketitle'
printf,1,''
printf,1,'\center{'
printf,1,'\begin{tabular}{lcccc}'
printf,1,'$\lambda,\AA$ & $F(\lambda)/F(H_\beta)$ & $F(\lambda)/F(H_\beta)$ & $V,km/s$ & $FWHM, \rm \AA$\\'
printf,1,' & & (unreddened) & \\'
for k=0,n_elements(llist)-1 do begin
  printf,1,string(llist[k])+'&'+strtrim(string(flust[k]/flust[hbeta],format='(F7.3)'),2)+'$\pm$'+$
          strtrim(string(dflust[k]/flust[hbeta],format='(F7.3)'),2)+'&'+$
          strtrim(string(flust_unred[k]/flust_unred[hbeta],format='(F7.3)'),2)+'$\pm$'+$
          strtrim(string(dflust_unred[k]/flust_unred[hbeta],format='(F7.3)'),2)+$
          '&'+strtrim(string(vels[k],format='(F8.0)'),2)+'$\pm$'+$
	   strtrim(string(dvels[k],format='(F8.0)'),2)+$
          '&'+strtrim(string(fwhms[k],format='(F8.1)'),2)+'$\pm$'+$
           strtrim(string(dfwhms[k],format='(F7.1)'),2)+'\\'
endfor
printf,1,'\end{tabular}}'
printf,1,''
printf,1,'total $H_\beta$ flux:'+string(flust[hbeta],format='(E10.3)')+'$\pm$'+$
    string(dflust[hbeta],format='(E10.3)')+' $erg/cm^2 s$'
printf,1,''
printf,1,'total $H_\beta$ flux (unreddened):'+string(flust_unred[hbeta],format='(E10.3)')+'$\pm$'+$
    string(dflust_unred[hbeta],format='(E10.3)')+' $erg/cm^2 s$'
printf,1,' '
printf,1,'\end{document}'
close,1
cd,wdir,current=curd
spawn,'latex linepars.tex'
cd,curd

set_plot,'ps'
  device,filename=wdir+'vels.ps'
loadct,0
    plot,llist,vels,psym=2,yrange=[-200.,100.]
    oploterr,llist,vels,dvels
  device,/close
set_plot,'x'
end
