pro linall_nodub,wdir,file=file

if not(keyword_set(file)) then file='spect_obj_abs.fts'

spect_unred,wdir+file,wdir+'spect_unred.fts',/nodeb
sp=readfits(wdir+file,hsp)
larray=dindgen(n_elements(sp))*sxpar(hsp,'CDELT1')+sxpar(hsp,'CRVAL1')

llist=[4101.33,4340.74,4685.7,4861.33,4958.91,5006.84,5755.,5876.,$
  6300.23,6363.82,6678.15,5200.,4471.48,4363.53,4658.,6562.83]
llist=llist(where(llist gt min(larray)-20. and llist lt max(larray)+20.))
flust=dblarr(n_elements(llist))
flust_unred=dblarr(n_elements(llist))
dflust=dblarr(n_elements(llist))
dflust_unred=dblarr(n_elements(llist))
stol=dblarr(n_elements(llist))
stol_unred=dblarr(n_elements(llist))
vels=dblarr(n_elements(llist))
dvels=dblarr(n_elements(llist))
fwhms=dblarr(n_elements(llist))  &  dfwhms=dblarr(n_elements(llist))
for k=0,n_elements(llist)-1 do begin
  span,wdir+file,[llist[k]],flux=flutmp,ston=stotmp,velt=veltmp,fwhm=fwhm_tmp,$
       dvelt=dveltmp,dflux=dflutmp,dfwhm=dfwhm_tmp
  spawn,'cp '+wdir+'span.ps '+wdir+'span_'+strtrim(string(llist[k],format='(I10)'),2)+'.ps'
  vels[k]=veltmp  &  dvels[k]=dveltmp  &  fwhms[k]=fwhm_tmp
  flust[k]=flutmp  & dflust[k]=dflutmp  &  stol[k]=stotmp &  dfwhms[k]=dfwhm_tmp
  span,wdir+'spect_unred.fts',[llist[k]],flux=flutmp,ston=stotmp,dflux=dflutmp
  flust_unred[k]=flutmp  & dflust_unred[k]=dflutmp  &  stol_unred[k]=stotmp
endfor
span,wdir+file,[6717.0,6731.3],flux=flus,ston=stos,velt=veltmp,fwhm=fwhm_tmp,$
    dvelt=dveltmp,dflux=dflus,dfwhm=dfwhm_tmp
  spawn,'cp '+wdir+'span.ps '+wdir+'span_sulf.ps'
span,wdir+'spect_unred.fts',[6717.0,6731.3],flux=flus_unred,ston=stos_unred,dflux=dflus_unred
  vels=[vels,veltmp]  &   dvels=[dvels,dveltmp]  &  fwhms=[fwhms,fwhm_tmp] &  dfwhms=[dfwhms,dfwhm_tmp]
flust=[flust,flus]  &  flust_unred=[flust_unred,flus_unred]  & llist=[llist,6717.0,6731.3]
stol=[stol,stos]  &  stol_unred=[stol_unred,stos_unred]  
dflust=[dflust,dflus]  &  dflust_unred=[dflust_unred,dflus_unred]
;span,wdir+file,[6548.06,6562.82,6583.57],flux=f3,ston=sto3,velt=veltmp,fwhm=fwhm_tmp,$
;     dvelt=dveltmp,dflux=df3,dfwhm=dfwhm_tmp
;  spawn,'cp '+wdir+'span.ps '+wdir+'span_halpha.ps'
;span,wdir+'spect_unred.fts',[6548.06,6562.82,6583.57],flux=f3_unred,ston=sto3_unred,dflux=df3_unred
;  vels=[vels,veltmp] & fwhms=[fwhms,fwhm_tmp]   &   dvels=[dvels,dveltmp]  &   dfwhms=[dfwhms,dfwhm_tmp] 
;flust=[flust,f3]  &  flust_unred=[flust_unred,f3_unred]  &  llist=[llist,6548.06,6562.82,6583.57]
;stol=[stol,sto3]  &  stol_unred=[stol_unred,sto3_unred]
; dflust=[dflust,df3]  &  dflust_unred=[dflust_unred,df3_unred]
close,1

sist=sort(llist)
flust=flust(sist)  &  flust_unred=flust_unred(sist)
dflust=dflust(sist)  &  dflust_unred=dflust_unred(sist)
vels=vels(sist)  &  dvels=dvels(sist)  &  fwhms=fwhms(sist) &  dfwhms=dfwhms(sist)
llist=llist(sist)

hb_tmp=min(abs(llist-4861.33),hbeta)  &  ha_tmp=min(abs(llist-6562.82),halpha)

av=hahb_to_av([flust[halpha]/flust[hbeta]])

openw,1,wdir+'linepars.tex'
printf,1,'\documentclass[12]{article}'
printf,1,'\usepackage{times}'
printf,1,'\textwidth=170mm'
printf,1,'\textheight=230mm'
printf,1,'\topmargin=-10mm'
printf,1,'\begin{document}'
printf,1,''
printf,1,'\title{HoII\,X-1 emission lines intensities, $A_V \simeq '+strtrim(string(av,format='(F5.2)'),2)+'$}'
printf,1,'\maketitle'
printf,1,''
printf,1,'\center{'
printf,1,'\begin{tabular}{lcccc}'
printf,1,'$\lambda,\AA$ & $F(\lambda)/F(H_\beta)$ & $F(\lambda)/F(H_\beta)$ & $V,km/s$ & $FWHM, \rm \AA$\\'
printf,1,' & & (unreddened) & \\'
for k=0,n_elements(llist)-1 do begin
  printf,1,string(llist[k])+'&'+strtrim(string(flust[k]/flust[hbeta],format='(F7.3)'),2)+'$\pm$'+$
          strtrim(string(dflust[k]/flust[hbeta],format='(F7.3)'),2)+'&'+$
          strtrim(string(flust_unred[k]/flust_unred[hbeta],format='(F7.3)'),2)+'$\pm$'+$
          strtrim(string(dflust_unred[k]/flust_unred[hbeta],format='(F7.3)'),2)+$
          '&'+strtrim(string(vels[k],format='(F8.0)'),2)+'$\pm$'+$
	   strtrim(string(dvels[k],format='(F8.0)'),2)+$
          '&'+strtrim(string(fwhms[k],format='(F8.1)'),2)+'$\pm$'+$
           strtrim(string(dfwhms[k],format='(F7.1)'),2)+'\\'
endfor
printf,1,'\end{tabular}}'
printf,1,''
printf,1,'total $H_\beta$ flux:'+string(flust[hbeta],format='(E10.3)')+'$\pm$'+$
    string(dflust[hbeta],format='(E10.3)')+' $erg/cm^2 s$'
printf,1,''
printf,1,'total $H_\beta$ flux (unreddened):'+string(flust_unred[hbeta],format='(E10.3)')+'$\pm$'+$
    string(dflust_unred[hbeta],format='(E10.3)')+' $erg/cm^2 s$'
printf,1,' '
printf,1,'\end{document}'
close,1
cd,wdir,current=curd
spawn,'latex linepars.tex'
cd,curd

set_plot,'ps'
  device,filename=wdir+'vels.ps'
loadct,0
!p.multi=[0,1,2]
    plot,llist,vels,psym=2,yrange=[-10.,350.]
    oploterr,llist,vels,dvels
plot,larray,sp,yrange=[-.1,1.2]*max(sp)
  for k=0,n_elements(llist)-1 do begin
       tmp=min(abs(larray-llist[k]),pos)
       oplot,[larray[pos],larray[pos]],[sp[pos]*1.01,sp[pos]*1.01+total(abs(sp))/double(n_elements(sp))]
  xyouts,llist[k],sp[pos]*1.01+total(abs(sp))/double(n_elements(sp))*2.,string(llist[k],format='(F7.2)'),$
	/data,orientation=90,charsize=.6
  endfor
!p.multi=0
  device,/close
set_plot,'x'
end
