function LINEFLUX,prof,pos,fwhm=fwhm,CONTIN=contin,lambda=lambda
; Line flux calculation
; output = line flux
; LAMBDA - wavelenght scale ( default from 0...)
; PROF -- line profile
; pos -- line position (in wavelength units)
; IF CONTIN=N then average of N lowly values will be subtracted from line profile (default=0)

n=n_elements(prof)

IF not(keyword_set(lambda)) then lambda=findgen(n)
IF not(keyword_set(fwhm)) then w=3. else w=fwhm
IF not(keyword_set(contin)) then contin=0

; maximum search:
 rec=where((lambda LE pos+2*w)and(lambda GE pos-2*w),count)
 if count  EQ 0 then BEGIN message,'Line position is out of range!!',/contin & return,0 & END

 maxprf=max(prof(rec),maxpos)
 maxpos=maxpos+rec(0) ; line true position
 prf=prof(maxpos-w-contin/2:maxpos+w+contin/2) ; new line profile

 ; ** continuum determination:
              sortp=sort(prf)
              IF keyword_set(contin) then cont=median(prf(sortp(0:contin-1))) $
                                     else cont=0
              prf=prf-cont ; contiuum subtraction
              flux=total(prf)
;plot,prf
return,flux
END
