;+
; NAME:
;	maplines
; PURPOSE:
;       MappingsIII modelling of an emission-line spectrum
;
; CALLING SEQUENCE:
;       trivial!
;           
; INPUTS:
;	none yet
;       
; OUTPUTS:
;	none
;
; OPTIONAL OUTPUT:
;	 -
; OPTIONAL INPUT KEYWORDS:
;       
; ERROR HANDLING:
;	no
; RESTRICTIONS:
;	no
; NOTES:
;       no
; PROCEDURES USED:
;       extline_mappings
; MODIFICATION HISTORY:
;	Written by P.Abolmasov, 2006
;-

pro maplines,temp=temp,n=n,av=av

!PATH=!PATH+':/users/pasha/MAPPINGsIII/'

mapscript='s2_maker.sh'
mapdir='/users/pasha/MAPPINGsIII/Mappings/lab/'

lines=[4340.74,4363.53,4958.91,5006.84,6562.82,6583.57,6678.15,6717.06,6731.30]
fluxes=[0.342,0.076,0.159,0.946,6.663,1.551,0.061,3.264,1.458]
dfluxes=[0.07,0.044,0.029,0.036,033,0.029,0.061,0.257,0.211]
nl=n_elements(lines)

res1=0. &  res2=0. &  res3=0.  

temp0=4.75  &  n0=0.5 & av0=0.0  &  tol=1.d-3  &  k=0  &  res0=total(fluxes^2)/double(nl)

av=av0  &  dav=0.6
temp=temp0 &  n=n0   &  dn=-0.1  &  dtemp=0.1  &  dt=0.01
temptrace=temp0  &  ntrace=n0  &  restrace=res0  &  avtrace=av0

cd,mapdir,cur=curd
while k lt 10 do begin
   if res1<res2<res3 gt 0. then res0=sqrt((res1^2+res2^2+res3^2)/3d)
  temp=temp+dtemp*dt > 4.2
  n=n+dn*dt  
  av=abs(av+dav*dt)
  spawn,mapdir+'clean_all'
  spawn,mapdir+mapscript+' '+strtrim(string(temp,for='(F10.5)'),2)+' '+strtrim(string(n0,for='(F10.5)'),2)
   fluxes1=extline_mappings('~/MAPPINGsIII/Mappings/lab/shckn0001.sh2',[4861.33,lines],tol=1.5)
if n_elements(fluxes1) eq 1 then message,'Process aborted!'
   fluxes1=fluxes1(1:nl-1)/fluxes1[0]
ccm_unred,lines,fluxes1,-av0/3.1

  spawn,mapdir+'clean_all'
  spawn,mapdir+mapscript+' '+strtrim(string(temp0,for='(F10.5)'),2)+' '+strtrim(string(n,for='(F10.5)'),2)
   fluxes2=extline_mappings('~/MAPPINGsIII/Mappings/lab/shckn0001.sh2',[4861.33,lines],tol=1.5)
if n_elements(fluxes2) eq 1 then message,'Process aborted!'
ccm_unred,lines,fluxes2,-av0/3.1
   fluxes2=fluxes2(1:nl-1)/fluxes2[0]

  spawn,mapdir+'clean_all'
  spawn,mapdir+mapscript+' '+strtrim(string(temp0,for='(F10.5)'),2)+' '+strtrim(string(n0,for='(F10.5)'),2)
   fluxes3=extline_mappings('~/MAPPINGsIII/Mappings/lab/shckn0001.sh2',[4861.33,lines],tol=1.5)
if n_elements(fluxes3) eq 1 then message,'Process aborted!'
ccm_unred,lines,fluxes3,-av/3.1
   fluxes3=fluxes3(1:nl-1)/fluxes3[0]

  res1=total((fluxes-fluxes1)^2/dfluxes)/double(nl)
  res2=total((fluxes-fluxes2)^2/dfluxes)/double(nl)
  res3=total((fluxes-fluxes3)^2/dfluxes)/double(nl)

     if res0 eq 0. then res0=(res1+res2+res3)/3d
  print,res0,res1,res2,res3

dn0=dn  &  dtemp0=dtemp
  dn=dn*0.99-(res2-res0)*dt*(dn/abs(dn)) < n0*0.1
  dtemp=dtemp*0.99-(res1-res0)*dt*(dtemp/abs(dtemp)) < temp*0.1
  dav=dav*0.99-(res3-res0)*dt*(dav/abs(dav)) < 0.5
if abs(dtemp) ge temp/10. then temp=temp0
if abs(dn) ge 100. or abs(dn) le 1.e-3 then n=n0
 
 if res0-sqrt((res1^2+res2^2+res3^2)/3d) le tol and res0-sqrt((res1^2+res2^2+res3^2)/3d) gt 0. then k=k+1
  temptrace=[temptrace,temp]   &  ntrace=[ntrace,n] &   avtrace=[avtrace,av] &  restrace=[restrace,sqrt(res1*res2)]

set_plot,'ps'
device,filename='~/MAPPINGsIII/maplines.eps',/enc,/color
 !p.multi=[0,2,2]
 loadct,0
 plot,temptrace,ntrace,xtitle='lgT, K',ytitle='n, cm!U-3!N',/yst
 loadct,27
 oplot,[temp],[n],psym=2,color=1000

 loadct,0
 plot,avtrace,ntrace,xtitle='A!DV!N',ytitle='n, cm!U-3!N',/yst
 loadct,27
 oplot,[av],[n],psym=2,color=1000

 loadct,0
 plot,temptrace,avtrace,xtitle='lgT, K',ytitle='A!DV!N',/yst
 loadct,27
 oplot,[temp],[av],psym=2,color=1000

 loadct,0
 plot,restrace,/yst
 !p.multi=0
device,/close
set_plot,'x'
 if restrace[0] eq 0. then restrace[0]=res0
endwhile
cd,curd

  spawn,mapdir+'clean_all'
  spawn,mapdir+mapscript+' '+strtrim(string(temp,for='(F10.5)'),2)+' '+strtrim(string(n,for='(F10.5)'),2)
   fluxes1=extline_mappings('~/MAPPINGsIII/Mappings/lab/shckn0001.sh2',[4861.33,lines],tol=1.5)
ccm_unred,lines,fluxes1,-av/3.1
   fluxes1=fluxes1(1:nl-1)/fluxes1[0]

chisq=total((fluxes-fluxes1)^2/dfluxes)/double(n_elements(fluxes))

set_plot,'ps'
device,file='~/MAPPINGsIII/maplines_agreement.eps',/enc,/color
loadct,0,/sil
plot,lines,fluxes,title='lgT='+strtrim(string(temp,for='(F10.5)'),2)+';  n='+strtrim(string(n,for='(F10.5)'),2)+$
  '; av='+strtrim(string(av,for='(F10.3)'),2)+'; !4v!3!U2!N = '+chisq,xtitle='wavelength,'+string("305B),$
  charsize=2.,thick=2.,charthick=3.,psym=2,/ylog
oploterr,lines,fluxes,dfluxes,2
loadct,27,/sil
oplot,lines,fluxes1,psym=4,color=1000
loadct,0,/sil
device,/close
set_plot,'x'

end
