pro maps_all,llist,wdir,filename,w=fwhm,faint=faint ; maps_all,llist,wdir,'obj_abs.fts',w=fwhm
  if not(keyword_set(w)) then w=10.
  date=dblarr(3)
  par=dblarr(n_elements(llist),8)
  file=readfits(wdir+filename,h)
  dates=sxpar(h,'DATE-OBS')
  date=dasep(dates)
  jdcnv,date(2),date(1),date(0),0,jd
  baryvel,jd,sxpar(h,'EPOCH'),vh,vb
  ras=sxpar(h,'RA')                               ; 
  decs=sxpar(h,'DEC')
  radeg=double(strmid(ras,0,3))+double(strmid(ras,3,2))/60.+double(strmid(ras,6,2))/3600.
  decdeg=double(strmid(decs,0,3))+double(strmid(decs,3,2))/60.+double(strmid(decs,6,2))/3600.
  ra=radeg*15./!RADEG
  dec=decdeg/!RADEG 
  dv=vb(0)*cos(dec)*cos(ra)+vb(1)*cos(dec)*sin(ra)+vb(2)*sin(dec)
  print, dv
  print, wdir+filename

  for i=0, n_elements(llist)-1 do begin
    if not(keyword_set(faint)) then analine,wdir+filename,llist[i],wdir,w=w,dv=dv $
          else analine_faint,wdir+filename,llist[i],wdir,w=w,dv=dv   
    par(i,*)=parline(llist(i),wdir,w)          ; = [int. flux, mean velocity, mean fwhm, mean cont. and their uncertainties, respectively]
  endfor
close,1
openw,1,wdir+'parlines'
 for j=0, n_elements(llist)-1 do begin
printf,1,'lambda = ',strtrim(string(float(llist(j)))),$
'	total flux = ',strtrim(string(float(par(j,0)))),'+/-',strtrim(string(float(par(j,4)))), 'erg/(cm^2 Angstrom s)', $
'	mean velocity = ',strtrim(string(float(par(j,1)))),'+/-',strtrim(string(float(par(j,5)))), 'km/s',$
'	mean fwhm = ',strtrim(string(float(par(j,2)))),'+/-',strtrim(string(float(par(j,6)))), 'km/s',$
'	mean cont. level = ', strtrim(string(float(par(j,3)))),'+/-',strtrim(string(float(par(j,7)))),  'erg/(cm^2 Angstrom s)'    
 endfor
 close,1  
end
