function medfilt,array,wwidth,tlevel

;+
; NAME:
;	MEDFILT
; PURPOSE: 
;       Median non-linear filtering
; DESCRIPTION:
;       No comments
; CALLING SEQUENCE:
;	RESULT = MEDFILT(ARRAY, WWIDTH, TLEVEL)
;
; CATEGORY:
;	reduction MPFS-data
;
; INPUTS:
;	array is a 2D array of any numerical type
; OUTPUTS:
;	result - an array of the same type as array
;
; OPTIONAL OUTPUT:
;	no
;
; OPTIONAL INPUT KEYWORDS:
;	no
;
; RESTRICTIONS:
;	no
;
; NOTES:
;	no
;
; PROCEDURES USED:
;	Function  MEDIAN (a standard library function)
;		  
; MODIFICATION HISTORY:
;       Written by Pavel Abolmasov, Special Astrophysical Observatory RAS, Jul 2003
;-      Critisized by Antony Shipulin, Special Astrophysical Observatory RAS, Jul 2003
;

a=size(array)
;arr_med=dblarr(a[1],a[2])
;array1=dblarr(a[1],a[2])
array1=array
arr_med=median(array,wwidth)+tlevel

if a(0) eq 2 then begin
 for i=0,a(1)-1 do begin
  for k=0,a(2)-1 do begin
   if array[i,k] gt arr_med[i,k] then array1[i,k]=arr_med[i,k]
  endfor
 endfor
endif else begin
 message,'Function needs a 2D-array!!!'
endelse
return, array1
end
