function medfilt1, array, wwidth, tlevel

;+
; NAME:
;	MEDFILT1
; PURPOSE: 
;       Advanced median non-linear filtering
; DESCRIPTION:
;       No comments
; CALLING SEQUENCE:
;	RESULT = MEDFILT1(ARRAY, WWIDTH, TLEVEL)
;
; CATEGORY:
;	reduction MPFS-data
;
; INPUTS:
;	array is a 2D array of any numerical type
; OUTPUTS:
;	result - an array of the same type as array
;
; OPTIONAL OUTPUT:
;	no
;
; OPTIONAL INPUT KEYWORDS:
;	no
;
; RESTRICTIONS:
;	no
;
; NOTES:
;	no
;
; PROCEDURES USED:
;	Function  MEDIAN (a standard library function)
;		  
; MODIFICATION HISTORY:
;       Written by Pavel Abolmasov, Special Astrophysical Observatory RAS, Jul 2003
;-      Critisized by Antony Shipulin, Special Astrophysical Observatory RAS, Jul 2003
;

a=size(array)
array1=fltarr(a[1],a[2])
array1=array
yline=fltarr(a[2])
xline=fltarr(a[1])
;wwidth=3
if a(0) eq 2 then begin
 for i=0,a[1]-1 do begin
  yline(*)=array(i,*)
  yline=median(yline,wwidth)+tlevel
  for k=0,a[2]-1 do begin
   xline(*)=array(*,k)
   xline=median(xline,wwidth)+tlevel
   if ((array[i,k] gt xline[i]) and (array[i,k] gt yline[k])) then array1[i,k]=(xline[i]+yline[k])/2
  endfor
 endfor
endif else begin
 message,'Function needs a 2D-array!!!'
endelse
return, array1
end
