pro objinfo,wdir,line,files=files,alpha=alpha,delta=delta,dalpha=dalpha,ddelta=ddelta

if keyword_set(files) then begin
  filef=wdir+files[0]  
  filv=wdir+files[1]
endif else begin
  filef=wdir+strtrim(string(round(line),format='(I10)'),2)+'_F.FTS'
  filv=wdir+strtrim(string(round(line),format='(I10)'),2)+'_V.FTS'
endelse

  f=readfits(filef,hf)  &  v=readfits(filv,hv)
  f=rotate(f,7)  &  v=rotate(v,7)
  af=size(f)
  field=af(1:2)  

xa=rebin(dindgen(field[1]),field[0],field[1],/sample)
ya=transpose(xa)
posang=sxpar(hf,'POSANG')
uni=sxpar(hf,'BUNIT')
  posar=posang*!DPI/180.
  ra0=sxpar(hf,'RA') & dec0=sxpar(hf,'DEC')
  ra='20 35 0.75'  &  dec='+60 11 30.9'
xch=-(ratos(ra)-ratos(ra0))*cos(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*sin(posar)+double(field[0])/2.
ych=(ratos(ra)-ratos(ra0))*sin(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*cos(posar)+double(field[1])/2.

  m=50  &  w=4.

fm=rebin(f,m*field[0],m*field[1],/sample)
vm=rebin(v,m*field[0],m*field[1],/sample)
xa=rebin(xa,m*field[0],m*field[1])
ya=transpose(xa)

r=sqrt((xa-xch-.5)^2+(ya-ych-.5)^2)

www=where(r lt w)
wwx=where(abs(xa(*,0)-xch) lt w+1.)  &  wwy=where(abs(ya(0,*)-ych) lt w+1.)
wwx1=where(wwx mod 50 eq 0,nx1)  &  wwy1=where(wwy mod 50 eq 0,ny1)

intflux=total(fm(www))
wf=www(where(1-finite(vm(www),/NaN)))
meanvel=total(vm(wf)*fm(wf))/total(fm(wf))
dvel=stdev(vm(wf)-meanvel)
intflux=intflux/m^2

fm1=fm(min(wwx):max(wwx),min(wwy):max(wwy))
f0=bormed(fm1)
fm1=fm1-f0
f2=dblarr(nx1,ny1)
fit2d_2=dblarr(nx1,ny1)
for k=0,nx1-1 do f2(k,*)=fm1(wwx1[k],wwy1)

intflux=total(fm(www)-f0)/m^2
fit2d=gauss2dfit(fm1/intflux,g,/tilt)  
for k=0,nx1-1 do fit2d_2(k,*)=fit2d(wwx1[k],wwy1)

; df=sqrt(total((fm1-fit2d*intflux)^2))/sqrt((double(n_elements(fm1))*double(n_elements(fm1)-1)))
df=sqrt(total((interpolate(fm1/intflux-fit2d,wwx1,wwy1,/grid))^2))*intflux/sqrt(nx1*ny1)
r1=r(min(wwx):max(wwx),min(wwy):max(wwy))
x0=2.  &  y0=2. &  lx=10.  &  ly=10.
xc=g[4]/m+double(min(wwx))/m-.5
yc=g[5]/m+double(min(wwy))/m-.5

set_plot,'ps'
 device,filename=wdir+'objinfo.ps',xsize=x0+lx+2.,ysize=y0+ly+2.
  tvscl,-fm1,x0,y0,xsize=lx,ysize=ly,/cent
  plotsym,0,4,color=-1
  plots,(x0+lx/2.+.5)/(x0+lx+2.),(y0+ly/2.+.5)/(y0+ly+2.),symsize=1.,thick=3.,/norm,color=-1,psym=8
  plots,(x0+lx/2.+.5+(xc-xch))/(x0+lx+2.),(y0+ly/2.+.5+(yc-ych))/(y0+ly+2.),symsize=1.,thick=3.,/norm,color=-1,psym=2
 device,/close
set_plot,'x'

if abs(xc-xch) gt 2.*w then xc=total(xa*(fm(www)-f0)/(intflux*m^2))
if abs(yc-ych) gt 2.*w then yc=total(ya*(fm(www)-f0)/(intflux*m^2))

fwhm_to_psf=sqrt(.5*g[2]^2+.5*g[3]^2-0.*m^2)/m
dc=(sqrt(g[2]^2+g[3]^2)/m)*(df/intflux)
rch=sqrt((xc-xch)^2+(yc-ych)^2)
dra=-(xc-xch)*cos(posar)+(yc-ych)*sin(posar)
ddec=(xc-xch)*sin(posar)+(yc-ych)*cos(posar)

message,' object on '+strtrim(string(line),2)+string("305B)+': ',/cont
message,'  - integral flux: ('+strtrim(string(intflux,format='(E14.4)'),2)+'+/-'+strtrim(string(df,format='(E14.2)'),2)+') '+uni,/cont 
message,'  - center coords: !4Da!3 = '+strtrim(string(dra,format='(F6.3)'),2)+', !4Dd!3 = '+$
      strtrim(string(ddec,format='(F6.3)'),2),/cont 
message,'distance from Chandra coords = '+strtrim(string(rch,format='(F6.3)')),/cont
message,'estimated coordinates uncertainty '+strtrim(string(dc,format='(F5.3)'),2),/cont
message,'mean line velosity '+strtrim(string(meanvel),2)+'+/-'+strtrim(string(dvel),2)+'km/s',/cont
message,'object size: '+strtrim(string(fwhm_to_psf),2),/cont
close,1
openw,1,wdir+strtrim(string(line),2)+'_pars.txt'
  printf,1,' object on '+strtrim(string(line),2)+string("305B)+': ' 
  printf,1,'  - integral flux: ('+strtrim(string(intflux,format='(E14.5)'),2)+'+/-'+strtrim(string(df,format='(E14.2)'),2)+') '+uni
  printf,1,'  - center coords: x_c = '+strtrim(string(xc-xch,format='(F6.3)'))+', y_c = '+strtrim(string(yc-ych,format='(F6.3)'))
  printf,1,'distance from Chandra coords = '+strtrim(string(rch,format='(F6.3)'))
  printf,1,'estimated coordinates uncertainty '+strtrim(string(dc,format='(F5.3)'),2)
  printf,1,'mean line velosity '+strtrim(string(meanvel,format='(F10.1)'),2)+'+/-'+strtrim(string(dvel,format='(F10.1)'),2)+'km/s'
close,1
alpha=dra  &  delta=ddec  &  dalpha=dc  &  ddelta=dc
end
