function OUT_WAVE,FILELOG
;+
; NAME:
;	 OUT_WAVE
; PURPOSE:
;	read parameter of linerisation from LOG observation
; DESCRIPTION:
;
; CALLING SEQUENCE:
;	Result=OUT_WAVE(FILELOG)
;
; CATEGORY:
;	reduction MPFS-data
;
; INPUTS:
;	LOGFILE = file name of LOG observation (in format FITS-header)
;
;
; OUTPUTS:
;	Result = 2 elements float point array  contain beginning wavelength in A,
;		dispersion in A/px and number elements in linearised spectra
;
; OPTIONAL OUTPUT:
;	no
;
; OPTIONAL INPUT KEYWORDS:
;	no
;
; RESTRICTIONS:
;	no
;
; NOTES:
;	no
;
; PROCEDURES USED:
;	SXPAR
;
; MODIFICATION HISTORY:
;       Written by Victor Afanasiev, Special Astrophysical Observatory RAS, Jul 1999
;-

openr,UNIT,FILELOG,/GET_LUN
a=' '
readf,UNIT,a
TABLE=a
WHILE NOT EOF(UNIT) do begin
  readf,UNIT,a
  TABLE=[TABLE,a]
ENDWHILE
close,UNIT
FREE_LUN, UNIT
RESULT=sxpar(TABLE,'OUT_WAVE')
RESULT1=STR_SEP(result,',')

a=size(result1)

;
IF a(1) EQ 1 THEN RESULT=0 ELSE RESULT=FLOAT(result1)

RETURN,RESULT
END
