function par_line,vector,param,FWHM,line
;+
; NAME:
;	PAR_LINE
; PURPOSE:
;	calculation  parameter of  line in nigth sky spectrum
; DESCRIPTION: 
;	
; CALLING SEQUENCE:
;	Result = PAR_LINE ( vector,param,FWHM,line)
; CATEGORY:
;	reduction MPFS-data		
;
;INPUTS :
;	vector		input vector spectra
;	param=[lambda_0,d_lambda] beginnig wavelength(A) end dispersion(A/px)
;	FWHM	    	previus value width lines in px
;	line		wavelength line in A
; OUTPUTS:
;	Result =[flux,position(in px),FWHM(in px)] 
;		
; OPTIONAL OUTPUT:
;	no
;
; OPTIONAL INPUT KEYWORDS:
;	no	
;
; RESTRICTIONS:
;	no
;
; NOTES:
;	no
;
; PROCEDURES USED:
;	ROBOMEAN
;
; MODIFICATION HISTORY:
;       Written by Victor Afanasiev, Special Astrophysical Observatory RAS, Jul 1999
;-

a=size(vector)
N=a(1)
pos_line=fix((line-param(0))/param(1))

W=FWHM
thresh_sig=1
max_line=max(vector(pos_line-2*w:pos_line+2*w),pos_max)
pos_line=pos_max+pos_line-w

x=findgen(N)
robomean,vector(pos_line-w*10:pos_line+w*10),thresh_sig,0.5,mean,avgdev,sigma
flux=total(vector(pos_line-2*w:pos_line+2*w)-mean)
pos_line=total((vector(pos_line-2*w:pos_line+2*w)-mean)*x(pos_line-2*w:pos_line+2*w))/flux
width=total((vector(pos_line-2*w:pos_line+2*w)-mean)*(x(pos_line-2*w:pos_line+2*w)-pos_line)^2)/flux
width=2.35*sqrt(width)
return,[flux,pos_line,width]
end
