pro prinfo_2comp,wdir
  field=[16,16]
  file=wdir+'5007_fit0.FTS'
  file1=wdir+'5007_fit1.FTS'
  filef1=wdir+'5007_F0.FTS'
  filef2=wdir+'5007_F1.FTS'
  filev1=wdir+'5007_V0.FTS'
  filev2=wdir+'5007_V1.FTS'

  data=readfits(file,hi)  &  data1=readfits(file1,hi1)
  a=size(data)  &  a1=size(data1)
  cube=reform(data,a[1],field[0],field[1])
  cube1=reform(data1,a1[1],field[0],field[1])
  flux_map=readfits(filef1,hf)/readfits(filef2,hf)
  flux_map=med_ext2(rotate(flux_map,7),3)
  vel1=readfits(filev1,hf)  &  vel2=readfits(filev2,hf)

ra0=sxpar(hi,'RA') & dec0=sxpar(hi,'DEC')
ra='20 35 0.75'  &  dec='+60 11 30.9'
posar=sxpar(hi,'POSANG')*!DPI/180.

xch=-(ratos(ra)-ratos(ra0))*cos(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*sin(posar)+double(field[0])/2.
ych=(ratos(ra)-ratos(ra0))*sin(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*cos(posar)+double(field[1])/2.

print,xch,ych

cubem=cube
cubem1=cube1
for k=0,a[1]-1 do cubem(k,*,*)=med_ext2(reform(cube(k,*,*)),3)
for k=0,a[1]-1 do cubem1(k,*,*)=med_ext2(reform(cube1(k,*,*)),3)
yr=[0.,max(cubem+cubem1)]*2.
  y1=2  &  y2=7  &  x1=5  &  x2=10
 s=2
  x=x1+indgen(x2-x1)  &  y=y1+indgen(y2-y1)
  
  v=dindgen(a[1])*sxpar(hi,'CDELT1')+sxpar(hi,'CRVAL1')
  v1=dindgen(a1[1])*sxpar(hi1,'CDELT1')+sxpar(hi1,'CRVAL1')
;  window,ysize=(y2-y1+2)*s,xsize=(x2-x1+2)*s

; getrot,hhst,rothst,sc
; sc=sc*3600.    ; arcsecs / pixel
; cx_hst=((x2-x1)*.5)*s  &  cy_hst=((y2-y1)*.5+2.02)*s
; hsta=size(hstim)
; lx=sc[0]*hsta[1]*s  &  ly=sc[1]*hsta[2]*s
; hstim=rot1(hstim,rothst+posar*!RADEG,/int)
; lx=sc[0]*max(hsta(1:2))*s  &  ly=sc[1]*max(hsta(1:2))*s

set_plot,'ps'
device,filename=wdir+'prinfo_2comp.ps',ysize=(y2-y1+3.5)*s,xsize=(x2-x1+3)*s,/color
 loadct,0
 ; contour,flux_map,pos=[1.,1.,x2-x1+2.,y2-y1+2.],/device,/fill
  x=x1+indgen(x2-x1+2)  &  y=y1+indgen(y2-y1+2)
 contour,flux_map(x1:x2+1,y1:y2+1),x,y,/device,pos=[1.,1.,x2-x1+2.,y2-y1+2.]*s*1000,xst=5,yst=5,xrange=[x1-.5,x2+.5],$
      yrange=[y1-.5,y2+.5],chars=1.,charth=2.,/down,levels=dindgen(6)*.1+.4,c_annotation=strtrim(string(dindgen(6)*.1+.4,format='(F5.3)'),2)
  for x=x1,x2 do begin
    for y=y1,y2 do begin
      pr=reform(cube(*,x,field[1]-y-1))
      pr1=reform(cube1(*,x,field[1]-y-1))
     ; if x gt x1 then yticks=1 else yticks=5
     ; if y gt y1 then xticks=1 else xticks=5
     plot,v1,pr1*1.e+15,pos=[x-x1+1.,y-y1+1.,x-x1+2.,y-y1+2.]*s*1000,/device,yrange=yr*1.e+15,xst=5,yst=5,/noer,$
        color=1,thick=2.,xrange=[-1500.,1500.]  ;,/ylog
loadct,0
     oplot,v,pr*1.e+15,thick=2.,color=100 ;,linestyle=3
    ;  xticks=xticks,yticks=yticks
loadct,0     
     oplot,v*10.,v*0.,thick=.5
     oplot,pr*0.-1500.,dindgen(n_elements(pr))*10.-5.,thick=.5
     oplot,v*10.,v*0.+max(yr),thick=.5
     oplot,pr*0.+1500.,dindgen(n_elements(pr))*10.-5.,thick=.5

;     xyouts,-1000.,5.e-16,strtrim(string(vel1[x,field[1]-y-1],format='(F8.2)'),2),/data,charsize=.5
;     xyouts,-1000.,4.e-16,strtrim(string(vel2[x,field[1]-y-1],format='(F8.2)'),2),/data,charsize=.5

     if x eq x1 then begin
       axis,(x-x1+1.)*s*1000,(y-y1+1.)*s*1000,/device,/noer,chars=.6,yaxis=0,$  ;ytitle='fluxes, '+uni,$
             xst=4,yst=1
     endif
     if y eq y1 then axis,(x-x1+1.)*s*1000,(y-y1+1.)*s*1000,/device,/noer,chars=.6,xaxis=0,xrange=[-1500.,1500.],xst=1,$
          xtickv=[-1000.,0.,1000.],xtickname=['-1.0','','1.0'],xticks=3,yst=4  ;,xtitle='v, 10!A3!N !Ukm!N/!Ds'
;      print,x,y
    endfor
  endfor
  x=x1+indgen(x2-x1+2)  &  y=y1+indgen(y2-y1+2)
;fl=rotate(fl,7)
 contour,vel1(x1:x2+1,y1:y2+1),x,y,/noer,/device,pos=[1.,1.,x2-x1+2.,y2-y1+2.]*s*1000,xst=5,yst=5,xrange=[x1-.5,x2+.5],$
      yrange=[y1-.5,y2+.5],chars=1.,c_linestyle=2,levels=dindgen(20)*20.-160.,/nodata
; contour,vel2(x1:x2+1,y1:y2+1),x,y,/noer,/device,pos=[1.,1.,x2-x1+2.,y2-y1+2.]*s*1000,xst=5,yst=5,xrange=[x1-.5,x2+.5],$
 ;     yrange=[y1-.5,y2+.5],chars=1.,c_linestyle=3,levels=dindgen(20)*20.-60.

 plotsym,0,4,color=1,thick=3.
 plots,xch,ych,psym=8,/data,color=1,symsize=2.
axis,1000*s*(x2-x1+2.),1000.*s*(y2-y1+2.),yaxis=1,/device,yst=1,yticklen=0,xrange=[x1-.5,x2+.5],yrange=[y1-.5,y2+.5],chars=1.
axis,1000.*s*(x2-x1+2.),1000.*s*(y2-y1+2.),xaxis=1,/device,xst=1,xticklen=0,xrange=[x1-.5,x2+.5],yrange=[y1-.5,y2+.5],chars=1.

xyouts,(x1+x2)/2.-.5,y1-1.,'v, 10!U3!Nkm/s',/data,charsize=1.2,charthick=2.
xyouts,x1-1.,(y1+y2)/2.-1.,'Flux, 10!U-15!N erg/cm!U2!Ns'+string("305B),/data,charsize=1.2,charthick=2.,orie=90

device,/close
set_plot,'x'
end
