pro prinfo_col,wdir
  field=[16,16]
  file=wdir+'4686_cube.FTS'
  file1=wdir+'5007_cube.FTS'
  hst_file='/data3/MPFS_res/mf16/karty/bhst2.fts'
  data=readfits(file,hi)
  data1=readfits(file1,hi)
  hstim=readfits(hst_file,hhst)
  fl=readfits(wdir+'4686_F.FTS',hf)
  fl=smooth(med_ext2(fl,3),3)
    uni=sxpar(hi,'BUNIT')
  a=size(data)  &  a1=size(data1)
  cube=reform(data,a[1],field[0],field[1])*1.e+15
  cube1=reform(data1,a1[1],field[0],field[1])*5.e+13

ra0=sxpar(hi,'RA') & dec0=sxpar(hi,'DEC')
ra='20 35 0.737'  &  dec='+60 11 30.83'
posar=sxpar(hi,'POSANG')*!DPI/180.

xch=-(ratos(ra)-ratos(ra0))*cos(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*sin(posar)+double(field[0])/2.
ych=(ratos(ra)-ratos(ra0))*sin(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*cos(posar)+double(field[1])/2.

cubem=cube
for k=0,a[1]-1 do cubem(k,*,*)=med_ext2(reform(cube(k,*,*)),5)
yr=[0.,max(cubem)]*2.5  
  y1=2  &  y2=7  &  x1=5  &  x2=10
 s=2
  x=x1+indgen(x2-x1)  &  y=y1+indgen(y2-y1)
  
  v=dindgen(a[1])*sxpar(hi,'CDELT1')+sxpar(hi,'CRVAL1')
;  window,ysize=(y2-y1+2)*s,xsize=(x2-x1+2)*s
wv=where(v gt -1500. and v lt 1500.)

getrot,hhst,rothst,sc
sc=sc*3600.    ; arcsecs / pixel
cx_hst=((x2-x1)*.5+2.15)*s  &  cy_hst=((y2-y1)*.5+1.65)*s
hsta=size(hstim)
lx=sc[0]*hsta[1]*s  &  ly=sc[1]*hsta[2]*s
hstim=rot1(hstim,rothst+posar*!RADEG,/int)
; lx=sc[0]*max(hsta(1:2))*s  &  ly=sc[1]*max(hsta(1:2))*s

set_plot,'ps'
device,filename=wdir+'prinfo_col.ps',ysize=(y2-y1+3.5)*s,xsize=(x2-x1+3)*s,/color
 loadct,3,/sil
  tv,replicate(255,10,10),0,0,xsize=100,ysize=100,/centim
  tvscl,-alog(hstim+median(hstim)>median(hstim)*3.),cx_hst-lx/2.,cy_hst-ly/2.,xsize=lx,ysize=ly,/centim
  for x=x1,x2 do begin
    for y=y1,y2 do begin
      pr=reform(cube(*,x,field[1]-y-1))
      pr1=reform(cube1(*,x,field[1]-y-1))
     ; if x gt x1 then yticks=1 else yticks=5
     ; if y gt y1 then xticks=1 else xticks=5
loadct,0,/sil    
     plot,v(wv),pr(wv),pos=[x-x1+1.,y-y1+1.,x-x1+2.,y-y1+2.]*s*1000,/device,yrange=yr,xst=5,yst=5,/noer,thick=2.
loadct,27,/sil
     oplot,v(wv),pr1(wv),thick=2.,linestyle=0,color=4
    ;  xticks=xticks,yticks=yticks
loadct,0,/sil
     oplot,v*10.,v*0.,thick=.5
     oplot,pr*0.+min(v(wv)),dindgen(n_elements(pr))*10.-5.,thick=.5
     oplot,v*10.,v*0.+max(yr),thick=.5
     oplot,pr*0.+max(v(wv)),dindgen(n_elements(pr))*10.-5.,thick=.5
     if x eq x1 then begin
       axis,(x-x1+1.)*s*1000,(y-y1+1.)*s*1000,/device,/noer,chars=.5,yaxis=0,$  ;ytitle='fluxes, '+uni,$
             ytickv=dindgen(4)*.5,yticks=4,xst=4
     endif
     if y eq y1 then axis,(x-x1+1.)*s*1000,(y-y1+1.)*s*1000,/device,/noer,chars=.5,xaxis=0,xrange=round([min(v(wv)),max(v(wv))]),$
          xtickv=[-1000.,0.,1000.],xtickname=['-1.0','','1.0'],xticks=3,yst=4  ;,xtitle='v, 10!A3!N !Ukm!N/!Ds'
;      print,x,y
    endfor
  endfor
  x=x1+indgen(x2-x1+2)  &  y=y1+indgen(y2-y1+2)
fl=rotate(fl,7)
 loadct,3,/sil
 contour,fl(x1:x2+1,y1:y2+1),x,y,/noer,/device,pos=[1.,1.,x2-x1+2.,y2-y1+2.]*s*1000,xst=5,yst=5,xrange=[x1-.5,x2+.5],$
      yrange=[y1-.5,y2+.5],chars=1.,c_linestyle=2,/nodata
; plotsym,0,4,color=1,thick=3.
; plots,xch,ych,psym=8,/data,color=1,symsize=2.
 axis,1000*s*(x2-x1+2.),1000.*s*(y2-y1+2.),yaxis=1,/device,yst=1,yticklen=0,xrange=[x1-.5,x2+.5],yrange=[y1-.5,y2+.5],chars=1.
 axis,1000.*s*(x2-x1+2.),1000.*s*(y2-y1+2.),xaxis=1,/device,xst=1,xticklen=0,xrange=[x1-.5,x2+.5],yrange=[y1-.5,y2+.5],chars=1.

device,/close
set_plot,'x'
end
