function read_log,logfile,par
;+
; NAME:
;	DEF_WDIR
; PURPOSE:
;	extracts a keyword value from a logfile (file with 'fits header-like' structure)
; DESCRIPTION: 
;	
; CALLING SEQUENCE:
;	Result=read_log(FILELOG)
;
; CATEGORY:
;	reduction MPFS-data		
;
; INPUTS:
;	LOGFILE = file name of LOG observation (in format FITS-header)
;	
;
; OUTPUTS:
;	Result = string scalar name directory for writing
;		
; OPTIONAL OUTPUT:
;	no
;
; OPTIONAL INPUT KEYWORDS:
;	no	
;
; RESTRICTIONS:
;	no
;
; NOTES:
;	no
;
; PROCEDURES USED:
;	SXPAR
;
; MODIFICATION HISTORY:
;       Written by  P. Abolmasov as a trivial generalization of  
;       Victor Afanasiev's procedures, Special Astrophysical Observatory RAS, Jul 1999
;-

on_error,2

openr,UNIT,logfile,/GET_LUN
a=' '
readf,UNIT,a
TABLE=a
WHILE NOT EOF(UNIT) do begin
readf,UNIT,a
TABLE=[TABLE,a]
ENDWHILE
close,UNIT
FREE_LUN, UNIT
RESULT=sxpar(TABLE,par)
RETURN,RESULT
END
