pro setcoord,infile,alpha,delta,w=w,lambda=lambda,gau=gau
   if not(keyword_set(w)) then w=3.
   if not(keyword_set(lambda)) then lambda=6562.82
   if not(keyword_set(field)) then field=[16,16]

wl=50.
   datar=readfits(infile,h)
   a=size(datar)
   posang=sxpar(h,'POSANG')  ;*!DPI/180.
   l0=sxpar(h,'CRVAL1')
   dl=sxpar(h,'CDELT1')
   l=dindgen(a[1])*dl+l0
   cube=reform(datar,a[1],field[0],field[1])   
   a=size(cube)

slice0=rebin(rotate(total(cube(where(abs(l-lambda) le wl),*,*),1),7),30*field[0],30*field[1])

wkiller
window,/free,xsize=30*field[0],ysize=30*field[1]
tvscl,slice0,0.,0.,xsize=30*field[0],ysize=30*field[1]
drawne,.8,.8,posang,r=.05
posang=posang*!DPI/180.

x=double(0)  &  y=double(0)

    ret:
     cursor,x,y,4,/device
     m=!MOUSE
     sw=long(m.button)                                         ; mouse click-type  
  
     if sw eq 0 then goto,ret
     if sw eq 1 then begin
       c=[x,y]
       message,'got it! '+strcompress(string(double(c[0])/30.)+string(double(c[1])/30.)),/cont   
       goto,ret
     endif

if sw eq 2 then message,'coordinate determination interrupted'

x0=double(c[0])/30. & y0=double(c[1])/30.

xa=rebin(dindgen(a[3]),a[2],a[3],/sample)
ya=transpose(xa)

;x0=x0/30.  &  y0=(y0/30.)
r=sqrt((xa-x0)^2+(ya-y0)^2)

map=total(cube(where(abs(l-lambda) le wl),*,*),1)
map=rotate(map-median(map(where(r gt w))),7)
; map=map*(r le w)
map_xproj=total(map,2)  &  map_yproj=total(map,1)
map_xint=interpol(map_xproj,dindgen(field[0]),dindgen(field[0]*10)*.1,/spline)
map_yint=interpol(map_yproj,dindgen(field[1]),dindgen(field[1]*10)*.1,/spline)
totx=total(map_xint)  &  toty=total(map_yint)

xx=dindgen(field[0]*10)*.1 &  yy=dindgen(field[1]*10)*.1
;xx1=xx(fix((x0-w)*10)>0:fix((x0+w)*10)<10*field[0]-1)
;map_xint1=map_xint(fix((x0-w)*10)>0:fix((x0+w)*10)<10*field[0]-1)/median(map_xint)
;yy1=yy(fix((y0-w)*10)>0:fix((y0+w)*10)<10*field[0]-1)
;map_yint1=map_yint(fix((y0-w)*10)>0:fix((y0+w)*10)<10*field[0]-1)/median(map_yint)

if keyword_set(gau) then begin
  map1=rebin(map,field[0]*50,field[1]*50)
  
  wwx=where(abs(dindgen(field[0]*50)/50.-x0) lt 4.)
  wwy=where(abs(dindgen(field[1]*50)/50.-y0) lt 4.)

  map1=map1(min(wwx):max(wwx),min(wwy):max(wwy))
  fit2d=gauss2dfit(map1/max(map1),g2)
  x=(double(min(wwx))+g2[4])/50.
  y=(double(min(wwy))+g2[5])/50.
endif

ra=double(ratos(alpha))
decl=double(detos(delta))
ra=ra

if not(keyword_set(gau)) then begin
  x=x0
  y=y0
endif

ra0=ra+((x-double(field[0])/2.)*cos(posang)-(y-double(field[1])/2.)*sin(posang))/cos(decl/206265.)
decl0=decl-(x-double(field[0])/2.)*sin(posang)-(y-double(field[1])/2.)*cos(posang)

alpha0=ratos(ra0,/inv)
delta0=detos(decl0,/inv)

message,'coordinates of the frame center : '+alpha0+'  '+delta0,/cont
inp=''
read,inp,prompt='agree(y/n)'
if inp eq 'y' then begin
  sxaddpar,h,'RA',strjoin(string(alpha0),' ')
  sxaddpar,h,'DEC',strjoin(string(delta0),' ')
  writefits,infile,datar,h
endif

end
