pro sulfrac,wdir,colt=colt
  file1=wdir+'6717_F.FTS'  &  file2=wdir+'6731_F.FTS'
if not(keyword_set(colt)) then  colt=0
  field=[16,16]
  ima2=rotate(readfits(file2,h2),7)
  ima1=rotate(readfits(file1,h1),7)

  posang=sxpar(h1,'POSANG')

  x=rebin(dindgen(field[0]),field[0],field[1])
  y=transpose(x)

 w1=where(x gt 4 and x lt field[0]-2 and y lt field[0]-2 and y gt 1)
  x1=x(w1)
  y1=y(w1)

ima1=smooth(med_ext2(ima1,3),3)
ima2=smooth(med_ext2(ima2,3),3)

fr=ima1/ima2
; fr(where(ima2 le 2.e-17 or x le 2 or y le 0))=.6
; fr(0,*)=fr(1,*)
; fr[2,5]=fr[3,5]
fr1=fr(w1)
  lev_frac=dindgen(200)*.005+.5
  lev_frac1=[.8,.9,1.,1.05,1.1,1.2,1.4]

  set_plot,'x'
;  xloadct

  contour,fr,x,y,levels=lev_frac,xst=1,yst=1,/fill,yrange=[min(y),max(y)] ;,/irr

;  drawne,.8,.8,posang,r=.1
  posar=posang*!DPI/180.

ra0=sxpar(h1,'RA') & dec0=sxpar(h1,'DEC')
ra='20 35 0.75'  &  dec='+60 11 30.9'

xch=-(ratos(ra)-ratos(ra0))*cos(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*sin(posar)+double(field[0])/2.
ych=(ratos(ra)-ratos(ra0))*sin(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*cos(posar)+double(field[1])/2.
   plotsym,0,4,color=-1
   plots,xch,ych,psym=8,/data,color=-1,symsize=1.
post=[3.,3.,3.+field[0],3.+field[1]]*1000.

set_plot,'ps'
device,filename=wdir+'sulfrac.ps',xsize=5.+field[0],ysize=5.+field[1],/color
 loadct,colt
    contour,fr,x,y,levels=lev_frac,/cell_fill,xst=5,yst=5,pos=post,/dev,$  ;/irr,$
              xrange=[min(x),max(x)],yrange=[min(y),max(y)]
        ;  title='[S II] 6717 / 6731 3X3 smoothed',yrange=[max(y),min(y)]     
loadct,0
    contour,-fr,x,y,levels=reverse(-lev_frac),/fill,xst=1,yst=1,pos=post,/dev,$
          xrange=[min(x),max(x)],yrange=[min(y),max(y)],/nodata,/noer,charsize=2.5,charthick=3.

    contour,fr1,x1,y1,levels=lev_frac1,/downhill,/overplot,c_annotation=strtrim(string(lev_frac1,format='(F6.3)'),2),$
         min_value=.8,c_charsize=1.5,c_charthick=3.,/irr ;,yrange=[max(y),min(y)]
;  drawne,.85,.8,posang,r=.1   
   plotsym,0,4,color=-1,thick=5.
   plots,xch,ych,psym=8,/data,color=-1,symsize=1.

device,/close
set_plot,'x'

writefits,wdir+'sulfrac.fts',fr,h1

; *** n_e inference ***

n_e=reform(sulf_to_ne(fr),field[0],field[1])
n_e1=sulf_to_ne(fr1)
; n_e=med_xy(n_e,3)
ne_frac=sulf_to_ne(lev_frac)
ne_frac1=sulf_to_ne(lev_frac1)

n_e(where(1-(n_e ge 0.)))=1.
ne_frac=10^(.05*dindgen(200)-0.5)
ne_frac1=[1.,10.,100.,300.,500.,700.,1.e3,3.e3]

n_e=n_e<60000.

set_plot,'ps'
device,filename=wdir+'n_e.ps',xsize=5.+field[0],ysize=5.+field[1],/color
 loadct,colt
    contour,-n_e,x,y,levels=reverse(-ne_frac),/cell_fill,xst=5,yst=5,pos=post,/dev,$  ;/irr,$
              xrange=[min(x),max(x)],yrange=[min(y),max(y)]
        ;  title='[S II] 6717 / 6731 3X3 smoothed',yrange=[max(y),min(y)]     
loadct,0
    contour,-n_e,x,y,levels=reverse(-ne_frac),/fill,xst=1,yst=1,pos=post,/dev,$
          xrange=[min(x),max(x)],yrange=[min(y),max(y)],/nodata,/noer,charsize=2.5,charthick=3.

    contour,n_e1,x1,y1,levels=ne_frac1,/downhill,/overplot,c_annotation=strtrim(string(ne_frac1,format='(I10)'),2),$
         min_value=10.,c_charsize=1.5,c_charthick=3.,/irr,c_thick=3. ;,yrange=[max(y),min(y)],c_thick=2.
  ; drawne,.85,.75,posang,r=.1   
   plotsym,0,4,color=-1,thick=10.
   plots,xch,ych,psym=8,/data,color=-1,symsize=1.
device,/close
set_plot,'x'


end
