pro temp_ni2,wdir,colt=colt
  file1=wdir+'6584_F.FTS'  &  file2=wdir+'5755_F.FTS'
  if not(keyword_set(colt)) then  colt=0
  field=[16,16]
  ima2=rotate(readfits(file2,h2),7)
  ima1=rotate(readfits(file1,h1),7)*4./3.

  posang=sxpar(h1,'POSANG')

  x=rebin(dindgen(field[0]),field[0],field[1])
  y=transpose(x)

;ima1=smooth(med_ext2(ima1,3),3)
;;ima2=smooth(med_ext2(ima2,3),3)

fr=med_xy(ima1/ima2,3)
fr2=med_xy(fr,5)

  lev_frac1=[20.,40.,50.,60.,200.]
  lev_frac=rebin(lev_frac1,n_elements(lev_frac1)*5)
lev_frac=lev_frac(uniq(lev_frac))
  lev_frac1=[30.,50.,70.,90.,110.]
  set_plot,'x'
;  xloadct
w1=where(finite(fr))
  x1=x(w1)
  y1=y(w1)

fr1=fr(w1)


  contour,-fr,x,y,levels=reverse(-lev_frac),xst=1,yst=1,/fill,yrange=[min(y),max(y)] ;,/irr

;  drawne,.8,.8,posang,r=.1
  posar=posang*!DPI/180.

ra0=sxpar(h1,'RA') & dec0=sxpar(h1,'DEC')
ra='20 35 0.75'  &  dec='+60 11 30.9'

xch=-(ratos(ra)-ratos(ra0))*cos(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*sin(posar)+double(field[0])/2.
ych=(ratos(ra)-ratos(ra0))*sin(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*cos(posar)+double(field[1])/2.
   plotsym,0,4,color=-1
   plots,xch,ych,psym=8,/data,color=-1,symsize=1.
post=[3.,3.,3.+field[0],3.+field[1]]*1000.

set_plot,'ps'
device,filename=wdir+'ni2frac.ps',xsize=5.+field[0],ysize=5.+field[1],/color
 loadct,colt
    contour,-fr1,x1,y1,levels=reverse(-lev_frac),xst=1,yst=1,pos=post,/dev,/fill,$
              xrange=[min(x)-0.5,max(x)+0.5],yrange=[min(y)-0.5,max(y)+0.5],/irr
loadct,0
 ;   contour,-fr,x,y,levels=reverse(-lev_frac),/fill,xst=1,yst=1,pos=post,/dev,$
 ;         xrange=[min(x),max(x)],yrange=[min(y),max(y)],/nodata,/noer,charsize=2.5,charthick=3.

    contour,fr1,x1,y1,levels=lev_frac1,/downhill,/overplot,c_annotation=strtrim(string(lev_frac1,format='(F8.3)'),2),$
         min_value=.8,c_charsize=1.5,c_charthick=3.,/irr ;,yrange=[max(y),min(y)]
  drawne,.85,.8,posang,r=.1   
   plotsym,0,4,color=-1,thick=5.
   plots,xch,ych,psym=8,/data,color=-1,symsize=1.

device,/close
set_plot,'x'

writefits,wdir+'ni2frac.fts',fr,h1

; *** n_e inference ***
n_e=100.

; temp1=1.e4
; temp=2.5e4/alog(fr*(1.+2.7e-3*n_e/sqrt(temp1))/7.53)
; for q=0,10 do temp=2.5e4/alog(fr*(1.+2.7e-3*n_e/sqrt(temp))/7.53)

temp=ni_to_temp(fr)

temp=reform(temp,field[0],field[1])
; temp2=smooth(med_xy(temp,5),5)
; temp(where(1-finite(temp)))=temp2(where(1-finite(temp)))
w1=where(temp gt 0. and finite(temp))
temp1=temp(w1)  &  x1=x(w1)  &  y1=y(w1)

temp_frac1=[1000.,8000.,9000.,10000.,15000.]
;temp_frac=rebin(temp_frac1,n_elements(temp_frac1)*10)
;temp_frac=temp_frac(uniq(temp_frac))
temp_frac=[1000.,5000.,8000.,10000.,10500.,11000.,12000.,13000.,15000.,20000.]

; temp=temp < 1.e5

temp2=med_xy(temp,3)
temp(where(1-finite(temp)))=temp2(where(1-finite(temp)))
temp=temp < 1.e5
temp=temp > 0.
temp1=temp1 < 1.e5
temp1=temp1 > 0.

set_plot,'ps'
device,filename=wdir+'temp_ni2.ps',xsize=5.+field[0],ysize=5.+field[1],/color
 loadct,colt
   ; contour,temp1,x1,y1,levels=temp_frac,xst=5,yst=5,pos=post,/dev,/fill,/irr,$
   ;           xrange=[min(x)-0.5,max(x)+0.5],yrange=[min(y)-0.5,max(y)+0.5]

loadct,0
    contour,temp1,x1,y1,/fill,xst=1,yst=1,pos=post,/dev,levels=temp_frac,/irr,$
          xrange=[min(x)-0.5,max(x)+0.5],yrange=[min(y)-0.5,max(y)+0.5],charsize=2.5,charthick=3.

    contour,temp1,x1,y1,levels=temp_frac1,/downhill,/overplot,c_annotation=strtrim(string(temp_frac1,format='(I10)'),2),$
         c_charsize=1.5,c_charthick=3.,/irr,c_thick=3. ;,yrange=[max(y),min(y)],c_thick=2.
;   contour1,temp1,x1,y1,temp_frac1,post
 ;  drawne,.9,.75,posang,r=.1   
   plotsym,0,4,color=-1,thick=10.
   plots,xch,ych,psym=8,/data,color=-1,symsize=1.
device,/close
set_plot,'x'

writefits,wdir+'temp_ni2.fts',temp,h1

end
