pro temp_o3,wdir,colt=colt
  file1=wdir+'oxa.FTS'  &  file2=wdir+'4364_F.FTS'
if not(keyword_set(colt)) then  colt=0
  field=[16,16]
  ima2=rotate(readfits(file2,h2),7)
  ima1=rotate(readfits(file1,h1),7)

  posang=sxpar(h1,'POSANG')

  x=rebin(dindgen(field[0]),field[0],field[1])
  y=transpose(x)

ima1=smooth(med_ext2(ima1,3),3)
ima2=smooth(med_ext2(ima2,3),3)

fr=ima1/ima2
fr2=smooth(fr,5)

 w1=where(fr2 ge median(fr2)*0. and ima2 gt median(ima2)*0.)
  x1=x(w1)
  y1=y(w1)


fr1=fr(w1)
  lev_frac=dindgen(100)*2.+1.
  lev_frac1=[30,40.,50.,100.,200.]

  set_plot,'x'
;  xloadct

  contour,-fr,x,y,levels=reverse(-lev_frac),xst=1,yst=1,/fill,yrange=[min(y),max(y)] ;,/irr

;  drawne,.8,.8,posang,r=.1
  posar=posang*!DPI/180.

ra0=sxpar(h1,'RA') & dec0=sxpar(h1,'DEC')
ra='20 35 0.75'  &  dec='+60 11 30.9'

xch=-(ratos(ra)-ratos(ra0))*cos(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*sin(posar)+double(field[0])/2.
ych=(ratos(ra)-ratos(ra0))*sin(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*cos(posar)+double(field[1])/2.
   plotsym,0,4,color=-1
   plots,xch,ych,psym=8,/data,color=-1,symsize=1.
post=[3.,3.,3.+field[0],3.+field[1]]*1000.

set_plot,'ps'
device,filename=wdir+'o3frac.ps',xsize=5.+field[0],ysize=5.+field[1],/color
 loadct,colt
    contour,-fr,x,y,levels=reverse(-lev_frac),/cell_fill,xst=5,yst=5,pos=post,/dev,$  ;/irr,$
              xrange=[min(x),max(x)],yrange=[min(y),max(y)]
        ;  title='[S II] 6717 / 6731 3X3 smoothed',yrange=[max(y),min(y)]     
loadct,0
    contour,-fr,x,y,levels=reverse(-lev_frac),/fill,xst=1,yst=1,pos=post,/dev,$
          xrange=[min(x),max(x)],yrange=[min(y),max(y)],/nodata,/noer,charsize=2.5,charthick=3.

    contour,fr1,x1,y1,levels=lev_frac1,/downhill,/overplot,c_annotation=strtrim(string(lev_frac1,format='(F6.3)'),2),$
         min_value=.8,c_charsize=1.5,c_charthick=3.,/irr ;,yrange=[max(y),min(y)]
;  drawne,.85,.8,posang,r=.1   
   plotsym,0,4,color=-1,thick=5.
   plots,xch,ych,psym=8,/data,color=-1,symsize=1.

device,/close
set_plot,'x'

writefits,wdir+'o3frac.fts',fr,h1

; *** n_e inference ***
n_e=100.

temp1=3.e4
temp=3.29e4/alog(fr*(1.+4.5e-4*n_e/sqrt(temp1))/8.32)
for q=0,10 do temp=3.29e4/alog(fr*(1.+4.5e-4*n_e/sqrt(temp))/8.32)

temp=reform(temp,field[0],field[1])
; temp2=smooth(med_xy(temp,5),5)
; temp(where(1-finite(temp)))=temp2(where(1-finite(temp)))
temp1=temp(w1)

temp_frac=10^(dindgen(25)*.2+3.)
temp_frac1=[1.e4,2.e4,3.e4,5.e4]

set_plot,'ps'
device,filename=wdir+'temp_o3.ps',xsize=5.+field[0],ysize=5.+field[1],/color
 loadct,colt
    contour,temp,x,y,levels=temp_frac,xst=5,yst=5,pos=post,/dev,/fill,$  ;/irr,$
              xrange=[min(x),max(x)],yrange=[min(y),max(y)]

loadct,0
    contour,-temp,x,y,levels=reverse(-temp_frac),/fill,xst=1,yst=1,pos=post,/dev,$
          xrange=[min(x),max(x)],yrange=[min(y),max(y)],/nodata,/noer,charsize=2.5,charthick=3.

    contour,temp1,x1,y1,levels=temp_frac1,/downhill,/overplot,c_annotation=strtrim(string(temp_frac1,format='(I10)'),2),$
         c_charsize=1.5,c_charthick=3.,/irr,c_thick=3. ;,yrange=[max(y),min(y)],c_thick=2.
;   contour1,temp,x,y,temp_frac1,post
   drawne,.85,.75,posang,r=.1   
   plotsym,0,4,color=-1,thick=10.
   plots,xch,ych,psym=8,/data,color=-1,symsize=1.
device,/close
set_plot,'x'

writefits,wdir+'temp_o3.fts',temp,h1

end
