pro twocont,file1,file2,dfile1,dfile2,smooth=smooth

field=[16,16]

  f1=rotate(readfits(file1,h1),7)
  f2=rotate(readfits(file2,h2),7)
  df1=rotate(readfits(dfile1,dh1),7)
  df2=rotate(readfits(dfile2,dh2),7)

  if keyword_set(smooth) then begin
    f1_1=smooth(med_xy(f1,3),3)
    f2_1=smooth(med_xy(f2,3),3)
    f1(where(f1 le f1_1+df1))=f1_1(where(f1 le f1_1+df1))
    f2(where(f2 le f2_1+df2))=f2_1(where(f2 le f2_1+df2))
  endif  
 ra='20 35 0.75'  &  dec='+60 11 30.9'

posang=sxpar(h1,'POSANG')
posar=posang*!DPI/180.
ra0=sxpar(h1,'RA') & dec0=sxpar(h1,'DEC')
xch=-(ratos(ra)-ratos(ra0))*cos(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*sin(posar)+double(field[0])/2.
ych=(ratos(ra)-ratos(ra0))*sin(posar)*cos(detos(dec0)/206265.)+(detos(dec)-detos(dec0))*cos(posar)+double(field[1])/2.

set_plot,'ps'
device,file=exdir(file1)+'twocomp.eps',xsize=20,ysize=20,/encaps,/port,xoffset=0
  contour,-f1/max(f1),levels=reverse(-[0.1,0.5,0.8,1.5,2.]),/down,/iso,xthick=2.5,chars=2.,$
charthick=3.,/fill,ythick=2.5,xrange=[4,12],yrange=[2,8],xtitle='X, arcsec',ytitle='Y, arcsec'
  contour,f2/max(f2),levels=[0.1,0.5,0.8],/down,/over,c_thick=3.
   plotsym,0,4,color=-1,thick=10.
   plots,xch,ych,psym=8,/data,symsize=1.,color=-1 
   drawne,.35,.55,posang,r=.075
device,/close
set_plot,'x'

end
