pro vall,wdir,llist,velrange,field=field
 
  c_kms=2.9979e+5  ; light velocity in km/s
  if not(keyword_set(field)) then field=[16,16]  

  cd,wdir,current=qq
  decont,'obj-sky.fts',wdir,gf,sighmas,field=field
  data=readfits(wdir+'obj-sky.fts',header)
  cont_data=readfits(wdir+'cont.fts',header)
  a=size(data)
  cube=reform(data,a[1],field[0],field[1])*sxpar(header,'GAIN')
  cube_cont=reform(cont_data,a[1],field[0],field[1])*sxpar(header,'GAIN')
  l=sxpar(header,'CRVAL1')+sxpar(header,'CDELT1')*dindgen(a[1])
  nv=ceil((max(velrange)-min(velrange))*median(l)/(c_kms*sxpar(header,'CDELT1')))  ;  number of velocity slices
  print,nv
  ; gf=[flux,dest,cenx,ceny]
  nl=n_elements(llist)
  velcubes=dblarr(field[0],field[1],nv,nl)
  velcubes_cont=dblarr(field[0],field[1],nv,nl)
  vela=min(velrange)+(max(velrange)-min(velrange))*(dindgen(nv)+.5)/double(nv)

  for i=0,nl-1 do begin
     lrange=[llist[i]*(1.+velrange[0]/c_kms),llist*(1.+velrange[1]/c_kms)]
     indline=where(l gt min(lrange) and l lt max(lrange),cind)
     linecube=dblarr(cind,field[0],field[1])
     linecube_cont=dblarr(cind,field[0],field[1])
     for p=0,cind-1 do begin
        linecube(p,*,*)=shift_image(reform(cube(indline[p],*,*)),-gf(indline[p],2)+median(gf(*,2)),-gf(indline[p],3)+median(gf(*,3)))
        linecube_cont(p,*,*)=shift_image(reform(cube_cont(indline[p],*,*)),-gf(indline[p],2)+median(gf(*,2)),-gf(indline[p],3)+median(gf(*,3)))
  ;      linecube(p,*,*)=linecube(p,*,*)-bormed(reform(linecube(p,*,*)))
  ;      linecube_cont(p,*,*)=linecube_cont(p,*,*)-bormed(reform(linecube_cont(p,*,*)))
     endfor
     linel=l(indline)
     vel=(linel-llist[i])*c_kms/llist[i]
     for j=0,field[0]-1 do for k=0,field[1]-1 do velcubes(j,k,*,i)=interpol(linecube(*,j,k),vel,vela)
     for j=0,field[0]-1 do for k=0,field[1]-1 do velcubes_cont(j,k,*,i)=interpol(linecube_cont(*,j,k),vel,vela)
  endfor  
  velcube=total(velcubes,4)
  velcube_cont=total(velcubes_cont,4)
velmap=dblarr(field[0],field[1])
widmap=dblarr(field[0],field[1])
map=total(velcube,3)
mfit=gauss2dfit(map-bormed(map),a)

for i=0,field[0]-1 do begin
  for j=0,field[1]-1 do begin
     velmap[i,j]=total(velcube(i,j,*)*vela)/total(velcube(i,j,*))
     widmap[i,j]=sqrt(total(velcube(i,j,*)*(vela-velmap[i,j])^2)/total(velcube(i,j,*)))
  endfor
endfor
velmap=med_ext2(velmap,2)*(map gt median(map))
widmap=med_ext2(widmap,2)*(map gt median(map))

  sxaddpar,header,'CRVAL1',min(velrange)+.5/double(nv)
  sxaddpar,header,'CDELT1',(max(velrange)-min(velrange))/double(nv)

  writefits,wdir+'vall.fts',velcube,header
  writefits,wdir+'vallmap.fts',velmap,header
  writefits,wdir+'widthmap.fts',widmap,header
  cd,qq
cenx=dblarr(nv)  &  ceny=dblarr(nv)
flux=dblarr(nv)  &  ston=dblarr(nv)  &  flon=dblarr(nv)
dcenx=dblarr(nv)  &  dceny=dblarr(nv)
destx=dblarr(nv)  &  desty=dblarr(nv)

for k=0,nv-1 do begin
  cenx[k]=total(total(velcube(*,*,k),2)*dindgen(field[0]))/total(velcube(*,*,k))
  ceny[k]=total(total(velcube(*,*,k),1)*dindgen(field[1]))/total(velcube(*,*,k))
  destx[k]=sqrt(total(total(velcube(*,*,k),2)*(dindgen(field[0])-cenx[k])^2)/total(velcube(*,*,k)))
  desty[k]=sqrt(total(total(velcube(*,*,k),1)*(dindgen(field[1])-ceny[k])^2)/total(velcube(*,*,k)))
  flux[k]=total(velcube(*,*,k))  &  flon[k]=total(velcube_cont(*,*,k))
  ston[k]=flux[k]/sqrt(total(velcube(*,*,k)+velcube_cont(*,*,k)))
  dcenx[k]=destx[k]/ston[k]
  dceny[k]=desty[k]/ston[k]
;  fit=gauss2dfit(velcube(*,*,k),a,/tilt)
;   cenx[k]=a[4]  & ceny[k]=a[5]
endfor

  set_plot,'ps'
    device,filename=wdir+'mean_profile.ps'
    plot,vela,total(total(velcube,2),1)
    device,/close

    device,filename=wdir+'cen_xy.ps'
    plot,vela,cenx-median(cenx)
    oplot,vela,ceny-median(ceny),linestyle=3
    oploterr,vela,cenx-median(cenx),dcenx
    oploterr,vela,ceny-median(ceny),dceny
    device,/close
  set_plot,'x'
end
