pro AF_long,infile,lar,yrange=yrange,w=w,smooth=smooth,ddv=ddv

; "analine_faint" for long-slit spectra

if not(keyword_set(ddv)) then ddv=0.

c=double(2.9979e+5)
wdir=exdir(infile)
if not(keyword_set(w)) then w=30.

data=readfits(infile,h)
z=sxpar(h,'REDSHIFT')
; z=.00015
ds=size(data)
if not(keyword_set(yrange)) then yrange=[0,ds[2]-1]
dl=sxpar(h,'CDELT1')  &  l0=sxpar(h,'CRVAL1')
dy=sxpar(h,'CDELT2')  &  y0=sxpar(h,'CRVAL2')
l=dindgen(ds[1])*dl+l0
y=dindgen(ds[2])*dy+y0

warea=where(l-(lar) ge -w and l-(lar) le w,nwe)
larea=l(warea)  &  darea=data(warea,*)
wy=where(y ge min(yrange) and y le max(yrange),ny)

flux=dblarr(ny)
vel=dblarr(ny)
cent=dblarr(ny)
fwhm=dblarr(ny)
dflux=dblarr(ny)
dvel=dblarr(ny)
dcent=dblarr(ny)
; y=indgen(ds[2])
; ny=max(yrange)-min(yrange)
; y=y(min(yrange):max(yrange)-1)
wy=where(y ge min(yrange) and y le max(yrange),ny)
y=y(wy)
y0=min(y)

darint=total(darea(*,wy),2)
if keyword_set(smooth) then darint=smooth(med_ext(darint,5),5)

for k=0,ny-1 do begin
  vec=reform(darea(*,wy[k]))
  if keyword_set(smooth) then vec=smooth(med_ext(vec,2*smooth+1),2*smooth+1)
  cont=[indgen(5),dindgen(5)+nwe-6]
  lf=goodpoly(larea(cont),vec(cont),1,3.,lfit)
  rms=stdev(lfit-vec(cont))

  plot,larea,vec,psym=2
  oplot,larea,poly(larea,lf),color=1000
  flux[k]=total(vec-poly(larea,lf))
  cent[k]=total((vec-poly(larea,lf))*larea)/flux[k]
  vel[k]=(cent[k]/lar-1.D)*c
  fwhm[k]=sqrt((total((larea-cent[k])^2*(vec-poly(larea,lf)) > 0.)/flux[k])*8.*alog(2.))
  dflux[k]=rms*fwhm[k]/dl
  dcent[k]=fwhm[k]*dflux[k]/flux[k]
  dvel[k]=(dcent[k]/lar)*c
endfor
loadct,0

sxaddpar,h,'CDELT1',dy
sxaddpar,h,'CRVAL1',min(yrange)

set_plot,'ps'
sxaddpar,h,'LINE',strtrim(string(lar,format='(F10.2)'),2),'WAVELENGTH'
  out=strtrim(string(lar,format='(I10)'),2)+'_F'
  writefits,wdir+out+'.fts',reform(flux),h
  out=strtrim(string(lar,format='(I10)'),2)+'_df'
  writefits,wdir+out+'.fts',reform(dflux),h
   out=strtrim(string(lar,format='(I10)'),2)+'_V'
  writefits,wdir+out+'.fts',reform(vel),h
   out=strtrim(string(lar,format='(I10)'),2)+'_dv'
  writefits,wdir+out+'.fts',reform(dvel),h

lof=floor(alog10(max(flux)))

out=strtrim(string(lar,format='(I10)'),2)+'_FV'
  device,filename=wdir+out+'.ps',/port,xsize=21,ysize=27,yoffset=1,xoffset=0
!p.multi=[0,1,2]

;for lk=0,nl-1 do begin
;  flux(lk,*)=smooth(med_ext(reform(flux(lk,*)),3),3)
;  vel(lk,*)=smooth(med_ext(reform(vel(lk,*)),3),3)
;endfor

    plot,y,flux*(10D)^(-lof),yrange=[0,max(darea*10.)]*(10D)^(-lof),psym=1,ytitle='flux, 10!U'+$
       strtrim(string(lof,format='(I8)'),2)+'!Nerg/cm!U2!Ns',xst=1,yst=1,charsize=2.,$
       charthick=2.5,thick=2.
    oploterr,y,flux*(10D)^(-lof),dflux*(10D)^(-lof),1

    plot,y,vel,yrange=[-300.,300.]+c*z+ddv,psym=1,ytitle='v, km/s', xtitle='y, arcsec',xst=1,yst=1,charsize=2.,$
       charthick=2.5,thick=2.
    oploterr,y,vel,dvel,1
!p.multi=0
  device,/close 
set_plot,'x'

end
