;create 2D-dispersion curve
pro create_disperse2D,LOGFILE,idl_dir,Ndeg=Ndeg,PLOT=plot,CROSS=cross,manual=manual
sg=0
if keyword_set(plot) then sg=1
if not(keyword_set(cross)) then cross=0

if not(keyword_set(Ndeg)) then Ndeg=3;!!!!!!!!!!!!!!!!! Ndeg=3
;read file neon
wdir=DEF_WDIR(LOGFILE)
neon_ima=readfits(wdir+'neon.fts',h,/silent)
s=size(neon_ima)
N=s[1]   ;N=2048	;size etalon spectra along dispersion
; N=983
dir_eta=idl_dir
;read etalon spectra
cd,idl_dir,cur=curd
spawn,'ls etalon*txt > etalist'
cd,curd
files=read_text(idl_dir+'etalist',0,1000L)
;files=strmid(files,)
files1=files
for k=0,n_elements(files)-1 do files1[k]=strmid(files[k],7,strlen(files[k])-11)
files=files1
print,files
; files=['300','300g','600','1200',$  ;'1720','2310',$
; 'VPHG400','VPHG550G','VPHG550R','VPHG1200G','VPHG1200R','VPHG1800','VPHG2300','VPHG1200B']
;  files=['651','eta651']
 Neta=N_elements(files)
 ;Neta1=0. & wn=0.
 wn=0.
 for k=0,Neta-1 do begin
 neon_tmp=readfits(dir_eta+'etalon_'+files[k]+'.fts',/silent)
 s=size(neon_tmp) 
  if s[1] eq N then  wn=[wn,k]
 endfor
 wn=wn[1:*,*]
 Neta1=n_elements(wn)
 files=files(wn)
neon=dblarr(N,Neta1)
;wdir=DEF_WDIR(LOGFILE)
for k=0,Neta1-1 do begin
 neon(*,k)=readfits(dir_eta+'etalon_'+files[k]+'.fts',/silent)
 if max(neon(*,k)) lt 0 then neon(*,k)=readfits(wdir+'etalon_'+files[k]+'.fts',/silent)
endfor
Neta=Neta1
;read file neon
;neon_ima=readfits(wdir+'neon.fts',h,/silent)
wnf=where(1-finite(neon_ima),nnf)
if nnf gt 0 then neon_ima(wnf)=0.

Nx=sxpar(h,'NAXIS1') & Ny=sxpar(h,'NAXIS2')
bin=sxpar(h,'BINNING') & bin=str_sep(bin,'x') & bin=double(bin(0))
if bin eq 0 then bin=1.
;identefication grating  and direction of dispersion
neon_vec=total(neon_ima(*,Ny/2-Ny/4:Ny/2+Ny/4),2)  ;
;create background substraction vector
x=dindgen(Nx)
fi_peak,x,neon_vec,0,ipix,xpk,ypk,bkpk,ipk
bkpk=med_ext(bkpk,5)  ;;,/edge_truncate)
fon=interpol(bkpk,xpk,x,/LSQUADRATIC)
;fon=lowess(x,fon,Nx/10,3,3)
neon_vec=neon_vec-fon
;correction size etalon spectra
neon=congrid(neon,N/bin,Neta)

;comparison observed and etalon spectra
M=100 & x_cross=dindgen(2*M+1)-M

if cross eq 1 then window,0,xsize=400,ysize=900,title='result identefication mask'
if cross eq 1 then!P.multi=[0,2,Neta]
dx=dblarr(2*Neta) & ymax=dx & rev=dx & rev(0:Neta-1)=1 & num=dx
for k=0,Neta-1 do begin
  y_cross=CROSS_NORM(neon_vec(0:(N/bin-1 < Nx-1)),reverse(neon(*,k)),M)
  y_cross=y_cross-lowess(x_cross,y_cross,2*M,3,3)
  ymax(k)=max(y_cross,Nmax)& dx(k)=x_cross(Nmax) &  num(k)=k
  if  cross eq 1 then begin
    plot,x_cross,y_cross,xst=1,yrange=[-0.2,1],yminor=2,ytickinterval=0.5,yst=1
    oplot,[-M,M],[0,0],linestyle=2
    xyouts,0,0.7,'reverse '+files(k),/data,alignment=0.5
  endif
  y_cross=CROSS_NORM(neon_vec(0:(N/bin-1 < Nx-1)), neon(*,k) ,M)
  y_cross=y_cross-lowess(x_cross,y_cross,2*M,3,3)
  ymax(k+Neta)=max(y_cross,Nmax)& dx(k+Neta)=x_cross(Nmax) & num(k+Neta)=k
  if cross eq 1 then begin
    plot,x_cross,y_cross,xst=1,yrange=[-0.2,1],yminor=2,ytickinterval=0.5,yst=1
    oplot,[-M,M],[0,0],linestyle=2
    xyouts,0,0.7,'direct '+files(k),/data,alignment=0.5
  endif
endfor

if cross eq 1 then !P.multi=[0,1,1]
ymax=max(ymax,Nmax)
dx=dx(Nmax) & num=num(Nmax) & rev=rev(Nmax)
if rev eq 0 then direction='normal direction' else $
	direction='reverse direction'
MESSAGE,'result identefication spectra neon',/cont
message,direction+', grating '+files(num)+', shift along dispersion='+$
string(dx,format='(I4)')+' px,'+' correlation peak ='+string(ymax,format='(F4.2)')+$
',  binning along dispersion='+string(bin,format='(I2)'),/cont

;read position wavelength and lines etalon spectra
N_lines=numlines(dir_eta+'etalon_'+files(num)+'.txt')
table=dblarr(2,N_lines)
openr,1,dir_eta+'etalon_'+files(num)+'.txt'
readf,1,table
close,1
param=table(*,0:1)
table=table(*,2:N_lines-1) & N_lines=N_lines-2
line=table(0,*)
pos=(N*rev+(1-2*rev)*table(1,*))/bin+dx
wpos=where(pos lt Nx-1 and pos gt 0,N_pos)
pos=pos(wpos)  &  line=line(wpos)
N_pos=N_elements(pos(wpos))

;identefication lines
tresh=1
wnf=where(1-finite(neon_vec),nnf)
if nnf gt 0 then neon_vec(wnf)=0.
robomean,(neon_vec > 0.),3,0.5,avg_level,rms_level
fi_peak,x,neon_vec,avg_level+rms_level*tresh,ipix,xpk,ypk,bkpk,ipk
;calculation accuracy position
ymax=dblarr(N_pos) & xmax=ymax
FWHM=6 & W=FWHM*2/bin

for k=0,N_pos-1 do begin
 ymax[k]=max(neon_vec(pos[k]-w>0:pos[k]+w<Nx-1),Nmax)
 xmax[k]=x(pos[k]-w+Nmax-1)
 g=goodpoly(double(x(xmax[k]-w/2>0:xmax[k]+w/2<Nx-1)),$
	double(neon_vec(xmax[k]-w/2>0:xmax[k]+w/2<Nx-1)),2,2)
 xmax[k]=-g(1)/2/g(2)
endfor

;create previus dispersion curve
L=goodpoly(xmax,line,Ndeg,3,fit)
wave=0 & for j=0,Ndeg do wave=wave+L(j)*x^j

;calculation mean dispersion
disp=shift(wave,-1)-wave
disp=ABS(disp(Nx/2)/bin)

;prepare data for creating 2D-dispersion curve
Ny_pos=20
wy=Ny/(Ny_pos+1)  & y_pos=dindgen(Ny_pos)*wy+wy
neon_2D=dblarr(Nx,Ny_pos)
for k=0,Ny_pos-1 do begin
 y=total(neon_ima(*,y_pos(k)-wy:y_pos(k)+wy),2)
 fi_peak,x,y,0,ipix,xpk,ypk,bkpk,ipk
 bkpk=smooth(bkpk,3,/edge_truncate)
 fon=interpol(bkpk,xpk,x,/LSQUADRATIC)
 neon_2D(*,k)=y-fon
endfor
x_pos=dblarr(500,Ny_pos) & pos_num=intarr(Ny_pos)
;create 2D-array position peaks
for y=0,Ny_pos-1 do begin
fi_peak,x,neon_2D(*,y),0,ipix,xpk,ypk,bkpk,ipk
x_pos(0:ipk-1,y)=xpk
pos_num(y)=ipk
endfor

;selection conterminous repers
pos=0
for j=0,pos_num(Ny_pos/2)-1 do begin
sw=0
for y=0,Ny_pos-1 do begin
R=where(abs(x_pos(*,y)-x_pos(j,Ny_pos/2)) lt FWHM,ind)
if ind eq 1 then sw=sw+1
endfor
if sw eq Ny_pos then pos=[pos,x_pos(j,Ny_pos/2)]
endfor

;read table lines of neon spectra
N_tab=numlines(dir_eta+'lines.tab')
table_lines=dblarr(3,N_tab)
openr,1,dir_eta+'lines.tab'
readf,1,table_lines
close,1
lines=table_lines(0,*) & res=table_lines(1,*)

;selection lines in working spectral range
R=where(lines gt min(wave) and lines lt max(wave),ind)
lines=lines(R) & res=res(R)
;create list lines for working resolution
R=where(res gt disp*2/4,ind)
if ind gt 1 then lines=lines(R)

;identefication peaks in observed neon spectra
lpk=dblarr(ipk)
for j=0,Ndeg do lpk=lpk+L(j)*xpk^j
pos=0 & line=0
for k=0,ipk-1 do begin
 R=where(abs(lpk(k)-lines) lt disp*FWHM ,ind)
 if ind eq 1 then begin
  pos=[pos,xpk(k)]
  line=[line,lines(R(0))]
 endif
endfor
N_line=N_elements(pos)
pos=pos(1:N_line-1)
line=line(1:N_line-1) & N_line=N_line-1
x_pos=dblarr(N_line,Ny_pos)
;finding accuracy position peaks along slit
ww=FWHM/bin
for y=0,Ny_pos-1 do begin
 for k=0,N_line-1 do begin
  P=goodpoly(double(x(pos(k)-ww:pos(k)+ww)),double(neon_2D(pos(k)-ww:pos(k)+ww,y)),2,3,fit)
  x_pos(k,y)=-P(1)/2/P(2)
 endfor 
endfor
;create 2D-dispersion curve
st=0
beg:
if st eq 2 then goto,fin
disp_Y=dblarr(Ndeg+1,Ny_pos)
for y=0,Ny_pos-1 do begin
  disp_Y(*,y)=goodpoly(double(x_pos(*,y)),double(line),Ndeg,3,fit)
endfor
vec=dblarr(Ny_pos)
disp_XY=dblarr(Ndeg,Ndeg+1)
y=dindgen(Ny)
for j=0,Ndeg do begin
 vec(*)=disp_Y(j,*)
 disp_XY(*,j)=goodpoly(double(y_pos),median(vec,3),Ndeg-1,3,fit)
 fit=0 & for i=0,Ndeg-1 do fit=fit+disp_XY(i,j)*y^i
endfor
;polynomial fitting dispersion coefficients along slit
line_pos=dblarr(N_line,Ny_pos)
k=1
coeff=dblarr(Ndeg+1,Ny) ;2D-polynomial coefficienrs along slit

for k=0,Ndeg do for j=0,Ndeg-1 do coeff(k,*)=coeff(k,*)+disp_XY(j,k)*double(y)^j

;calculation wavelength peaks position
for k=0,N_line-1 do begin
  for j=0,Ndeg do line_pos(k,*)=line_pos(k,*)+coeff(j,y_pos)*x_pos(k,*)^j
endfor
;correction value wavelength lines
dy=5 & d_line=dblarr(N_line) & rms_line=d_line
for k=0,N_line-1 do begin
 robomean,line_pos(k,*)-line(k),3,0.5,avg_value,rms_value
 ;rms_value=stdev(line_pos(k,*)-line(k),avg_value)
 d_line(k)=avg_value & rms_line(k)=rms_value
endfor
shift_line=d_line
R=where(abs(d_line/disp/bin) lt 0.3,ind) & if ind gt 0 then shift_line(R)=0
line=line+shift_line
st=st+1
goto,beg
fin:
;calculation approximation errors
robomean,d_line,3,0.5,avg1,rms1
robomean,rms_line,3,0.5,avg2,rms2
err_approx=sqrt(rms1^2+(total(rms_line)/N_line)^2)
;plot result identefication

if sg eq 1 then window,2,xsize=1000,ysize=500,title='result identefication spectra neon'
if sg eq 0 then set_plot,'PS'
if sg eq 0 then device,file=wdir+'neon.ps',/landscape
R=where(neon_vec lt 0,ind) & if ind gt 1 then neon_vec(R)=0
neon_vec=neon_vec^0.5

plot,x,neon_vec/max(neon_vec),xst=1,yrange=[0,1.25],yst=1,$
	position=[0.1,0.3,0.99,0.95],/norm,xcharsize=1E-7,$
	title='grating '+files(num)+', bin_X='+strtrim(string(bin,format='(I2)'),2)+$
	',  central dispersion='+strtrim(string(disp*bin,format='(F7.2)'),2)+string("305B)+'/px'+$
	', error 2D-approximation='+string(err_approx/bin,format='(F4.2)')+string("305B),$
	ytitle='relative intensity'

for k=0,N_line-1 do begin
 oplot,[1,1]*pos(k),[neon_vec(pos(k))/max(neon_vec)+0.025,neon_vec(pos(k))/max(neon_vec)+.05]
 xyouts,pos(k)+Nx/500,neon_vec(pos(k))/max(neon_vec)+0.05,$
	string(line(k),format='(F8.2)'),/data,charsize=0.75,orientation=90
endfor

plot,pos,d_line/disp/bin,psym=6,yrange=[-0.39,0.39],yst=1,xst=1,yminor=1,$
	position=[0.1,0.1,0.99,0.3],/norm,/noerase,xrange=[0,Nx-1],xticklen=0.1,yticklen=0.01,$
	xtitle='channel, px', ytitle='error, px',symsize=0.25
oplot_err,pos,d_line/disp/bin,rms_line/disp/bin,psym=6,symsize=0.25
oplot,[0,Nx-1],[0,0],linestyle=2

if sg eq 0 then begin
device,/close
if os_family() eq 'unix' then set_plot,'X' else set_plot,'WIN'
endif
set_plot,'ps'
device,filename=wdir+'neon_poly'+'.ps',/enc,/color,/port,xsize=30,ysize=20,xoffset=15
plot,poly(x,coeff(*,y[Ny-1])),x
oploterr,line,pos,rms_line*100.,3
device,/close
mkhdr,h,coeff
sxaddpar,h,'lambda_0',param(0,0)
N_lin=fix((param(1,0)-param(0,0))/param(0,1))
sxaddpar,h,'d_lambda',param(0,1)
sxaddpar,h,'N_lin',N_lin
sxaddpar,h,'order2',param(1,1)
writefits,wdir+'2D_coeff.fts',coeff,h
set_plot,'x'
end
