pro LS_correlate,infile,outfile=outfile

; designed for atmospheric dispertion and dispersion direction inclination correction

wdir=exdir(infile)
if not(keyword_set(outfile)) then outfile=strreplace(infile,'.fts','_cor.fts')

data=readfits(infile,h)
dl=sxpar(h,'CDELT1')  &  l0=sxpar(h,'CRVAL1')
a=size(data)
nx=a[1]  &  ny=a[2]
l=dindgen(nx)*dl+l0
dy=sxpar(h,'CDELT2')   &  y0=sxpar(h,'CRVAL2') 
y=dindgen(ny)*dy+y0

c=15
slice0=total(data(round(nx/2.)-10:round(nx/2.)+10,*),1)
yint=dindgen(ny*c)*dy/double(c)+y0
if ny gt 450 then yint=yint(where(yint gt dy*200 and yint lt dy*(ny-201)))

winf=where(1-finite(slice0),ninf)
if ninf gt 0 then slice0(winf)=0.
slice0_smooth=lowess(y,slice0,100,1)
slice0=slice0/slice0_smooth-1.
slice0_int=interpol(slice0,y,yint)

nn=10.0*double(c)

w1=where(indgen(nx) mod 20 eq 0, n1)
message,strtrim(string(n1),2)+' points appropriate',/cont

yshift=dblarr(nx)

for k=0,n1-1 do begin
  slice=total(data(round(w1[k])-50>0:round(w1[k])+50<nx-1,*),1)
   winf=where(1-finite(slice),ninf)
  if ninf gt 0 then slice(winf)=0.
 slice_smooth=lowess(y,slice,100,1)
  slice=slice/slice_smooth-1.
  slice_int=interpol(slice,y,yint)  ;;,/spl)
  corr=c_correlate(slice0_int,slice_int,indgen(2*nn+1)-nn)
;  corr=gauss_convol(dindgen(n_elements(corr)),med_ext(corr,c),c/2.35)
  maxv=max(corr,wmax)
;  wmin=wmin-nn
;  gfit=gaussfit(double(indgen(2*nn+1)-nn)*dy,corr,g)

  yshift[w1[k]]=(wmax-double(nn))*dy/double(c)
;;;;  if k eq 0 then plot,corr,yrange=[0.,1.]
;;;;  oplot,corr
;;;;  oplot,[wmax,wmax],[min(corr),max(corr)],color=1000
endfor

; plot,l(w1),yshift(w1),xtitle='wv,'+string("305B),ytitle='dy, arcsec',psym=2,/yst
disp=stdev(yshift(w1))

message,'standard deviation of maximum: '+strtrim(string(disp,for='(F20.5)'),2),/cont

if disp le 0.1 then begin
  message,'ideal dispersion alignment',/cont
  writefits,outfile,data,h
endif else begin
  ypars=goodpoly(l(w1),yshift(w1),2,2.,yfit)
  yfit=poly(l,ypars)

  set_plot,'ps'
   device,filename=wdir+'LS_cor.ps'
    plot,l(w1),yshift(w1),xtitle='wv,'+string("305B),ytitle='dy, arcsec',yrange=[min(yfit),max(yfit)],psym=2
    oplot,l,yfit,thick=5.
   device,/close
  set_plot,'x'

  oud=data

  for k=0,nx-1 do begin
    slice=reform(data(k,*))
    slice=interpol(slice,y,y+poly(l[k],ypars))
    oud(k,*)=slice
  endfor

  writefits,outfile,oud,h
endelse


end
