pro DRAWPLOT
COMMON IMAblock,file,h,frame,ima,LOGFILE,Nx,Ny,Nz,sc,bin,plane,d_lambda,lambda_0
COMMON WIN,num_win,s_win,xs,ys,xgau,sw_gau
COMMON BOXblock,map,x1,x2,y1,y2
COMMON REG,x_min,y_min,x_max,y_max,region,x,y,a
WSET, num_win

R=FLOAT(x_max-x_min)/float(y_max-y_min)
IF R gt 1 then begin
x_tmp=FIX((x_min+(x_max-x_min)/600.*xs))
vector=total(region,2)/a(2)
plot,x,vector,XST=1,yst=1,position=[0,0,1,1],xmin=1,ymin=1,$
	xtickinterval=1E5,ytickinterval=1E8
oplot,x,vector*0,linestyle=2
oplot,x_tmp*[1,1],$
[min(vector),max(vector)],linestyle=2
if sw_gau ne 1 then begin
if d_lambda eq 0 then xyouts,0.75,0.9,strcompress('pixel '+string(x_tmp)),/norm $
ELSE xyouts,0.75,0.9,strcompress('wavelength '+string(FIX(d_lambda*x_tmp+lambda_0))+' A'),/norm
endif
xyouts,0.75,0.8,strcompress('value '+string(vector(x_tmp-x_min))),/norm
if sw_gau eq 1 then begin
profile=gaussfit(x,vector,G)
oplot,x,profile,linestyle=1
if d_lambda eq 0 then begin
xyouts,0.75,0.9,strcompress('pixel '+string(G(1))),/norm
xyouts,0.75,0.7,strcompress('FWHM '+string(G(2)*2.345)),/norm
endif
if d_lambda gt 0 then begin
xyouts,0.75,0.9,strcompress('wavelength '+string(G(1)*d_lambda+lambda_0,format='(F6.1)')+' A'),/norm
xyouts,0.75,0.7,strcompress('FWHM '+string(G(2)*2.345*d_lambda,format='(F4.1)')+' A'),/norm
endif
endif

endif
if R lt 1 then begin
y_tmp=FIX((y_min+(y_max-y_min)/600.*xs))
vector=total(region,1)/a(1)
plot,y,vector,XST=1,yst=1,position=[0,0,1,1],xmin=1,ymin=1,$
	xtickinterval=1E5,ytickinterval=1E8
oplot,y,vector*0,linestyle=2
oplot,y_tmp*[1,1],$
[min(vector),max(vector)],linestyle=2
if sw_gau ne 1 then xyouts,0.8,0.9,strcompress('pixel '+string(y_tmp)),/norm
xyouts,0.8,0.8,strcompress('value '+string(vector(y_tmp-y_min))),/norm
if sw_gau eq 1 then begin
profile=gaussfit(y,vector,G)
oplot,y,profile,linestyle=1
xyouts,0.8,0.9,strcompress('pixel '+string(G(1))),/norm
xyouts,0.8,0.7,strcompress('FWHM '+string(G(2)*2.345)),/norm
imascale=sxpar(h,'IMSCALE')
imascale=str_sep(imascale,'x') & imascale=float(imascale(1))
xyouts,0.8,0.6,strcompress('seeing '+string(G(2)*2.345*imascale)),/norm
endif
endif
;WSET, swin			; Restore the original window
END




Pro Wplot_event, event
COMMON IMAblock,file,h,frame,ima,LOGFILE,Nx,Ny,Nz,sc,bin,plane,d_lambda,lambda_0
COMMON WIN,num_win,s_win,xs,ys,xgau,sw_gau
COMMON BOXblock,map,x1,x2,y1,y2
; When a widget is selected, put its User Value into 'eventval':

WIDGET_CONTROL, event.id, GET_UVALUE = eventval

; Perform actions based on the User Value of the event:

CASE eventval OF
   'DRAW_EVENT': BEGIN
			; The help statement is useful for
			; debugging the event handler.  Try uncommenting
			; it to see the full structure returned by a
			; draw window event.  Note the 'PRESS' and
			; 'RELEASE' fields.
			; HELP, /STRUCT, event

			; Only deal with the 'motion' event,
			; disregard the 'press' and 'release' events:

			IF (event.press EQ 0) AND (event.release EQ 0) THEN BEGIN

			xs=event.x & ys=event.y
						DRAWPLOT
			ENDIF
			sw_gau=0
			if event.press EQ 1 then begin
			sw_gau=1 & xgau=event.x
			DRAWPLOT
			endif


		     END
   'DONE': WIDGET_CONTROL, event.top, /DESTROY
ENDCASE

END



PRO Wplot, GROUP=GROUP

COMMON IMAblock,file,h,frame,ima,LOGFILE,Nx,Ny,Nz,sc,bin,plane,d_lambda,lambda_0
COMMON WIN,num_win,s_win,xs,ys,xgau,sw_gau
COMMON BOXblock,map,x1,x2,y1,y2
COMMON REG,x_min,y_min,x_max,y_max,region,x,y,a
s_win = !D.WINDOW	; Remember the current window so it can be restored
sw_gau=0

; This example uses keywords to define the size of the draw area:

x_size = 600
y_size = 300

; A top-level base widget with the title "Motion Event Widget Example"
; will be created.  The size is left unspecified until the draw widget
; is created:
print,x1,y1,x2,y2
base = WIDGET_BASE(TITLE = 'Plot region',/COLUMN)

WIDGET_CONTROL, /MANAGED, base


; A widget called 'draw' is created:

draw_plot = WIDGET_DRAW(base, XSIZE=x_size, YSIZE=y_size,/FRAME, $
	/MOTION_EVENTS,  /BUTTON_EVENTS ,$		;generate LOTS of events
	UVALUE = 'DRAW_EVENT', 	RETAIN = 2)

; The 'DONE' button:

button = WIDGET_BUTTON(base , $
		UVALUE = 'DONE', $
		VALUE = 'DONE')
; Realize the widgets:
WIDGET_CONTROL, base, /REALIZE

; Get the window number from the draw widget.  This can only be done
; after the widget has been realized:

WIDGET_CONTROL, draw_plot, GET_VALUE=num_win
xs=0 & ys=0

DRAWPLOT
; Hand off control of the widget to the XMANAGER:
XMANAGER, "Wplot", base, GROUP_LEADER=GROUP, /NO_BLOCK

END
