pro autolog,file,logname=logname,stddir=stddir

if not(keyword_set(stddir)) then stddir='~/standards/'

ss=size(file)
if ss[0] eq 0 then file0=file else file0=file[0]

indir=exdir(file0)
hdr=headfits(file0)
mode=sxpar(hdr,'MODE')
grid=sxpar(hdr,'DISPERSE')
bin=sxpar(hdr,'BINNING')
objname=strcompress(sxpar(hdr,'OBJECT'),/remove_all)
outdir=indir+objname+'/'

logname=indir+objname+'.txt'
mess=dialog_message('Agree with the name "'+logname+'"?',/que)
if mess eq 'No' then logname=dialog_pickfile(filter=logname)

neonfiles=fselect(indir,'neon',grid=grid,bin=bin,mode=mode)
flatfiles=fselect(indir,'flat',grid=grid,bin=bin,mode=mode)
mapfiles=fselect(indir,'map',grid=grid,bin=bin,mode=mode)
; objvarfiles=fselect(indir,'obj',grid=grid,bin=bin,mode=mode)

starfiles=[dialog_pickfile(filter=indir+"*.FTS",title='select spectral standard files (at least one)',/multi)]
starname=sxpar(headfits(starfiles[0]),'OBJECT')
table=dialog_pickfile(filter=stddir+'f'+strlowcase(starname)+".dat",title='select spectral standard flux table')

biasfiles=fselect(indir,'bias',bin=bin,mode=mode)

  flatbest=prered_best(flatfiles,hdr0,file,mode=mode)
  neonbest=prered_best(neonfiles,hdr0,file,mode=mode)
  map=strmid(prered_best(mapfiles,hdr0,file,mode=mode),7,4,/reverse_offset)
 night=strmid(file,11,4,/reverse_offset)
if n_elements(night) gt 1 then night=night[0]
obj=strmid(file,7,4,/reverse_offset)
neon=strmid(neonbest,7,4,/reverse_offset)
flat=strmid(flatbest,7,4,/reverse_offset)
star=strmid(starfiles,7,4,/reverse_offset)
bias=strmid(biasfiles,7,4,/reverse_offset)

openw,uni,logname,/get_lun
 printf,uni,'SIMPLE  =                                 T / LOG OBSERVATION'
 printf,uni,'EXT     =  .FTS                          / EXTENTION DATA FILE'
 printf,uni,'YOBJ    =   '+string(39B)+'50.,150.    '+string(39B)+'                      / approximate object position'
 printf,uni,'SLITPOS =  530. / slit position'
 printf,uni,'SLITSIZE=  1. / slit size'
 printf,uni,'MODE    =  '+mode+'           / EXTENTION DATA FILE'
 printf,uni,'R_DIR   = '+indir+'                     / DIRECTORY FOR READING'
 printf,uni,'W_DIR   = '+outdir+'                     / DIRECTORY FOR READING'
 printf,uni,'NIGHT   = '+string(39B)+night+string(39B)+'            / observational night in S### format'
 printf,uni,'MAP     = '+string(39B)+strjoin(map,',')+string(39B)+'            / object images -- "maps"'
 printf,uni,'BIAS    = '+string(39B)+strjoin(bias,',')+string(39B)+'           / bias files'
 printf,uni,'OBJ     = '+string(39B)+strjoin(obj,',')+string(39B)+'            / object spectra'
 printf,uni,'NEON    = '+string(39B)+strjoin(neon,',')+string(39B)+'           / wavelength standard'
 printf,uni,'FLAT    = '+string(39B)+strjoin(flat,',')+string(39B)+'           / flatfields'
 printf,uni,'STAR    = '+string(39B)+strjoin(star,',')+string(39B)+'            / spectral standard slitless spectra'
 printf,uni,'STARSLIT= '+string(39B)+strjoin(star,',')+string(39B)+'            / spectral standard, slit spectra'
 printf,uni,'TABLE   = '+table+'           / spectral standard spectrum in 1.e-16 erg/cm^2/s/\AA units'
 printf,uni,'REDSHIFT= 0.        / ESTIMATED system redshift'
 printf,uni,'END'
 printf,uni,''
close,uni
free_lun,uni

;mkhdr, header, im, naxisx, IMAGE = image, EXTEND = extend

end
