pro balcor,infile,outfile

; procedure uses several balmer lines to correct for dispersion curve 
; anomalies in the blue range
; disigned for SCORPIO LS spectra,
; written by P. Abolmasov, Dec 2005

c=double(2.9979e+5)

ind=readfits(infile,hin)
dl=sxpar(hin,'CDELT1')  &  l0=sxpar(hin,'CRVAL1') 
nx=n_elements(ind) 

l=dindgen(nx)*dl+l0

baw=[6562.82,4861.33,4340.74,4101.33,3970.07,3889.05]

baw=baw(where(baw gt min(l)+20. and baw lt max(l)-20.))
v=baw*0.  &  dv=baw*0.

if baw[0] eq 6562.82 then begin
 span_halpha,infile,velt=vtmp,dvelt=dvtmp
 v[0]=vtmp[1]  &  dv[0]=dvtmp[1]
  for k=1,n_elements(baw)-1 do begin
    span,infile,[baw[k]],velt=vtmp,dvelt=dvtmp
    v[k]=vtmp[0]  &  dv[k]=dvtmp[0]
  endfor 
endif else begin
  for k=0,n_elements(baw)-1 do begin
    span,infile,[baw[k]],velt=vtmp,dvelt=dvtmp
    v[k]=vtmp[0]  &  dv[k]=dvtmp[0]
  endfor 
endelse

plot,baw,v,/yst
oploterr,baw,v,dv

lacor_tmp=baw*(v-v[0])/c
lacor_tmp=lacor_tmp(sort(baw))
baw1=baw(sort(baw))

lacor=interpol(lacor_tmp(where(baw1 gt 4020.)),baw1(where(baw1 gt 4020.)),l)
oplot,l,lacor*c/l+v[0],color=1000

oud=interpol(ind,l-1.*lacor,l)
hout=hin
writefits,outfile,oud,hout
print,'Halpha velocity: ',v[0]

end
