pro color_spect1,infile,wdir=wdir,redir=redir,av=av,parv=parv,ub=ub,bv=bv,vr=vr,magv=magv,deline=deline,$
  dspfile=dspfile,noerr=noerr, lrange=lrange
; on_error,1

if not(keyword_set(dspfile)) then dspfile=exdir(infile)+'dsp.fts'
if not(keyword_set(av)) then av=0.
if not(keyword_set(parv)) then parv=3.1
if not(keyword_set(redir)) then redir='/users/lfz/standards/filters/'
if not(keyword_set(wdir)) then wdir=exdir(infile) ;;'~/V532/mp041112resultsky/color_spect_star.eps'

f=readfits(infile,hin)
l0=sxpar(hin,'CRVAL1')  &  dl=sxpar(hin,'CDELT1')
l=dindgen(n_elements(f))*dl+l0
if not(keyword_set(noerr)) then df=readfits(dspfile,dhin)

if keyword_set(lrange) then begin
           www=where(l lt max(lrange) and l gt min(lrange))
           l=l(www) 
           f=f(www)
endif

; f=f/l
if keyword_set(deline) then begin
set_plot,'ps'
 device,filename=wdir+'deline.ps'
 plot,l,f
   f1=lowess(l,f,250,1)
 oplot,l,f1,color=1000  
 device,/close
set_plot,'x'
f=f1
endif

; *** reading responses
fileu=redir+'filter_u.dat'
fileb=redir+'filter_b.dat'
filev=redir+'filter_v.dat'
filer=redir+'filter_r.dat'
file_a0=redir+'a0.dat'
filsfilt=[fileb,filev,filer]

  openr,1,file_a0
   s0=''
   readf,1,s0
   tmp=dblarr(5)
   readf,1,s0
   tmp=strsplit(s0,'	',/ext)
   if strpos(s0,'#') ge 0. then begin
     la0=0. & fa0=0.
   endif else begin
     la0=double(tmp[0])
     fa0=double(tmp[1])
   endelse
  while not(eof(1)) do begin
    readf,1,s0
    if strpos(s0,'#') ge 0. then continue
    tmp=strsplit(s0,'	',/ext)
    la0=[la0,double(tmp[0])]
    fa0=[fa0,double(tmp[1])/double(tmp[0])]
  endwhile  
close,1

openr,1,fileu
   tmp=dblarr(2)
   readf,1,tmp
   lu=tmp[0]  &  fu=tmp[1]
  while not(eof(1)) do begin
    readf,1,tmp
    lu=[lu,tmp[0]]
    fu=[fu,tmp[1]]
  endwhile  
close,1

openr,1,fileb
   tmp=dblarr(2)
   readf,1,tmp
   lb=tmp[0]  &  fb=tmp[1]
  while not(eof(1)) do begin
    readf,1,tmp
    lb=[lb,tmp[0]]
    fb=[fb,tmp[1]]
  endwhile  
close,1
openr,1,filev
   tmp=dblarr(2)
   readf,1,tmp
   lv=tmp[0]  &  fv=tmp[1]
  while not(eof(1)) do begin
    readf,1,tmp
    lv=[lv,tmp[0]]
    fv=[fv,tmp[1]]
  endwhile  
close,1
openr,1,filer
   tmp=dblarr(2)
   readf,1,tmp
   lr=tmp[0]  &  fr=tmp[1]
  while not(eof(1)) do begin
    readf,1,tmp
    lr=[lr,tmp[0]]
    fr=[fr,tmp[1]]
  endwhile  
close,1
; ***

; *** calculating fluxes for A0 star
c=1.
fa0=fa0*c/la0^2
  fa0_u=interpol(fu,lu,la0,/spline)
  fa0_u(where(la0 gt max(lu) or la0 lt min(lu)))=0.
  flux_a0u=total(fa0_u*fa0 > 0.)*abs(median(shift(la0,1)-la0))

  fa0_b=interpol(fb,lb,la0,/spline)
  fa0_b(where(la0 gt max(lb) or la0 lt min(lb)))=0.
  flux_a0b=total(fa0_b*fa0 > 0.)*abs(median(shift(la0,1)-la0))

  fa0_v=interpol(fv,lv,la0,/spline)*abs(median(shift(la0,1)-la0))
  fa0_v(where(la0 gt max(lv) or la0 lt min(lv)))=0.
  flux_a0v=total(fa0_v*fa0 > 0.)
 
  fa0_r=interpol(fr,lr,la0,/spline)*abs(median(shift(la0,1)-la0))
  fa0_r(where(la0 gt max(lr) or la0 lt min(lr)))=0.
  flux_a0r=total(fa0_r*fa0 > 0.)
 
; *** ... and object analysed
; f=f*double(10.)^(-double(.4*av*5500.)/l)
; f=f*double(10.)^(-.4*av*ext_ccm(l,parv))
ccm_unred,l,f,av/parv,f1,r_v=parv
; f=f1

  f_u=interpol(fu,lu,l)  ;*abs(median(shift(l,1)-l))
  w_u=where(l gt max(lu) or l lt min(lu),n_u)
  if n_u gt 0 then f_u(w_u)=0.
  flux_u=int_tabulated(l,f_u*f > 0.,/double)
 if not(keyword_set(noerr)) then  dflux_u=int_tabulated(l,f_u*df > 0.,/double)

  f_b=interpol(fb,lb,l)  ;*abs(median(shift(l,1)-l))
  w_b=where(l gt max(lb) or l lt min(lb),n_b)
  if n_b gt 0 then f_b(w_b)=0.
  flux_b=int_tabulated(l,f_b*f > 0.,/double)
 if not(keyword_set(noerr)) then  dflux_b=int_tabulated(l,f_b*df > 0.,/double)

  f_v=interpol(fv,lv,l) ;*abs(median(shift(l,1)-l))
  w_v=where(l gt max(lv) or l lt min(lv),n_v)
  if n_v gt 0 then f_v(w_v)=0.
  flux_v=int_tabulated(l,f_v*f > 0.,/double)
 if not(keyword_set(noerr)) then  dflux_v=int_tabulated(l,f_v*df > 0.,/double)
; flux_v=total(f_v*f > 0.)*dl
 
  f_r=interpol(fr,lr,l)
  w_r=where(l gt max(lr) or l lt min(lr),n_r)
   if n_r gt 0 then f_r(w_r)=0.
  flux_r=int_tabulated(l,f_r*f > 0.,/double)  ;*abs(median(shift(l,1)-l))
 if not(keyword_set(noerr)) then  dflux_r=int_tabulated(l,f_r*df > 0.,/double)  ;*abs(median(shift(l,1)-l))


; ***  U-B,B-V, V-R at last!!!

ub=-2.5*(alog10(flux_u/flux_a0u)-alog10(flux_b/flux_a0b))
bv=-2.5*(alog10(flux_b/flux_a0b)-alog10(flux_v/flux_a0v))
vr=-2.5*(alog10(flux_v/flux_a0v)-alog10(flux_r/flux_a0r))

u=-2.5*alog10(flux_u)-13.87
v=-2.5*alog10(flux_v)-13.74
b=-2.5*alog10(flux_b)-12.97
 bv=b-v
du=0. & dv=0. &  db=0. &  dr=0. 
if not(keyword_set(noerr)) then begin
 du=1.08*dflux_u/flux_u
 dv=1.08*dflux_v/flux_v
 db=1.08*dflux_b/flux_b
 dr=1.08*dflux_r/flux_r
endif
 dbv=db+dv
 dub=du+db
 dvr=dr+dv
; dist=5.1E+6
; v=v-alog10(dist)*5.+5.

resd=dialog_message('U-B color index:'+strtrim(string(ub,for='(F10.2)'),2)+string("261B)+strtrim(string(dub,for='(F10.2)'),2)+$
                   string(10B)+'B-V color index:'+strtrim(string(bv,for='(F10.2)'),2)+string("261B)+strtrim(string(dbv,for='(F10.2)'),2)+$
                   string(10B)+'V-R color index:'+strtrim(string(vr,for='(F10.2)'),2)+string("261B)+strtrim(string(dvr,for='(F10.2)'),2)+$
                   string(10B)+'V magnitude:'+strtrim(string(v,for='(F10.2)'),2)+string("261B)+strtrim(string(dv,for='(F10.2)'),2),/info)

print,'U-B color index:',ub,string("261B),dub
print,'B-V color index:',bv,string("261B),dbv
print,'V-R color index:',vr,string("261B),dvr
print,'V-magnitude:',v,string("261B),dv

magv=v
wkiller
; *** PS output
outfile=strreplace(infile,'.fts','_color_spect.eps')
set_plot,'ps'
 device,filename=outfile,/encaps,/color,/land
  loadct,0
  fsm=med_ext(reform(f),20)
  plot,l,f,thick=2.,charsize=2.,charthick=3.,yrange=[0.,max(fsm)]*2.,/yst
 loadct,27
  oplot,l,f_r*flux_r/total(f_r),color=1000,thick=3.
  oplot,l,f_b*flux_b/total(f_b),color=40,thick=3.
  oplot,l,f_v*flux_v/total(f_v),color=80,thick=3.
  oplot,l,f_u*flux_u/total(f_u),color=5,thick=3.
;  oplot,l,f_i*flux_i/total(f_i)
  loadct,0
  xyouts,5200.,max(fsm)*1.8,'V ='+strtrim(string(v,for='(F10.2)'),2)+string("261B)+strtrim(string(dv,for='(F10.2)'),2),$
    charsize=2.,charthick=3.
  xyouts,5200.,max(fsm)*1.6,'B-V ='+strtrim(string(bv,for='(F10.2)'),2)+string("261B)+strtrim(string(dbv,for='(F10.2)'),2),$
    charsize=2.,charthick=3.
  xyouts,5200.,max(fsm)*1.4,'V-R ='+strtrim(string(vr,for='(F10.2)'),2)+string("261B)+strtrim(string(dvr,for='(F10.2)'),2),$
    charsize=2.,charthick=3.
  xyouts,5200.,max(fsm)*1.2,'U-B ='+strtrim(string(ub,for='(F10.2)'),2)+string("261B)+strtrim(string(dub,for='(F10.2)'),2),$
    charsize=2.,charthick=3.
 device,/close
set_plot,'x'
end
