pro contmap_long,infile,yrange=yrange,lrange=lrange

data=readfits(infile,h)

dl=sxpar(h,'CDELT1')  &  l0=sxpar(h,'CRVAL1')
dy=sxpar(h,'CDELT2')  &  y0=sxpar(h,'CRVAL2')

s=size(data)

l=dindgen(s[1])*dl+l0
y=dindgen(s[2])*dy+y0

if keyword_set(yrange) then begin
  wy=where(y gt min(yrange) and y lt max(yrange))
  data=data(*,wy) & y=y(wy)
endif
if keyword_set(lrange) then begin
  wl=where(l gt min(lrange) and l lt max(lrange))
  data=data(wl,*) & l=l(wl)
endif

ny=n_elements(y)  &  nl=n_elements(l)
datasm=data

for k=0,ny-1 do begin
;  datasm(*,k)=smooth(med_ext(reform(data(*,k)),100),100)
endfor

slice0=reform(data(round(double(nl)/2.),*))
shift=dblarr(nl)

for k=0,nl-1 do begin
  slice=reform(datasm(k,*))
  ccor=c_correlate(slice0,slice,10,/doub)
  maxv=max(ccor,wmax)
  shift[k]=(double(wmax)-5.)*dy
endfor

pf=goodpoly(l,shift,2,2.,shiftfit)
for k=0,nl-1 do datasm(k,*)=vecshift(reform(datasm(k,*)),dx=-shiftfit[k])

profile=total(datasm,1)

wdir=exdir(infile)

plot,y,profile

sxaddpar,h,'CDELT1',dy
sxaddpar,h,'CRVAL1',min(y)

writefits,wdir+'contmap.fts',profile,h

end
