pro dqe,obs,tab,wdqe=wdqe

date_fts,tab,exdir(obs)+'spectr_standard.fts',lrange=[3000,9000]
if not(keyword_set(wdqe)) then wdqe=240

wdir=exdir(obs)
 fo=readfits(obs,ho)
so=size(fo)

dl=sxpar(ho,'CDELT1')  &  l0=sxpar(ho,'CRVAL1')
lo=dindgen(so[1])*dl+l0

texp=sxpar(ho,'EXPTIME')
message,'Exposure for star:'+strtrim(string(texp,for='(I10)'),2)+'s',/cont
fo=fo/texp

 tt=dblarr(3)
 ttmp=tt

tt=read_asc(tab)

; dt=indgen(n_elements(tt))

ltab=tt(0,*)           ;(where((dt mod 3) eq 0))
ftab=tt(1,*)*1.e-16                ;(where((dt mod 3) eq 1))*1.e-16
dft=tt(2,*)              ;(where((dt mod 3) eq 2))
step=min(abs(ltab-shift(ltab,1)))
 z=sxpar(ho,'Z')
ca=0.012 & cc=0.12
extin=((ca*1./((lo/10000.)^4.)+cc)*2.5/2.3)/cos(z/!RADEG)
;extin=extin*0.   ;;; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

f_sim=interpol(ftab,ltab,lo) ;*(10d)^(-0.4*extin)

badlam=[6562.82,5577.345,6300.23,6363.82,4861.33,4340.74,4101.33,3990.,4713.]

wgood=indgen(n_elements(lo))
for q=0,n_elements(badlam)-1 do wgood=wgood(where(abs(lo(wgood)-badlam[q]) ge wdqe*0.1*(badlam[q]/6000.)))

dqe_draft=fo/f_sim
dqe_draft=med_ext(interpol(dqe_draft(wgood),lo(wgood),lo),20)
dqe=lowess(lo,dqe_draft,wdqe,1)
;plot,lo,dqe_draft,psym=2
;oplot,lo,dqe,color=1000
;;  dispersion correction ;||

fo_reversim=fo/dqe
cont_fo=lowess(lo,fo_reversim,wdqe,2)
cont_f_sim=lowess(lo,f_sim,wdqe,2)
nn=30
lag=indgen(2*nn+1)-nn
fo1=fo
if step lt 10. then begin 
corr=c_correlate(f_sim/cont_f_sim,fo_reversim/cont_fo,lag)
maxv=max(corr,wmax)
fo1=shift(fo,nn-wmax)
endif

dqe_draft=fo1/f_sim
dqe_draft=med_ext(interpol(dqe_draft(wgood),lo(wgood),lo),20)

wplus=where(dqe_draft gt 0.)

dqe=(10d)^(interpol(lowess(lo(wplus),alog10(dqe_draft(wplus)),wdqe,2),lo(wplus),lo)+0.4*extin)
;dqelin=interpol(lowess(lo(wplus),(dqe_draft(wplus)),wdqe,1),lo(wplus),lo)
;plot,lo,dqe_draft,/ylog,psym=2
;oplot,lo,dqe,color=1000

set_plot,'ps'
 device,filename=wdir+'DQE.ps',/port,/color,xsize=21,ysize=27,xoff=0,yoff=0
!p.multi=[0,1,2]
loadct,0,/sil
  plot,lo,dqe_draft*(10d)^(0.4*extin),psym=3,xtitle='!4k!3,'+string("305B),ytitle='counts/(erg/cm^2)',yrange=[min(dqe)>0.,max(dqe)],$
    charsize=2.,symsize=2.,charthick=3.,thick=3.,title='spectral sensitivity calibration'
loadct,27,/sil
  oplot,lo,dqe,color=1000,thick=3.
loadct,0,/sil
 plot,lo,fo,xtitle='!4k!3,'+string("305B),ytitle='counts',title='specrtophotometric standard spectrum',$
    charsize=2.,symsize=2.,charthick=3.,thick=3.
loadct,27,/sil
  oplot,ltab,ftab*median(fo/f_sim*(10d)^(-0.4*extin)),color=1000,thick=3.
loadct,0,/sil
!p.multi=0
 device,/close
set_plot,'x'
h=ho
sxaddpar,h,'DQE',wdqe
writefits,wdir+'sent.fts',dqe,h
end
