pro exmultispect,infile,shifts=shifts

;  the input file must be a 2D (long-slit) spectrum

f=readfits(infile,hf,/sil)
field=[sxpar(hf,'FIELD1'),sxpar(hf,'FIELD2')]
a=size(f)
cube=reform(f,a[1],field[0],field[1])
ftot=total(cube,2)
if a[0] ne 2 then message,'Massaraxh! Wrong dimentions: the file is '+strtrim(string(a[0]),2)+'D.'
dl=sxpar(hf,'CDELT1')   &  l0=sxpar(hf,'CRVAL1')  &  nx=a[1]
l=dindgen(nx)*dl+l0
dy=sxpar(hf,'CDELT2')   &  y0=sxpar(hf,'CRVAL2')  &  ny=field[1]
y=dindgen(field[1])*dy+y0

wkiller
window,0,ypos=400,xpos=0,xsize=a[1]/2.,ysize=(ny/4.+30)

y1=min(y) & y2=max(y)
; *** MAIN CYCLE ***
ret_obj:
loadct,0,/sil
tvscl,rebin(-(ftot(0:floor(nx/2.)*2-1,0:floor(ny/4.)*4-1)+median(ftot)*10.),floor(nx/2.),floor(ny/4.)),0,0,ysize=ny/4.,xsize=a[1]/2.
contour,-alog(ftot+median(ftot)*10.),l,y,/xst,/yst,/noer,/noda,pos=[0,0,nx/2.,ny/4.],/dev,charsize=1.5,$
  charthick=2.5,xticklen=1.0,color=0
contour,-alog(ftot+median(ftot)*10.),l,y,xst=5,yst=5,/noer,/noda,pos=[0,0,nx/2.,ny/4.],/dev,charsize=1.5,$
  charthick=2.5
loadct,27,/sil
oplot,[l[20],l[20]],[y1,y2],color=1000,thick=5.
oplot,[l[nx-21],l[nx-21]],[y1,y2],color=1000,thick=5.
oplot,[l[20],l[nx-21]],[y1,y1],color=1000,thick=1.
oplot,[l[20],l[nx-21]],[y2,y2],color=1000,thick=1.
loadct,0,/sil
     cursor,xx,yy,4,/data
     m=!MOUSE
     sw=long(m.button)                                         ; mouse click-type  
     if sw eq 0 then goto,ret_obj
     if sw eq 4 then begin
       y1=yy
       goto,ret_obj
     endif
     if sw eq 1 then begin
       c=[xx,yy]
       y2=yy
       message,'got it! '+strcompress(string(c[0])+string(c[1])),/cont   
       goto,ret_obj
     endif

wy_obj=where(y gt y1 and y lt y2)

;  **** MAIN CYCLE COMPLETE: wy_obj  is the y-subscript range for object
;   *** background determination
y3=min(y) & y4=max(y)
wy_bgd=[0]

ret_bgd:

loadct,0
tvscl,rebin(-(ftot(0:floor(nx/2.)*2-1,0:floor(ny/4.)*4-1)+median(ftot)*10.),floor(nx/2.),floor(ny/4.)),0,0,ysize=ny/4.,xsize=a[1]/2.
contour,-alog(ftot+median(ftot)*10.),l,y,/xst,/yst,/noer,/noda,pos=[0,0,nx/2.,ny/4.],/dev,charsize=1.5,$
  charthick=2.5,xticklen=1.0,color=0
contour,-alog(ftot+median(ftot)*10.),l,y,xst=5,yst=5,/noer,/noda,pos=[0,0,nx/2.,ny/4.],/dev,charsize=1.5,$
  charthick=2.5
loadct,27,/sil
oplot,[l[10],l[10]],[y1,y2],color=40,thick=5.
oplot,[l[nx-11],l[nx-11]],[y1,y2],color=40,thick=5.
oplot,[l[20],l[20]],[y3,y4],color=1000,thick=5.
oplot,[l[nx-21],l[nx-21]],[y3,y4],color=1000,thick=5.
oplot,replicate(l[20],n_elements(wy_bgd)),y(wy_bgd),color=1000,thick=2.,psym=3
oplot,replicate(l[nx-21],n_elements(wy_bgd)),y(wy_bgd),color=1000,thick=2.,psym=3
loadct,0,/sil
     cursor,xx,yy,4,/data
     m=!MOUSE
     sw=long(m.button)                                         ; mouse click-type  
     if sw eq 0 then goto,ret_bgd
     if sw eq 4 then begin
       y3=yy
       goto,ret_bgd
     endif
     if sw eq 1 then begin
       c=[xx,yy]
       y4=yy
       message,'got it! '+strcompress(string(c[0])+string(c[1])),/cont   
       goto,ret_bgd
     endif

wy_bgd=[wy_bgd,where(y gt y3 and y lt y4)]
message,'Any more background areas?',/cont
q=''
read,'(y/n)',q
if q eq 'y' or q eq 'Y' then goto,ret_bgd
wy_bgd=wy_bgd(1:n_elements(wy_bgd)-1)

; *** END OF BACKGROUND EXTRACTION

sp_bgd=total(cube(*,*,wy_bgd),3)/double(n_elements(wy_bgd))
sp_obj=total(cube(*,*,wy_obj),3)-sp_bgd*double(n_elements(wy_obj))
ao=size(sp_obj)

shu=uniq(shifts,sort(shifts))
  nshu=n_elements(shu)

if nshu eq 1 then begin
  sp_bgd=total(sp_bgd,2)
  sp_obj=total(sp_obj,2)
endif else begin
  objout=dblarr(nx,nshu)
  bgdout=dblarr(nx,nshu)
    for k=0,nshu-1 do begin
         wwshu=where(shifts eq shifts[shu[k]],nnshu)
         objout(*,k)=total(reform(sp_obj(*,wwshu),ao[1],nnshu),2)
         bgdout(*,k)=total(reform(sp_bgd(*,wwshu),ao[1],nnshu),2)
    endfor
  sp_obj=objout
  sp_bgd=bgdout
endelse

set_plot,'ps'
device,filename=exdir(infile)+'multispect.eps',/enc,/color,/port,xsize=20,ysize=28,yoffset=5
!p.multi=[0,1,nshu]
plot,l,sp_obj(*,0),xtitle='wavelength, '+string("305B),ytitle='Int. flux',charsize=2.,charthick=3.
loadct,27,/sil
oplot,l,sp_bgd(*,0),color=1000
loadct,0,/sil
if nshu gt 1 then begin
  for k=1,nshu-1 do begin
      plot,l,sp_obj(*,k),xtitle='wavelength, '+string("305B),ytitle='Int. flux',charsize=2.,charthick=3.
      loadct,27
      oplot,l,sp_bgd(*,k),color=1000
      oplot,l,sp_bgd(*,k)*0.,color=100
      loadct,0,/sil
  endfor
endif
;contour,-alog(ftot+median(abs(f))),l,y,/xst,/yst,nlevels=150,/fill,xtitle='wavelenght, '+string("305B),$
; ytitle='y, arcsec',charsize=2.,charthick=3.
;loadct,27
;oplot,[l[20],l[20]],[y1,y2],color=180,thick=3.
;oplot,[l[nx-21],l[nx-21]],[y1,y2],color=180,thick=3.
;oplot,[l[20],l[nx-21]],[y1,y1],color=180,thick=2.
;oplot,[l[20],l[nx-21]],[y2,y2],color=180,thick=2.
;oplot,replicate(l[20],n_elements(wy_bgd)),y(wy_bgd),thick=2.,psym=2,symsize=0.5,color=50
;oplot,replicate(l[nx-21],n_elements(wy_bgd)),y(wy_bgd),thick=2.,psym=2,symsize=0.5,color=50
loadct,0,/sil
!p.multi=0
device,/close
set_plot,'x'
writefits,exdir(infile)+'multispint.fts',sp_obj(*,sort(shifts(shu))),hf
writefits,exdir(infile)+'multispint_bgd.fts',sp_bgd(*,sort(shifts(shu))),hf
writefits,exdir(infile)+'multispint_dev.fts',sp_bgd(*,sort(shifts(shu)))*sqrt(double(n_elements(wy_bgd)))+$
sp_obj(*,sort(shifts(shu)))*sqrt(double(n_elements(wy_obj))),hf

end
