pro extra,wdir,ftype,yest,yfix=yfix,ext=ext,w=w,plot=plot,medfilt=medfilt

; extra,wdir,'starw',200.
if not(keyword_set(w)) then w=20.
if not(keyword_set(ext)) then ext='.fts'

ind=readfits(wdir+ftype+ext,h)

a=size(ind)
dl=sxpar(h,'CDELT1')  &  l0=sxpar(h,'CRVAL1')
l=dindgen(a[1])*dl+l0

wc=dblarr(a[1])
x=dindgen(a[1])
flux=dblarr(a[1])
y=dindgen(a[2])

; if not(keyword_set(yfix)) then begin
 for k=0,a[1]-1 do begin
   vec=reform(ind(k,*))
   c_tmp=max(vec,wc_tmp)
   wc[k]=wc_tmp
 endfor

ww1=where(abs(wc-yest) le w,nw1)
if nw1 eq 0 then yest=median(wc)
 x1=x(where(abs(wc-yest) le w))
 wc1=wc(where(abs(wc-yest) le w))

 wc_pars=goodpoly(x1,wc1,1,2.,wc_fit)
; endif else 
wc_fit=poly(x,wc_pars)

if keyword_set(yfix) then wc_fit=replicate(yest,a[1])

set_plot,'ps'
 device,filename=wdir+ftype+'_cen.ps',/land
  plot,x,wc,psym=2,yst=16,yrange=[-w,w]*2.+yest
  oplot,x,wc_fit
 device,/close
set_plot,'x'

for k=0,a[1]-1 do begin
  vec=reform(ind(k,*))*1.e17
  ww=where(abs(wc_fit[k]-y) le w)
  vec1=smooth(med_ext(vec,7),5)
  wb=where(vec gt vec1*1.5,nb)
  if nb gt 0 then vec(wb)=vec1(wb)

  gfit=gaussfit(y(ww),vec(ww),gpars,nter=5,estimates=[max(vec(ww))-min(vec(ww)),wc_fit[k],w/5.,min(vec(ww)),0.])*1.e-17
  flux[k]=total(vec(ww)-gpars[3]-0.*y(ww))*1.e-17            
  plot,y(ww),vec(ww)
  oplot,y(ww),gfit*1.e17,color=1000
  flux[k]=sqrt(2.D*!DPI)*gpars[0]*gpars[2]*1.e-17
;  if gpars[2] gt w/2. or flux[k] gt total(vec(ww))*1.e-17 then flux[k]=0.
  if flux[k] gt 1.e-10 then flux[k]=total(vec(ww)-gpars[3]-gpars[4]*y(ww))*1.e-17
endfor

if keyword_set(medfilt) then begin
  flum=smooth(med_ext(flux,5),5)
  flux(where(flux gt 1.5*flum or flux lt .5*flum,nch))=flum(where(flux gt 1.5*flum or flux lt .5*flum))
  print,nch,' points replaced'
endif

writefits,wdir+ftype+'_sp'+ext,flux,h

if keyword_set(plot) then begin
  lof=floor(alog10(max(flux)))+1.
  set_plot,'ps' 
   device,filename=wdir+ftype+'_sp.ps',/landscape,xsize=26,ysize=18,xoffset=1,yoffset=28
    plot,l,flux/(10.D)^lof,xst=1,yst=1,xrange=[min(l),max(l)],xtitle='!4k!3,'+string("305B),$
     yrange=[-.02,.5]*max(flux)/(10.D)^lof,ytitle='F!D!4k!3!N, 10!U'+string(lof,format='(I5)')$
	+'!N erg/cm!U2!Ns'+string("305B)
   device,/close
  set_plot,'x'
endif
end
