pro extra_max,wdir,ftype,ext=ext,medclean=medclean,slitsize=slitsize,logfile=logfile

w=20.
if not(keyword_set(ext)) then ext='.fts'

ima=readfits(wdir+ftype+ext,h)
; if max(ima)-min(ima) le 1.e-10 then m=1.e-17 else m=1.
m=abs(quantile(ima,0.75)-quantile(ima,0.25))

; if not(keyword_set(slitsize)) then slitsize=sxpar(h,'SLITWID')
if double(sxpar(h,'SLITWID')) ne 0. then slitsize=double(sxpar(h,'SLITWID'))

a=size(ima)
Nx=a[1]  &  Ny=a[2]
profile=total(ima(round(.25*Nx):round(.75*Nx),*),1)

dl=sxpar(h,'CDELT1')  &  dy=sxpar(h,'CDELT2')
l0=sxpar(h,'CRVAL1')  &  y0=sxpar(h,'CRVAL2')
l=dl*dindgen(a[1])+l0
y=dy*dindgen(a[2])+y0

bin=double(strsplit(sxpar(h,'BINNING'),'x',/ext))
w=w*2./bin[0]

mayx=max(profile,ymax)
wy=ymax-w+indgen(2*w)

if keyword_set(medclean) then for j=0,a[2]-1 do ima(*,j)=smooth(med_ext(reform(ima(*,j)),10),10)

flux=dblarr(a[1])  &  cent=dblarr(a[1]) &  fwhm=dblarr(a[1])
wkiller

for k=0,a[1]-1 do begin
 vec=reform(ima(k,wy))
 yfit=gaussfit(y(wy),vec/m,g,nterms=5)*m
  flux[k]=sqrt(2.*!DPI)*abs(g[2]*g[0])*m
 cent[k]=g[1]  &  fwhm[k]=abs(g[2])*sqrt(8.*alog(2.))
 plot,y(wy),vec
 oplot,y(wy),yfit,color=1000
endfor

; if slitsize gt 0. then renorm=flux_geom(logfile,slitsize,mapfile=def_par(logfile,'R_DIR')+$
;   def_par(logfile,'NIGTH')+def_par(logfile,'STARMAP')+'.FTS',/max) else renorm=1.
;
; if slitsize gt 0. then renorm=slitsize[0]/slitsize[1] else renorm=1.
renorm=1.

writefits,wdir+ftype+'_fwhm'+ext,fwhm,h
writefits,wdir+ftype+'_cent'+ext,cent,h
writefits,wdir+ftype+'_sp'+ext,flux*renorm,h

; PS - control output

set_plot,'ps'
  device,filename=wdir+ftype+'_extra.ps',/port,xsize=20,ysize=27,/color
   !p.multi=[0,1,3]
loadct,0
   plot,y,profile,xtitle='coordinate along slit',ytitle='total counts',xrange=[y[ymax-w],y[ymax+w]],$
     chars=2.,charth=3.,yrange=[0.,1.2*mayx]
loadct,27
 ;  oplot,[y[ymax],y[ymax]],[mayx,1.1*mayx],thick=3.,color=2000
   arrow,y[ymax],1.25*mayx,y[ymax],1.05*mayx,/data,color=1000,thick=3.
loadct,0   
   plot,l,flux,xtitle='!4k!3,'+string("305B),ytitle='Flux, counts',xst=1,yst=1,$
     chars=2.,charth=3.

   plot,l,cent,yst=1,xst=1,xtitle='!4k!3,'+string("305B),ytitle='Gaussian center',$
     chars=2.,charth=3.
!p.multi=0
  device,/close
set_plot,'x'

end
