function gau_ext,x,a
  y=gaussian(x,a,pder)
  return,[y,pder[0],pder[1],pder[2]]
end
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

pro extract_spectral_series,infile

wdir=exdir(infile)
ff=read_asc(wdir+'intspec_file.txt') & y0=ff[0] & dy=ff[1]-ff[0] & gau=ff[2]
ext='.fts'

dfon=2.*dy
yyy=dy

f=readfits(infile,hf,/sil)
field=[sxpar(hf,'FIELD1'),sxpar(hf,'FIELD2')]
a=size(f)
cube=reform(f,a[1],field[0],field[1])
ftot=total(cube,2)
if a[0] ne 2 then message,'Massaraxh! Wrong dimentions: the file is '+strtrim(string(a[0]),2)+'D.'
dl=sxpar(hf,'CDELT1')   &  l0=sxpar(hf,'CRVAL1')  &  nx=a[1]
l=dindgen(nx)*dl+l0
;dy=sxpar(hf,'CDELT2')   &  y0=sxpar(hf,'CRVAL2')  &  
ny=field[1]
y=dindgen(field[1])*sxpar(hf,'CDELT2')+sxpar(hf,'CRVAL2')

n=n_elements(l)

sp2=dblarr(n,field[0])
jd=dblarr(n)
    for q=0,field[0]-1 do begin

       dy=yyy
      objnor=reform(cube(*,q,*))
      m=1./stdev(objnor)
      spect=dblarr(n)
      cent=dblarr(n)
      fwhm=dblarr(n)


         ;&&&&&&&&&&&&&& cicl extrakcii spectra &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
         
          for k=0,n-1 do begin
           vec=reform(objnor(k,*))
           win=where(abs(y-y0) le dy)

          win=win(where(finite(vec(win))))

          wout=where(abs(y-y0) ge dy and abs(y-y0) le dfon+dy)
          yfon=goodpoly(y(wout),vec(wout),1,2.)
          yfit=gaussfit(y(win),(vec(win)-poly(y(win),yfon))*m,g0,nterms=3)/m  ;,$
               spect[k]=sqrt(2.*!DPI)*g0[2]*g0[0]/m
               cent[k]=g0[1]
               fwhm[k]=g0[2]*sqrt(8.*alog(2))

               if abs(g0[1]-y0) gt 20.*dy then begin
                  spect[k]=total(vec(win)-poly(y(win),yfon)) 
                  cent[k]=total((vec(win)-poly(y(win),yfon))*y(win))/spect[k]
                  fwhm[k]=sqrt(8.*alog(2.))*stdev((y(win)-cent[k])*(vec(win)-poly(y(win),yfon)))/(spect[k])
               endif

          endfor
cenpars=goodpoly(l,cent,2,1.,cenfit)
wpars=goodpoly(l,fwhm,2,3.,wfit)
 
spect_med=med_ext(spect,20)
set_plot,'ps'
 device,filename=wdir+'spectr_obj_cent'+strtrim(string(q,for='(I10)'),2)+'.ps',/enc,/color,/land,xsize=28,ysize=18,xoff=5,yoff=28
 plot,l,cent 
 oplot,l,cenfit,color=1000
 device,/close
 device,filename=wdir+'spectr_obj_fwhm'+strtrim(string(q,for='(I10)'),2)+'.ps',/enc,/color,/land,xsize=28,ysize=18,xoff=5,yoff=28
 plot,l,fwhm 
 oplot,l,wfit,color=1000
 device,/close

set_plot,'x'

;))))))))))))))))))))))))))))))))))))))))))))(((((((((((((((((((((((((((((((((((((

cent1=cent &  fwhm1=fwhm
dy0=dy

          for k=0,n-1 do begin
             y0=cenfit[k]
             dy=dy0/2.
             vec=reform(objnor(k,*))
             win=where(abs(y-y0) le dy)

             wout=where(abs(y-y0) ge dy and abs(y-y0) le dfon/2.+dy)
             yfon=goodpoly(y(wout),vec(wout),1,3.)
             vec1=vec(win)
             yfit=gaussfit(y(win),(vec(win)-poly(y(win),yfon))*m,g0,nterms=3,$
             estima=[max(vec1)*m,cenfit[k],fwhm[k]],chisq=chisq,sig=sig)/m
             amp=spect[k]*2.3548/(wfit[k]*sqrt(!DPI*2.))
             pars=[amp,cenfit[k],wfit[k]/2.3548]

             yfit=lmfit(y(win),vec(win)-poly(y(win),yfon),pars,fita=[1.,0.,1.],function_name='gau_ext',/double,convergence=conv,itmax=20)       ; ,[cenfit[k]],FWHM=[wfit[k]],/FIXpos,/FIXfwhm)

             spect[k]=sqrt(2.*!DPI)*pars[2]*pars[0] ;/m 
             cent1[k]=pars[1]
             fwhm1[k]=pars[2]*sqrt(8.*alog(2))

         endfor


 ;))))))))))))))))))))))))))))))))))))))))))))(((((((((((((((((((((((((((((((((((((
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
sp2(*,q)=spect
jd[q]=sxpar(hf,'JD'+strtrim(q,2))
set_plot,'ps'
 device,filename=exdir(infile)+'spectr_obj'+strtrim(string(q,for='(I10)'),2)+'.ps',/enc,/color,/land,xsize=28,ysize=18,xoff=5,yoff=28
 plot,l,spect,yrange=[min(spect),max(spect)]
device,/close
set_plot,'x'

writefits,wdir+'spectr_obj_'+strtrim(string(q,for='(I10)'),2)+'.fts',spect,hf

   endfor


dt=abs(median(jd-shift(jd,1)))
t0=jd[0]
sxaddpar,hf,'CRVAL2',t0
sxaddpar,hf,'CDELT2',dt
writefits,wdir+'cube_spect'+ext,sp2,hf
norm_multispect,wdir+'cube_spect'+ext,outfile=wdir+'cube_spect_norm'+ext


end
