;test ext
pro extraction,LOGFILE,DPOS=dpos,PLOT=plot,FWHM=fwhm,BIAS=bias,EXTR=extr
print,float(dpos)
if not(keyword_set(bias)) then bias=0
;extraction spectra


wdir=DEF_WDIR(LOGFILE)
obj=readfits(wdir+'obj_sky.fts',h,/silent)

Nx=sxpar(h,'NAXIS1') & Ny=sxpar(h,'NAXIS2')
y=findgen(Ny) & x=findgen(Nx)
d_lambda=sxpar(h,'CDELT1')
lambda=findgen(Nx)*d_lambda+sxpar(h,'CRVAL1')

Nobj=N_elements(dpos) & print,Nobj
spectra=fltarr(Nx,Nobj)
w=fltarr(Nobj)+FWHM/2
Ndeg=2
;correction bias
obj=obj-bias
;begin optimal extraction
if extr eq 0 then begin
print,'OPTIMAL EXTRACTION'
;create traectory
Npos=10 & wx=Nx/(Npos+1)
xpos=findgen(Npos)*wx+wx
if xpos(Npos-1)+wx gt Nx-1 then xpos(Npos-1)=Nx-wx-1
ypos=fltarr(Npos,Nobj) & FWHMpos=ypos
vector=fltarr(Ny)
for k=0,Npos-1 do begin
  vector(*)=total(obj(xpos(k)-wx:xpos(k)+wx,*),1)
  res=MULTIGAUS(y,vector,dpos,FWHM=w)
  ypos(k,*)=res.center
  FWHMpos(k,*)=res.FWHM
endfor
posfit=fltarr(Nx,Nobj)
FWHMfit=fltarr(Nx,Nobj)
;polynomial approximation
for k=0,Nobj-1 do begin
f=goodpoly(xpos,ypos(*,k),Ndeg,2)
for j=0,Ndeg do posfit(*,k)=posfit(*,k)+f(j)*x^j
f=goodpoly(xpos,FWHMpos(*,k),Ndeg,2)
for j=0,Ndeg do FWHMfit(*,k)=FWHMfit(*,k)+f(j)*x^j
endfor
;extraction spectra
eps=0
for k=eps,Nx-1-eps do begin
vector=total(obj(k-eps:k+eps,*),1)/(2*eps+1)
res=MULTIGAUS(y,vector,posfit(k,*),FWHM=FWHMfit(k,*),FIXpos=1,FIXfwhm=1)
spectra(k,*)=res.flux
endfor
	if keyword_set(plot) then begin
window,11
!P.multi=[0,1,2]
plot,[0,Nx],[min(dpos)-10,max(dpos)+10],$
	xst=1,yst=1,/nodata,title='traectory'
for k=0,Nobj-1 do begin
oplot,xpos,ypos(*,k),psym=k+5
oplot,x,posfit(*,k)
endfor
plot,[0,Nx],[0,20],xst=1,yst=1,/nodata,title='variation FWHM'
for k=0,Nobj-1 do begin
oplot,xpos,FWHMpos(*,k),psym=k+5
oplot,x,FWHMfit(*,k)
endfor
	endif
sxaddhist,'optimal extraction',h
endif   ; end optimal extraction

;begin extraction in strobe
if extr eq 1 then begin
print,'STROBE EXTRACTION'
w=float(FWHM(0))/2.
tra=replicate(dpos,Nx)             ; readfits(wdir+'traectory.fts',/silent)
tra_mean=tra(Nx/2)
for j=0,Nobj-1 do begin
for k=0,Nx-1 do begin
y=tra(k)  ;-tra_mean+dpos(j)
spectra(k,j)=total(obj(k,y-w:y+w,0),2)-median([reform(obj(k,0:y-w-1)),reform(obj(k,y+w+1:Ny-1))])
endfor& endfor
sxaddhist,'strobe extraction, width'+string(FWHM(0),format='(I2)')+' px',h
endif

sent=readfits(wdir+'sent.fts',/silent)
;correction extintion
Texp=sxpar(h,'EXPTIME')
Z=sxpar(h,'Z')
GAIN=sxpar(h,'GAIN')
for j=0,Nobj-1 do begin
spectra(*,j)=spectra(*,j)*GAIN/calc_ext(lambda,Z) ;/d_lambda/Texp
endfor
;plot result
if keyword_set(plot) then begin

; for k=0,Nobj-1 do spectra(*,k)=spectra(*,k)*sent(*,0)
window,12
!P.multi=[0,1,Nobj]
for k=0,Nobj-1 do begin
ymin=0 & ymax=max(spectra(*,k))
R=where(spectra(*,k) lt 0,ind) & if ind gt 1 then ymin=-ymax/20
plot,lambda, spectra(*,k ),yst=1,yrange=[ymin,ymax*1.05],$
	xst=1,title='object position along slit'$
	+string(dpos(k),format='(I4)')
endfor
!P.multi=[0,1,1]
endif
;determination units
s=''
for k=0,Nobj-1 do begin
a=string(dpos(k),format='(I3)')
if k gt 0 then a=','+a
s=s+a
endfor
s=strcompress(s)
sxaddpar,h,'UNITS','erg/cm^2/sec/A', BEFORE='YPOS'
sxaddpar,h,'POS_OBJ',s,after='YPOS',' POSITION EXTRACTED SPECTRA ALONG SLIT'
writefits,wdir+'obj_spect.fts',spectra,h
cont:
end
