function flux_geom,logfile,slitwidth,mapfile=mapfile,maxsearch=maxsearch

   wdir=def_par(logfile,'W_DIR')
   
  if not(keyword_set(mapfile)) then mapfile=wdir+'map_i.fts'
  map=readfits(mapfile,h)

; map=smooth(map,5)

am=size(map)

scale=strsplit(sxpar(h,'IMSCALE'),'x',/ext)
if n_elements(scale) le 1 then scale=[1,1]
xar=dindgen(am[1])*scale[0]
yar=dindgen(am[2])*scale[1]

ddx=12.
ddy=12.

loadct,0
window,/free,xsize=500,ysize=500
tvscl,-alog(rebin(map,am[1]/2,am[2]/2)),0,0,xsize=500,ysize=500,/cent
  contour,map,xar,yar,/nodata,/noer,/dev,pos=[0,0,500,500],xst=5,yst=5
ret:

     cursor,x,y,4,/data
     m=!MOUSE
     sw=long(m.button)                                         ; mouse click-type  

if sw eq 1 then begin
  c=[x,y]
  tvscl,-alog(rebin(map,am[1]/2,am[2]/2)),0,0,xsize=500,ysize=500,/cent
  contour,map,xar,yar,/nodata,/noer,/dev,pos=[0,0,500,500],xst=5,yst=5
;  c=[x*am[1],y*am[2]]/500.
loadct,27
  plots,c[0],c[1],psym=4,color=1000,/data
!p.color=1000
  oploterr,[c[0]],[c[1]],[ddx] ;,/data
  oploterx,[c[0]],[c[1]],[ddy] ;,/data
!p.color=-1
loadct,0
endif
if sw eq 4 then goto,fin
if sw eq 2 then begin
 read,inp,prompt='size change factor: '
 ddx=ddx*double(inp)
 ddy=ddy*double(inp)
; ddx=round(ddx/2.)*2 &  ddy=round(ddy/2.)*2
endif

goto,ret
fin:

sijz=[ddx,ddy]

; ddx=round(ddx/(2.*scale[0]))*2.
; ddy=round(ddy/(2.*scale[1]))*2.

win_x=where(abs(xar-c[0]) le ddx)
win_y=where(abs(yar-c[1]) le ddy)
wout_x=where(abs(xar-c[0]) ge ddx and abs(xar-c[0]) le ddx*2.)
wout_y=where(abs(yar-c[1]) ge ddy and abs(yar-c[1]) le ddy*2.)

bgd1=map(wout_x,*)
bgd1=bgd1(*,win_y)
bgd1=reform(bgd1,n_elements(bgd1))
bgd2=map(win_x,*)
bgd2=bgd1(*,wout_y)
bgd2=reform(bgd2,n_elements(bgd2))

map=map-median([bgd1,bgd2])

object=map(win_x,*)
object=object(*,win_y)

xo=xar(win_x)
yo=yar(win_y)

slitpos=def_par(logfile,'SLITPOS')

slit=total(object,1)

ao=size(object)

xoint=interpol(xo,dindgen(ao[1]),(dindgen(ao[1]*50)-25.)/50.)
obj_tmp=dblarr(ao[1]*50,ao[2])

if keyword_set(maxsearch) then begin
  obj_int=interpol(total(object,2),dindgen(ao[1]),(dindgen(ao[1]*50)-25.)/50.,/spline)
  maxv=max(obj_int,wmax)
  c[0]=interpol(xoint,(dindgen(ao[1]*50)-25.),wmax,/spline)
endif

for k=0,ao[2]-1 do begin
  slice_tmp=rebin(reform(object(*,k)),ao[1]*50,/sam)
  slit[k]=total(slice_tmp(where(abs(xoint-c[0]) lt slitwidth/2.)))/50.
  obj_tmp(*,k)=slice_tmp*(abs(xoint-c[0]) lt slitwidth/2.)/50.
endfor

message,'integration box '+strtrim(string(sijz[0]*2.,format='(F5.2)'),2)+'x'+strtrim(string(sijz[1]*2.,format='(F5.2)'),2),/cont
message,'flux renormalization factor: '+strtrim(string(total(object)/total(slit),format='(F8.3)'),2),/cont

return,total(object)/total(slit)
end
