pro imre_light,log

overscan=[20,-20]  &  thresh=3.  &  idldir='~/idllib/scorpio_2K.lib/'

night=def_par(log,'night')
ext=def_par(log,'ext')
indir=def_rdir(log)
wdir=def_wdir(log)
 objfile=strtrim(def_name(log,'obj'),2)
 flatfile=strtrim(def_name(log,'flat'),2)

objfile=indir+objfile+ext
flatfile=indir+flatfile+ext

;;print,objfile,neonfile

;; *** primary reduction: ***

 flat=readfits(flatfile,hn,/sil)
 an=size(flat)
if an[0] gt 1 then begin
  gain_flat=sxpar(hn,'GAIN')
  flatmed=med_xy(flat,17)
  wcos=where(flat gt flatmed+sqrt(flatmed)*thresh,ncos)
  if ncos gt 0 then flat(wcos)=flatmed(wcos)

  if overscan[0] gt 0 and overscan[1] gt 0 then mover_flat=median([reform(flat(0:overscan[0]-1,*),overscan[0]*an[2]),reform(flat(*,0:overscan[1]-1),-overscan[1]*an[1])])
  if overscan[0] lt 0 and overscan[1] gt 0 then mover_flat=median([reform(flat(an[1]+overscan[0]-1:an[1]-1,*),overscan[0]*an[2]),reform(flat(*,0:overscan[1]-1),-overscan[1]*an[1])])
  if overscan[0] gt 0 and overscan[1] lt 0 then mover_flat=median([reform(flat(0:overscan[0]-1,*),overscan[0]*an[2]),reform(flat(*,an[2]+overscan[1]:an[2]-1),-overscan[1]*an[1])])
  if overscan[0] lt 0 and overscan[1] lt 0 then mover_flat=median([reform(flat(an[1]+overscan[0]-1:an[1]-1,*),overscan[0]*an[2]),reform(flat(*,an[2]+overscan[1]-1:an[2]-1),-overscan[1]*an[1])])
endif else begin

 message,'No appropriate flatfield found',/cont
endelse
;

;; object:

if n_elements(objfile) eq 1 then begin
  obj=readfits(objfile,hdr0,/sil)
  hdr=hdr0
endif else begin
  profile=n_elements(obj)
  nf=n_elements(objfile)

  f0=readfits(objfile[0],hdr0,/sil)
  ao=size(f0)
  p11=floor(ao[1]*3./8.)  &  p12=floor(ao[1]*5./8.)
  p21=floor(ao[2]*3./8.)  &  p22=floor(ao[2]*5./8.)

dra0=ratos(sxpar(hdr0,'RA'))  &  ddec0=detos(sxpar(hdr0,'DEC'))

  hdr=strarr(n_elements(hdr0),nf)
  f=dblarr(ao[1],ao[2],nf)  &   dx=dblarr(nf)  &  dy=dblarr(nf)
  f(*,*,0)=f0   &   hdr(*,0)=hdr0
f0s=med_xy(f0,3)-smooth(f0,17)

ptb0=sxpar(hdr0,'ROTANGLE')  &    para0=sxpar(hdr0,'PARANGLE')
    posang0=sxpar(hdr0,'PARANGLE')-sxpar(hdr0,'ROTANGLE')+131.

scale=strsplit(sxpar(hdr0,'IMSCALE'),'x',/ext)

shiftest=dblarr(nf,2)
shiftest(0,*)=0.

  for k=1,nf-1 do begin
    ftmp=readfits(objfile[k],hdrk,/sil)
     dra=ratos(sxpar(hdrk,'RA'))  &  ddec=detos(sxpar(hdrk,'DEC'))
    ptbk=sxpar(hdrk,'ROTANGLE')
    parak=sxpar(hdrk,'PARANGLE')
    posang=sxpar(hdrk,'PARANGLE')-sxpar(hdrk,'ROTANGLE')+131.
    dx0=((dra-dra0)*cos(posang0*!DPI)*cos((ddec+ddec0)*0.5*3600.*!DPI)+(ddec-ddec0)*sin(posang0*!DPI))/scale[0]
    dy0=((dra-dra0)*sin(posang0*!DPI)*cos((ddec+ddec0)*0.5*3600.*!DPI)+(ddec-ddec0)*cos(posang0*!DPI))/scale[1]
     if abs(posang-posang0) ge 2. then ftmp=rot(ftmp,(posang-posang0),missing=1.,/piv)
    comtmp=sxpar(hdrk,'COMMENT')
    comwx=strpos(comtmp,'dX')>strpos(comtmp,'dx')   &  comwy=strpos(comtmp,'dY')>strpos(comtmp,'dy')
    shiftest(k,*)=shiftest(k-1,*)
    if comwx>comwy ge 0 then begin
        shiftest(k,*)=[dx0,dy0]
    endif
    ftmp1=shift_image(ftmp,-dx[k],-dy[k])
;    shift=shiftest(k,*)
 ;;;    corf=corr2d(f0,ftmp1,(dindgen(10)-5.)*2.,maxx=maxx,maxy=maxy)
  shifts=(dindgen(31)-15.)*2.+1.
ftmp1s=med_xy(ftmp1,3)-smooth(ftmp1,17)
  corf=correl_images(f0s(p11:p12,p21:p22),ftmp1s(p11:p12,p21:p22),red=2,xshift=30,yshift=30)

  corfx=total(corf,2)   &   corfy=total(corf,1)

  maxxv=max(corfx,wmaxx)
  maxyv=max(corfy,wmaxy)

   gfitx=gaussfit(shifts((wmaxx-5)>0:(wmaxx+5)<n_elements(shifts)-1),corfx((wmaxx-5)>0:(wmaxx+5)<n_elements(shifts)-1),gx,nterm=3,est=[maxxv,shifts[wmaxx],3.])
   gfity=gaussfit(shifts((wmaxx-5)>0:(wmaxx+5)<n_elements(shifts)-1),corfy((wmaxx-5)>0:(wmaxx+5)<n_elements(shifts)-1),gy,nterm=3,est=[maxyv,shifts[wmaxy],3.])
;   pfitx=goodpoly(shifts((wmaxx-4)>0:(wmaxx+4)<16),corfx((wmaxx-4)>0:(wmaxx+4)<16),2,2.)   &    pfity=goodpoly(shifts((wmaxy-4)>0:(wmaxy+4)<16),corfy((wmaxy-4)>0:(wmaxy+4)<16),2,2.)

    dx[k]=dx[k]-shifts[wmaxx]  &   dy[k]=dy[k]-shifts[wmaxy]
    ftmp1=shift_image(ftmp,-dx[k],-dy[k])
     f(*,*,k)=ftmp1
    hdr(*,k)=hdrk
  endfor

  obj=total(f,3)
  hdr=add_header(hdr) 
endelse

    gain_obj=sxpar(hdr0,'GAIN')
  ao=size(obj)
  objmed=med_xy(obj,7)

if overscan[0] gt 0 and overscan[1] gt 0 then mover_obj=median([reform(obj(0:overscan[0]-1,*),overscan[0]*ao[2]),reform(obj(*,0:overscan[1]-1),-overscan[1]*ao[1])])
if overscan[0] lt 0 and overscan[1] gt 0 then mover_obj=median([reform(obj(ao[1]+overscan[0]-1:ao[1]-1,*),overscan[0]*ao[2]),reform(obj(*,0:overscan[1]-1),-overscan[1]*ao[1])])
if overscan[0] gt 0 and overscan[1] lt 0 then mover_obj=median([reform(obj(0:overscan[0]-1,*),overscan[0]*ao[2]),reform(obj(*,ao[2]+overscan[1]:ao[2]-1),-overscan[1]*ao[1])])
if overscan[0] lt 0 and overscan[1] lt 0 then mover_obj=median([reform(obj(ao[1]+overscan[0]-1:ao[1]-1,*),overscan[0]*ao[2]),reform(obj(*,ao[2]+overscan[1]-1:ao[2]-1),-overscan[1]*ao[1])])

  wcos=where(obj gt objmed+sqrt(objmed)*thresh,ncos)
  if ncos gt 0 then obj(wcos)=objmed(wcos)

  obj=(obj(overscan[0] > 0:(ao[1]-1+overscan[0])<(ao[1]-1),overscan[1] > 0:(ao[2]-1+overscan[1])<(ao[2]-1))-mover_obj)*gain_obj >1.
 if an[0] gt 1 then flat=(flat(overscan[0] > 0:(an[1]-1+overscan[0])<(an[1]-1),overscan[1] > 0:(an[2]-1+overscan[1])<(an[2]-1))-mover_flat)*gain_flat else flat=obj*0.+1.

obj0=obj
if an[0] ne 0 then obj=obj/flat
ao=size(obj)

  wkiller
  window,retain=2
  tvscl,-alog(rebin(obj(0:floor(double(ao[1])/2.)*2-1,0:floor(double(ao[2])/2.)*2-1),floor(double(ao[1])/2.),floor(double(ao[2])/2.)))
xyouts,0.4,0.9,'Object: '+strtrim(sxpar(hdr,'OBJECT'),2),/norm,charsize=2.,charthick=2.5,color=1000
xyouts,0.4,0.8,'Exposure time '+strtrim(string(sxpar(hdr,'EXPTIME'),for='(I10)'),2)+'s',/norm,charsize=2.,charthick=2.5,color=1000
xyouts,0.4,0.7,'filter: '+strcompress(sxpar(hdr,'FILTER')+' '+sxpar(hdr,'FILTERS')),/norm,charsize=2.,charthick=2.5,color=1000

set_plot,'ps'
 device,file=wdir+'obj_ima.eps',/color,/port,xoffset=3,yoffset=2
loadct,0,/sil
;;  tvscl,-alog(rebin(obj(0:floor(double(ao[1])/2.)*2-1,0:floor(double(ao[2])/2.)*2-1),floor(double(ao[1])/2.),floor(double(ao[2])/2.)))
  contour,-alog(rebin(obj(0:floor(double(ao[1])/2.)*2-1,0:floor(double(ao[2])/2.)*2-1)*flat(0:floor(double(ao[1])/2.)*2-1,0:floor(double(ao[2])/2.)*2-1),floor(double(ao[1])/2.),floor(double(ao[2])/2.))),nlev=100,$
    /fill,xst=5,yst=5,/iso
loadct,33,/sil
  xyouts,0.4,0.9,'Object: '+strtrim(sxpar(hdr,'OBJECT'),2),/norm,charsize=1.5,charthick=3.5,color=200
  xyouts,0.4,0.8,'Exposure time '+strtrim(string(sxpar(hdr,'EXPTIME'),for='(I10)'),2)+'s',/norm,charsize=1.5,charthick=3.5,color=200
  xyouts,0.4,0.7,'filter: '+strcompress(sxpar(hdr,'FILTER')+' '+sxpar(hdr,'FILTERS')),/norm,charsize=1.5,charthick=3.5,color=200
  contour,rebin(obj0(0:floor(double(ao[1])/2.)*2-1,0:floor(double(ao[2])/2.)*2-1),floor(double(ao[1])/2.),floor(double(ao[2])/2.)),/over,lev=[1000,10000,50000],c_thick=3.,c_color=230,c_lab=[1,1,1]
  xyouts,0.5,0.01,'isophotes at 10!U3!N, 10!U4!N and 5X10!U4!N counts',color=250,charsize=0.8,/norm,charthick=2.
loadct,0,/sil
 device,/close
if os_family() eq 'unix' then set_plot,'x' else set_plot,'win'

  writefits,wdir+'obj_ima.fts',obj,hdr0
end
