function gau_ext,x,a
  y=gaussian(x,a,pder)
  return,[y,pder[0],pder[1],pder[2]]
end

pro intspectrum,infile,y0,dy,out=out,log=log,map=map,nobgd=nobgd,gauss=gauss,smooth=smooth,dfon=dfon,plot=plot,wr=wr

if not(keyword_set(out)) then out='obj_spect'
if not(keyword_set(log)) then log=pickfile()
if not(keyword_set(dfon)) then dfon=2.*dy
if (keyword_set(gauss)) then y3=1 else y3=0

if strpos(infile,'d',/reverse_search) lt strpos(infile,'/',/reverse_search) and keyword_set(wr) then begin
 y1=y0
 y2=y0+dy
if keyword_set(gauss) then y3=1 else y3=0
 wdir=def_par(log,'W_DIR')
 openw,uni,wdir+'intspec_file.txt',/get_lun
 printf,uni,y1,y2,y3
 close,uni
endif
wdir=exdir(infile)
ima=readfits(infile,him)

www=where(finite(ima,/nan),numbersw) 
 if  numbersw gt 0. then ima[www]=mean(ima(where(finite(ima))))

; dy=sxpar(him,'CDELT2')  &  y0=sxpar(him,'CRVAL2')

a=size(ima)
x=dindgen(a[1])
y=dindgen(a[2])*sxpar(him,'CDELT2')+sxpar(him,'CRVAL2')
ddy=sxpar(him,'CDELT2')
l=x*sxpar(him,'CDELT1')+sxpar(him,'CRVAL1')
spect=dblarr(a[1])
cent=dblarr(a[1])
fwhm=dblarr(a[1])

if keyword_set(smooth) then begin
 ima1=ima
 for k=0,a[1]-1 do begin
  ima1(k,*)=smooth(reform(ima(k,*)),3)
 endfor
 ima=ima1
endif

m=1./stdev(ima)
print,stdev(ima)

if keyword_set(plot) then begin
 wkiller
 window,0,xsize=1000,ysize=500
endif

for k=0,a[1]-1 do begin
  vec=reform(ima(k,*))
;  nanwww=where(vec*0. ne 0.,nnan)
;  if nnan gt 0 then vec(nanwww)=0.
  win=where(abs(y-y0) le dy)

  win=win(where(finite(vec(win))))
  ;vec=vec(where(finite(vec)))
  wout=where(abs(y-y0) ge dy and abs(y-y0) le dfon+dy)
  ;wout=wout(where(finite(vec(wout))))
 ; print,wout
  yfon=goodpoly(y(wout),vec(wout),1,2.)

; if not(keyword_set(gauss)) then begin
;
;  spect[k]=total(vec(win)-poly(y(win),yfon))*ddy  ;*double(not(keyword_set(nobgd)) ge 0.))
; ; if l[k] gt 4861. then message,'!'
; if strpos(infile,'dobj') gt -0.5 then spect[k]=spect[k]/sqrt(double(n_elements(win)))
;  plot,y,vec,xrange=[(-dfon+y0)>min(y),(dfon+y0)<max(y)],title='wavelength='+strtrim(string(l[k]),2)+string("305B),/xst ;,yrange=[min(ima(*,win)),max(ima(*,win))]
;  oplot,y,yfon[0]+yfon[1]*y,color=1000
;  for qq=0,100 do oplot,[-dy,dy]+y0,[max(vec),max(vec)],thick=5.
;  cent[k]=total((vec(win)-poly(y(win),yfon))*y(win))*ddy/spect[k]
;  fwhm[k]=sqrt(8.*alog(2.))*stdev((y(win)-cent[k])*(vec(win)-poly(y(win),yfon)))*ddy/(spect[k])
;
; endif else begin
 ; vec1=med_ext(vec(win),3)
  yfit=gaussfit(y(win),(vec(win)-poly(y(win),yfon))*m,g0,nterms=3)/m  ;,$
   ;  estimates=[max(vec(win)-poly(y(win),yfon))*m,median(y(win)),dy/5.])/m
  ; print,g0
  
  if (keyword_set(plot)) then begin 
   plot,y,vec,xrange=[(-dfon+y0)>min(y),(dfon+y0)<max(y)],title='wavelength='+strtrim(string(l[k]),2)+string("305B),/xst ;,yrange=[min(ima(*,win)),max(ima(*,win))]
   oplot,y(win),yfit+poly(y(win),yfon),color=1000
   oplot,y,poly(y,yfon),color=-1000
   oplot,[-dy,dy]+y0,[max(vec),max(vec)],thick=5.
   for qq=0,100 do oplot,y(win),yfit,color=1000
  
  endif
  spect[k]=sqrt(2.*!DPI)*g0[2]*g0[0]/m
  cent[k]=g0[1]
  fwhm[k]=g0[2]*sqrt(8.*alog(2))
  if abs(g0[1]-y0) gt 20.*dy then begin
    spect[k]=total(vec(win)-poly(y(win),yfon)) 
    cent[k]=total((vec(win)-poly(y(win),yfon))*y(win))/spect[k]
    fwhm[k]=sqrt(8.*alog(2.))*stdev((y(win)-cent[k])*(vec(win)-poly(y(win),yfon)))/(spect[k])
   endif
; endelse
endfor

cenpars=goodpoly(l,cent,2,1.,cenfit)
wpars=goodpoly(l,fwhm,2,3.,wfit)

spect_med=med_ext(spect,20)

;; 2nd cycle:


cent1=cent &  fwhm1=fwhm
dy0=dy

for k=0,a[1]-1 do begin
 if keyword_set(gauss) then y0=cenfit[k]
  dy=dy0/2.
  vec=reform(ima(k,*))
  win=where(abs(y-y0) le dy)

  wout=where(abs(y-y0) ge dy and abs(y-y0) le dfon/2.+dy)
  yfon=goodpoly(y(wout),vec(wout),1,3.)

 if not(keyword_set(gauss)) then begin

if out eq 'dsp' then spect[k]=total(vec(win))*ddy else spect[k]=total(vec(win)-poly(y(win),yfon))*ddy
 ;spect[k]=total(vec(win)-poly(y(win),yfon))*ddy
 ; if l[k] gt 4861. then message,'!'
 if strpos(infile,'dobj') gt -0.5 then spect[k]=spect[k]/sqrt(double(n_elements(win)))
if (keyword_set(plot)) then begin
  plot,y,vec,xrange=[-dy,dy]+y0,xst=1,title='wavelength='+strtrim(string(l[k]),2)+string("305B)
  oplot,y,yfon[0]+yfon[1]*y,color=1000
 endif
  cent1[k]=total((vec(win)-poly(y(win),yfon))*y(win))/spect[k]
  fwhm1[k]=sqrt(8.*alog(2.))*stdev((y(win)-cent[k])*(vec(win)-poly(y(win),yfon)))/(spect[k])

 endif else begin
  vec1=vec(win)
  yfit=gaussfit(y(win),(vec(win)-poly(y(win),yfon))*m,g0,nterms=3,$
     estima=[max(vec1)*m,cenfit[k],fwhm[k]],chisq=chisq,sig=sig)/m
     amp=spect[k]*2.3548/(wfit[k]*sqrt(!DPI*2.))
;     amp=max(slil)
     pars=[amp,cenfit[k],wfit[k]/2.3548]
     yfit=lmfit(y(win),vec(win)-poly(y(win),yfon),pars,fita=[1.,0.,1.],function_name='gau_ext',/double,convergence=conv,itmax=20)       ; ,[cenfit[k]],FWHM=[wfit[k]],/FIXpos,/FIXfwhm)
  if (keyword_set(plot)) then begin
    plot,y,vec,xrange=[-dy,dy]*2.+y0,xst=1,title='wavelength='+strtrim(string(l[k]),2)+string("305B),/yst
    oplot,y(win),yfit+poly(y(win),yfon),color=1000
    for qq=0,100 do oplot,y(win),poly(y(win),yfon),color=109900
  endif
; if abs(spect[k]-sqrt(2.*!DPI)*pars[2]*pars[0]) lt spect_med[k]*100. then
 spect[k]=sqrt(2.*!DPI)*pars[2]*pars[0] ;/m 
  cent1[k]=pars[1]
  fwhm1[k]=pars[2]*sqrt(8.*alog(2))
 endelse
endfor

if out eq 'dsp' then spect=spect/sqrt(wfit/ddy)

if (keyword_set(plot)) then begin
set_plot,'ps'
 device,filename=wdir+out+'.ps',/land
  plot,l,spect,xst=1,yst=1,xrange=[min(l),max(l)],yrange=[min(med_ext(spect(where(finite(spect))),5)),max(med_ext(spect(where(finite(spect))),5))],$
    xtitle='!4k!3,'+string("305B),ytitle='F!D!4k!3!N, erg/cm!U2!Ns'+string("305B)
 device,/close
;if keyword_set(gauss) then begin 
 device,filename=wdir+out+'_cent.ps',/land,/color
loadct,0,/sil
  plot,l,cent,xst=1,yst=1,xrange=[min(l),max(l)],yrange=[min(med_ext(cent(where(finite(spect))),5)),max(med_ext(cent(where(finite(spect))),5))],$
    xtitle='!4k!3,'+string("305B),ytitle='y, arcsec'
loadct,27,/sil
  oplot,l,cenfit,color=1000
loadct,0,/sil
 device,/close 
 device,filename=wdir+out+'_fwhm.ps',/land
loadct,0,/sil
  plot,l,fwhm,xst=1,yst=1,xrange=[min(l),max(l)],yrange=[min(med_ext(fwhm(where(finite(spect))),5)),max(med_ext(fwhm(where(finite(spect))),5))],$
    xtitle='!4k!3,'+string("305B),ytitle='y, arcsec'
loadct,27,/sil
  oplot,l,wfit,color=1000
loadct,0,/sil
 device,/close 
;endif
set_plot,'x'
endif

slit=def_par(log,'SLITSIZE')
renorm=1. ;flux_geom(log,slit[0],map=map,/maxsearch)

sxaddpar,him,'RENORM',renorm,'flux renormalization factor'
writefits,wdir+out+'.fts',spect,him

dy=dy0

wkiller
end
