pro intspectrum_multigauss,infile,y0,dy,log=log,dfon=dfon,plot=plot,out=out

if not(keyword_set(dfon)) then dfon=2.*dy
if not(keyword_set(out)) then out='obj_spect'
 wdir=def_par(log,'W_DIR')

;------------------------------------------
 y1=y0
 y2=y0+dy
 y3=1
 wdir=def_par(log,'W_DIR')
 openw,uni,wdir+'intspec_file.txt',/get_lun
 printf,uni,y1,y2,y3
 close,uni
;-----------------------------------------------

f=readfits(infile,hf)
a=size(f)
dl=sxpar(hf,'CDELT1') & l0=sxpar(hf,'CRVAL1')
l=dindgen(a[1])*dl+l0

y=dindgen(a[2])*sxpar(hf,'CDELT2')+sxpar(hf,'CRVAL2')

n=a[1]

cent=dblarr(2,n) & dcent=dblarr(2,n)
fwhm=dblarr(2,n) & dfwhm=dblarr(2,n)
flux=dblarr(2,n) & dflux=dblarr(2,n)

set_plot,'x'
wkiller
for k=0,n-1 do begin
  vec=reform(f(k,*))
  win=where(abs(y-y0) le dy)

  wout=where(abs(y-y0) ge dy and abs(y-y0) le dfon/2.+dy)
  yfon=goodpoly(y(wout),vec(wout),1,3.)
  y1=y(win)
res=multigaus(y1,vec(win)-yfon[0]-yfon[1]*y1,[y0-3.,y0+3],yfit=spfit,lim_fwhm=[1.,7.])
fwhm(*,k)=[res.fwhm]
cent(*,k)=[res.center]
if keyword_set(plot) then begin
plot,y1,vec(win)
oplot,y1,spfit+yfon[0]+yfon[1]*y1,color=1000
oplot,y(wout),yfon[0]+yfon[1]*y1,color=-1000
endif
endfor

fwhm1=goodpoly(l,reform(fwhm(1,*)),2,3,wfit1)
fwhm0=goodpoly(l,reform(fwhm(0,*)),2,3,wfit0)
cent1=goodpoly(l,reform(cent(1,*)),2,3,cenfit1)
cent0=goodpoly(l,reform(cent(0,*)),2,3,cenfit0)

;&&&&&&&00000&&&&&&&&&& %%%%%%%%% &&&&&&&&&*****88888888*******&&&&&&&&& %%%%%%%%% &&&&&&&&00000&&&&&&&&&

for k=0,n-1 do begin
  vec=reform(f(k,*))
  win=where(abs(y-y0) le dy)

  wout=where(abs(y-y0) ge dy and abs(y-y0) le dfon/2.+dy)
  yfon=goodpoly(y(wout),vec(wout),1,3.)
  y1=y(win)
  yc1=cenfit1(k) & yc0=cenfit0(k)
  
  res=multigaus(y1,vec(win)-yfon[0]-yfon[1]*y1,[yc0,yc1],yfit=spfit,fwhm=[wfit0(k),wfit1(k)],lim_fwhm=[1.,7.],sigma=sign)
      fwhm(*,k)=[res.fwhm]   &   dfwhm(*,k)=sign.fwhm
      cent(*,k)=[res.center]   &   dcent(*,k)=sign.center
      flux(*,k)=[res.flux]   &   dflux(*,k)=sign.flux
if keyword_set(plot) then begin
plot,y1,vec(win)
oplot,y1,spfit+yfon[0]+yfon[1]*y1,color=1000
oplot,y(wout),yfon[0]+yfon[1]*y1,color=-1000
endif
endfor

;888888888888888888 UUUUUUUUUUUUUUU 8888888888888888888888888

fl0=flux(0,*) & fl1=flux(1,*)
dfl0=dflux(0,*) & dfl1=dflux(1,*)
cen0=cent(0,*) & cen1=cent(1,*)
fw0=fwhm(0,*) & fw1=fwhm(1,*)

; ------------------- KARTINKI ------------------------

if (keyword_set(plot)) then begin
set_plot,'ps'
 device,filename=wdir+out+'0.ps',/land
  plot,l,fl0,xst=1,yst=1,xrange=[min(l),max(l)],yrange=[min(med_ext(fl0(where(finite(fl0))),5)),max(med_ext(fl0(where(finite(fl0))),5))],$
    xtitle='!4k!3,'+string("305B),ytitle='F!D!4k!3!N, erg/cm!U2!Ns'+string("305B)
  oploterr,l,fl0,dfl0,3
 device,/close
 device,filename=wdir+out+'1.ps',/land
  plot,l,fl1,xst=1,yst=1,xrange=[min(l),max(l)],yrange=[min(med_ext(fl1(where(finite(fl1))),5)),max(med_ext(fl1(where(finite(fl1))),5))],$
    xtitle='!4k!3,'+string("305B),ytitle='F!D!4k!3!N, erg/cm!U2!Ns'+string("305B)
  oploterr,l,fl1,dfl1,3
 device,/close

 device,filename=wdir+out+'0_cent.ps',/land,/color
loadct,0,/sil
  plot,l,cen0,xst=1,yst=1,xrange=[min(l),max(l)],yrange=[min(med_ext(cen0(where(finite(fl0))),5)),max(med_ext(cen0(where(finite(fl0))),5))],$
    xtitle='!4k!3,'+string("305B)
loadct,27,/sil
  oplot,l,cenfit0,color=1000
loadct,0,/sil
 device,/close 

device,filename=wdir+out+'1_cent.ps',/land,/color
loadct,0,/sil
  plot,l,cen1,xst=1,yst=1,xrange=[min(l),max(l)],yrange=[min(med_ext(cen1(where(finite(fl1))),5)),max(med_ext(cen1(where(finite(fl1))),5))],$
    xtitle='!4k!3,'+string("305B)
loadct,27,/sil
  oplot,l,cenfit1,color=1000
loadct,0,/sil
 device,/close 

 device,filename=wdir+out+'0_fwhm.ps',/land
loadct,0,/sil
  plot,l,fw0,xst=1,yst=1,xrange=[min(l),max(l)],yrange=[min(med_ext(fw0(where(finite(fl0))),5)),max(med_ext(fw0(where(finite(fl0))),5))],$
    xtitle='!4k!3,'+string("305B)
loadct,27,/sil
  oplot,l,wfit0,color=1000
loadct,0,/sil
 device,/close 
 device,filename=wdir+out+'1_fwhm.ps',/land
loadct,0,/sil
  plot,l,fw1,xst=1,yst=1,xrange=[min(l),max(l)],yrange=[min(med_ext(fw1(where(finite(fl1))),5)),max(med_ext(fw1(where(finite(fl0))),5))],$
    xtitle='!4k!3,'+string("305B)
loadct,27,/sil
  oplot,l,wfit1,color=1000
loadct,0,/sil
 device,/close 
set_plot,'x'
endif
;---------------------------------------------------------------------------
writefits,wdir+out+'0.fts',reform(flux(0,*)),hf
writefits,wdir+out+'1.fts',reform(flux(1,*)),hf

wkiller
end
