pro linall_sco,wdir,file=file,llist=llist,av=av

if not(keyword_set(file)) then file='obj_spect.fts'

if not(keyword_set(av)) then av=1.24 ;  especially for MF16
spect_unred,wdir+file,wdir+'spect_unred.fts',/nodeb,av=av 
sp=readfits(wdir+file,hsp)
larray=dindgen(n_elements(sp))*sxpar(hsp,'CDELT1')+sxpar(hsp,'CRVAL1')
z=sxpar(hsp,'REDSHIFT')
objname=sxpar(hsp,'OBJECT')

if not(keyword_set(llist)) then llist=[4101.33,4685.7,4861.33,4958.91,5006.84,$
  5200.7,4471.48,4658.1,5411.524,5158.,3967.5]  ;,4068.62]
llist=llist(where(llist gt min(larray)-15. and llist lt max(larray)+15.))
flust=dblarr(n_elements(llist))
flust_unred=dblarr(n_elements(llist))
dflust=dblarr(n_elements(llist))
dflust_unred=dblarr(n_elements(llist))
stol=dblarr(n_elements(llist))
stol_unred=dblarr(n_elements(llist))
vels=dblarr(n_elements(llist))
dvels=dblarr(n_elements(llist))
fwhms=dblarr(n_elements(llist))  &  dfwhms=dblarr(n_elements(llist))
for k=0,n_elements(llist)-1 do begin
  span,wdir+file,[llist[k]],flux=flutmp,ston=stotmp,velt=veltmp,fwhm=fwhm_tmp,$
       dvelt=dveltmp,dflux=dflutmp,dfwhm=dfwhm_tmp
  spawn,'cp '+wdir+'span.ps '+wdir+'span_'+strtrim(string(llist[k],format='(I10)'),2)+'.ps'
  vels[k]=veltmp  &  dvels[k]=dveltmp  &  fwhms[k]=fwhm_tmp
  flust[k]=flutmp  & dflust[k]=dflutmp  &  stol[k]=stotmp &  dfwhms[k]=dfwhm_tmp
  span,wdir+'spect_unred.fts',[llist[k]],flux=flutmp,ston=stotmp,dflux=dflutmp
  flust_unred[k]=flutmp  & dflust_unred[k]=dflutmp  &  stol_unred[k]=stotmp
endfor
close,1

  span,wdir+file,[4340.74,4363.53],flux=fluhg,ston=stohg,velt=velhg,fwhm=fwhm_hg,$
       dvelt=dvelhg,dflux=dfluhg,dfwhm=dfwhm_hg
  spawn,'cp '+wdir+'span.ps '+wdir+'span_hg.ps'
  vels=[vels,velhg]  &  dvels=[dvels,velhg]  &  fwhms=[fwhms,fwhm_hg]
  flust=[flust,fluhg]  & dflust=[dflust,dfluhg]  &  stol=[stol,stohg] &  dfwhms=[dfwhms,dfwhm_hg]
  span,wdir+'spect_unred.fts',[4340.74,4363.53],flux=fluhg,ston=stohg,dflux=dfluhg
  flust_unred=[flust_unred,fluhg]  & dflust_unred=[dflust_unred,dfluhg]  &  stol_unred=[stol_unred,stohg]
llist=[llist,4340.74,4363.53]

sist=sort(llist)
flust=flust(sist)  &  flust_unred=flust_unred(sist)
dflust=dflust(sist)  &  dflust_unred=dflust_unred(sist)
vels=vels(sist)  &  dvels=dvels(sist)  &  fwhms=fwhms(sist) &  dfwhms=dfwhms(sist)
llist=llist(sist)

hb_tmp=min(abs(llist-4861.33),hbeta) ; &  ha_tmp=min(abs(llist-6562.82),halpha)

; av=1.24  ;hahb_to_av([flust[halpha]/flust[hbeta]])

openw,1,wdir+'linepars.tex'
printf,1,'\documentclass[12]{article}'
printf,1,'\usepackage{times}'
printf,1,'\textwidth=170mm'
printf,1,'\textheight=230mm'
printf,1,'\topmargin=-10mm'
printf,1,'\begin{document}'
printf,1,''
printf,1,'\title{'+objname+' emission lines intensities, $A_V \simeq '+strtrim(string(av,format='(F5.2)'),2)+'$}'
printf,1,'\maketitle'
printf,1,''
printf,1,'\center{'
printf,1,'\begin{tabular}{lcccc}'
printf,1,'$\lambda,\AA$ & $F(\lambda)/F(H_\beta)$ & $F(\lambda)/F(H_\beta)$ & $V,km/s$ & $FWHM, \rm \AA$\\'
printf,1,' & & (unreddened) & \\'
for k=0,n_elements(llist)-1 do begin
  printf,1,string(llist[k])+'&'+strtrim(string(flust[k]/flust[hbeta],format='(F7.3)'),2)+'$\pm$'+$
          strtrim(string(dflust[k]/flust[hbeta],format='(F7.3)'),2)+'&'+$
          strtrim(string(flust_unred[k]/flust_unred[hbeta],format='(F7.3)'),2)+'$\pm$'+$
          strtrim(string(dflust_unred[k]/flust_unred[hbeta],format='(F7.3)'),2)+$
          '&'+strtrim(string(vels[k],format='(F8.0)'),2)+'$\pm$'+$
	   strtrim(string(dvels[k],format='(F8.0)'),2)+$
          '&'+strtrim(string(fwhms[k],format='(F8.1)'),2)+'$\pm$'+$
           strtrim(string(dfwhms[k],format='(F7.1)'),2)+'\\'
endfor
printf,1,'\end{tabular}}'
printf,1,''
printf,1,'total $H_\beta$ flux:'+string(flust[hbeta],format='(E10.3)')+'$\pm$'+$
    string(dflust[hbeta],format='(E10.3)')+' $erg/cm^2 s$'
printf,1,''
printf,1,'total $H_\beta$ flux (unreddened):'+string(flust_unred[hbeta],format='(E10.3)')+'$\pm$'+$
    string(dflust_unred[hbeta],format='(E10.3)')+' $erg/cm^2 s$'
printf,1,' '
printf,1,'\end{document}'
close,1
cd,wdir,current=curd
spawn,'latex linepars.tex'
spawn,'dvips -olinepars.ps linepars.dvi'
cd,curd

c=2.997925e5
set_plot,'ps'
  device,filename=wdir+'vels.ps'
loadct,0
!p.multi=[0,1,2]
    plot,llist,vels,psym=2,yrange=[-300.,300.]+z*c,xrange=[min(larray),max(larray)],xst=1
    oploterr,llist,vels,dvels
    oplot,llist,replicate(z*c,n_elements(llist)),linestyle=3
plot,larray,sp,yrange=[-.1,1.2]*max(sp),xrange=[min(larray),max(larray)],xst=1
  for k=0,n_elements(llist)-1 do begin
       tmp=min(abs(larray-llist[k]),pos)
       oplot,[larray[pos],larray[pos]],[sp[pos]*1.01,sp[pos]*1.01+total(abs(sp))/double(n_elements(sp))]
  xyouts,llist[k],sp[pos]*1.01+total(abs(sp))/double(n_elements(sp))*2.,string(llist[k],format='(F7.2)'),$
	/data,orientation=90,charsize=.6
  endfor
!p.multi=0
  device,/close
set_plot,'x'
end
