pro linecenter_peak,infile,quantile

pr=readfits(infile,h) 
dy=sxpar(h,'CDELT1')  &  y0=sxpar(h,'CRVAL1')  & nx=n_elements(pr)
y=dindgen(nx)*dy+y0
wdir=exdir(infile)

pmax=max(pr,wmax)
whigh=where(pr ge pmax*(1.-quantile),nhigh)

set_plot,'ps'
 device,filename=wdir+'limp.eps',/color,/enc,/land
loadct,0
 plot,y,pr,psym=2,title='fitting upper '+strtrim(string(quantile*100,for='(I10)'),2)+'%',$
  symsize=0.75,charsize=2.,charthick=3.0,thick=2.0  ;,yrange=[1.,20.]*1.e-17
loadct,27
  oplot,y(whigh),pr(whigh),color=1000,psym=7,thick=2.,symsize=2.
 
 ypars=poly_fit(y(whigh),alog10(pr(whigh)),2,/dou,yfit=yfit,sigma=sig,chisq=chisq)  ;,aa,nterms=3)  
sig=sig/sqrt((nhigh-3)/chisq)
  yc=-0.5*ypars[1]/ypars[2]
  sic=0.5*(abs(sig[1]/ypars[2])+abs(ypars[1]*sig[2])/ypars[2]^2)
oplot,y(whigh),(10d)^yfit,color=20
plotsym,2,5,thick=3.0
plots,yc,(10d)^(max(yfit)-0.5),color=20,psym=8,thick=3.5
loadct,8
xyouts,min(y),max(pr),'y!Dc!N(gauss) = '+strtrim(string(yc,for='(F10.2)'),2)+$
  string("261B)+strtrim(string(sic,for='(F10.2)'),2)+' arcsec',charsize=1.8,charthick=2.0

y1=rebin(y,nx*200)
pr1=interpol(pr,y,y1)
whigh1=where(pr1 gt pmax*(1.-quantile))

oplot,y1(whigh1),pr1(whigh1),color=60,psym=2,symsize=0.1,thick=5.
oplot,y,replicate(pmax*(1.-quantile),nx),color=80

ybc=total(pr1(whigh1)*y1(whigh1))/total(pr1(whigh1))

loadct,0

xyouts,min(y),max(pr)*(1.-quantile)*0.8,'y!Dc!N(barycenter) = '+strtrim(string(ybc,for='(F10.2)'),2),charsize=1.8,charthick=2.0 ;+$
 ; string("261B)+strtrim(string(sic,for='(F10.2)'),2)+' arcsec'

 device,/close
set_plot,'x'
end
