;2D linerisation SCORPIO data in LONG-slit mode

pro linerisation_2D,LOGFILE,IMAGE_TYPE ;,beg_lambda,end_lambda,d_lambda

print,'linerisation '+IMAGE_TYPE
wdir=DEF_WDIR(LOGFILE)
coeff=readfits(wdir+'2D_coeff.fts',h,/silent)
beg_lambda=sxpar(h,'LAMBDA_0')
Ndeg=sxpar(h,'NAXIS1')-1 & Ny_disp=sxpar(h,'NAXIS2')
d_lambda=sxpar(h,'D_LAMBDA')
nl=sxpar(h,'N_LIN')
bint=double(strsplit(sxpar(h,'BINNING'),'x',/ext))

ima=readfits(wdir+IMAGE_TYPE+'.fts',hi,/silent)
a=size(ima)
Nx=sxpar(hi,'NAXIS1') & Ny=sxpar(hi,'NAXIS2')


maxw=dblarr(a[2])
for y=0,a[2]-1 do maxw[y]=poly(a[1]-1,coeff(*,y))
end_lambda=min(maxw)  ;;beg_lambda+nl*d_lambda

lambda_0=beg_lambda 
N=FIX((end_lambda-beg_lambda)/d_lambda)
;read spectra
;ima=readfits(wdir+IMAGE_TYPE+'.fts',h,/silent)

if Ny_disp ne Ny then begin
message,'size along slit image and dispersion coefficients not equal!'
endif
;N_frame=sxpar(h,'NAXIS3')
;linerisation spectra
; wav=0 & for j=0,Ndeg do wav=wav+coeff(j,Ny/2)*float((Nx-1))^j
wav=poly(double(Nx-1),coeff(*,Ny/2))

lambda=dindgen(N)*d_lambda+lambda_0
x=dindgen(Nx)
ima_lin=dblarr(N,Ny)
for y=0,Ny-1 do begin
; wav=0 & for j=0,Ndeg do wav=wav+coeff(j,y)*double(x)^j
wav=poly(double(x),coeff(*,y))
 ;if N_frame eq 2 then begin
 ; for j=0,N_frame-1 do begin
 ;vector=ima(*,y,j)
;ima_lin(*,y,j)=INTERPOL(vector,wav,lambda)
;endfor 
; endif
; if N_frame eq 0 then begin
 vector=ima(*,y)
;
 ima_lin(*,y)=INTERPOL(vector,wav,lambda)
;endif
endfor
scale=str_sep(sxpar(hi,'IMSCALE'),'x') 
if n_elements(scale) eq 1 then scale=[1,1]
 scale=double(scale[1])
sxaddpar,hi,'CRVAL1',lambda(0)
; sxaddpar,h,'CRVAL2',sxpar(h,'CRVAL2')*scale/bint[1]         ; /sxpar(h,'CDELT2')
sxaddpar,hi,'CDELT1',d_lambda,' DISPERSION A/px',AFTER='CRVAL2'
sxaddpar,hi,'CDELT2',scale,' SCALE ALONG SLIT arcsec/px',AFTER='CDELT1'
sxaddhist,'spectra linearised',hi
writefits,wdir+IMAGE_TYPE+'_lin.fts',ima_lin,hi
end
