;2D linerisation SCORPIO data in LONG-slit mode

pro linerisation_2D_multiframe,LOGFILE

wdir=DEF_WDIR(LOGFILE)  &  ofs=DEF_name(LOGFILE,'OBJ',nobj)
print,'linerisation '+strtrim(nobj,2)+'object exposures'

ext='.fts'
filar='obj'+strtrim(indgen(nobj),2)+ext
filar1='obj_lin'+strtrim(indgen(nobj),2)+ext

coeff=readfits(wdir+'2D_coeff.fts',h,/silent)

beg_lambda=sxpar(h,'LAMBDA_0')
d_lambda=sxpar(h,'D_LAMBDA')
nl=sxpar(h,'N_LIN')
end_lambda=beg_lambda+nl*d_lambda

Ndeg=sxpar(h,'NAXIS1')-1 & Ny_disp=sxpar(h,'NAXIS2')
lambda_0=beg_lambda 
N=FIX((end_lambda-beg_lambda)/d_lambda)
;read spectra
for k=0,nobj-1 do begin
  ima=readfits(wdir+filar[k],h,/silent)
  bint=double(strsplit(sxpar(h,'BINNING'),'x',/ext))
  Nx=sxpar(h,'NAXIS1') & Ny=sxpar(h,'NAXIS2')

  if Ny_disp ne Ny then begin
    message,'size along slit image and dispersion coefficients not equal!'
  endif

  wav=poly(double(Nx-1),coeff(*,Ny/2))

  lambda=dindgen(N)*d_lambda+lambda_0
  x=dindgen(Nx)
;if N_frame eq 2 then ima_lin=fltarr(N,Ny,N_frame) ELSE ima_lin=fltarr(N,Ny)
ima_lin=dblarr(N,Ny)
  for y=0,Ny-1 do begin
     wav=poly(double(x),coeff(*,y))
    ; if N_frame eq 0 then begin
       vector=ima(*,y)
       ima_lin(*,y)=INTERPOL(vector,wav,lambda)
;endif
   endfor
   scale=str_sep(sxpar(h,'IMSCALE'),'x') 
   if n_elements(scale) eq 1 then scale=[1,1]
   scale=double(scale[1])
   sxaddpar,h,'CRVAL1',lambda(0)
   ; sxaddpar,h,'CRVAL2',sxpar(h,'CRVAL2')*scale/bint[1]         ; /sxpar(h,'CDELT2')
   sxaddpar,h,'CDELT1',d_lambda,' DISPERSION A/px',AFTER='CRVAL2'
   sxaddpar,h,'CDELT2',scale,' SCALE ALONG SLIT arcsec/px',AFTER='CDELT1'
   sxaddhist,'spectra linearised',h
   writefits,wdir+filar1[k],ima_lin,h
endfor
end
