;2D linerisation SCORPIO data in LONG-slit mode

pro linerisation_quasi3D,LOGFILE

print,'linerisation  object quasicube'
wdir=DEF_WDIR(LOGFILE)
coeff=readfits(wdir+'2D_coeff.fts',h,/silent)

beg_lambda=sxpar(h,'LAMBDA_0')
d_lambda=sxpar(h,'D_LAMBDA')
nl=sxpar(h,'N_LIN')
end_lambda=beg_lambda+nl*d_lambda

Ndeg=sxpar(h,'NAXIS1')-1 & Ny_disp=sxpar(h,'NAXIS2')
lambda_0=beg_lambda 
N=FIX((end_lambda-beg_lambda)/d_lambda)
;read spectra
ima=readfits(wdir+'cube.fts',h,/silent)
field=[sxpar(h,'FIELD1'),sxpar(h,'FIELD2')]
bint=double(strsplit(sxpar(h,'BINNING'),'x',/ext))
Nx=sxpar(h,'NAXIS1') & Ny=sxpar(h,'NAXIS2')

if Ny_disp ne field[1] then begin
message,'size along slit image and dispersion coefficients not equal!'
endif
wav=poly(double(Nx-1),coeff(*,field[1]/2))

lambda=dindgen(N)*d_lambda+lambda_0
x=dindgen(Nx)
ima_lin=dblarr(N,Ny)

for y1=0,field[0]-1 do begin
 for y=0,field[1]-1 do begin
 ; wav=0 & for j=0,Ndeg do wav=wav+coeff(j,y)*double(x)^j
   wav=poly(double(x),coeff(*,y))
   vector=ima(*,y*field[0]+y1)
   ima_lin(*,y*field[0]+y1)=INTERPOL(vector,wav,lambda)
 endfor
endfor
scale=str_sep(sxpar(h,'IMSCALE'),'x') 
if n_elements(scale) eq 1 then scale=[1,1]
 scale=double(scale[1])
sxaddpar,h,'CRVAL1',lambda(0)
; sxaddpar,h,'CRVAL2',sxpar(h,'CRVAL2')*scale/bint[1]         ; /sxpar(h,'CDELT2')
sxaddpar,h,'CDELT1',d_lambda,' DISPERSION A/px',AFTER='CRVAL2'
sxaddpar,h,'CDELT2',scale,' SCALE ALONG SLIT arcsec/px',AFTER='CDELT1'
sxaddhist,'spectra linearised',h
writefits,wdir+'cube_lin.fts',ima_lin,h
end
