pro muline_long,infile,lar,yrange=yrange,w=w,smooth=smooth,ddv=ddv,z=z,binning=binning,vvar=vvar,yadd=yadd

if not(keyword_set(ddv)) then ddv=0.
if not(keyword_set(vvar)) then vvar=20.
nl=n_elements(lar)

fmin=0.11

c=double(2.9979e+5)
wdir=exdir(infile)
if not(keyword_set(w)) then w=20.

data=readfits(infile,h)
ddata=readfits(exdir(infile)+'dobj_norm.fts',h)
if not(keyword_set(z)) then z=sxpar(h,'REDSHIFT')
; z=.00015
ds=size(data)
if not(keyword_set(yrange)) then yrange=[0,ds[2]-1]
dl=sxpar(h,'CDELT1')  &  l0=sxpar(h,'CRVAL1')
dy=sxpar(h,'CDELT2')  &  y0=sxpar(h,'CRVAL2')
l=dindgen(ds[1])*dl+l0
y=dindgen(ds[2])*dy+y0

if keyword_set(yadd) then begin
  y=y+yadd
  yrange=yrange+yadd
endif

if keyword_set(binning) then begin
  nbins=floor(double(ds[2])/double(binning))
  data1=dblarr(ds[1],nbins)   &   ddata1=dblarr(ds[1],nbins)
  y1=dblarr(nbins)
 for k=0,nbins-1 do begin    
   data1(*,k)=total(data(*,k*binning:(k+1)*binning-1),2)
  for j=0,ds[1]-1 do ddata1[j,k]=stdev(data(j,k*binning:(k+1)*binning-1)) ;/sqrt(double(binning))
   y1[k]=y[float(k*binning+(k+1)*binning)*0.5]
 endfor
  data=data1  &  ddata=ddata1  &   y=y1  & dy=dy*double(binning)
endif

warea=where(l-min(lar)*(z+1.) ge -w and l-max(lar)*(z+1.) le w,nwe)
larea=l(warea)  &  darea=data(warea,*) &  ddarea=ddata(warea,*)
wy=where(y ge min(yrange) and y le max(yrange),ny)

nl=n_elements(lar)
flux=dblarr(nl,ny)
vel=dblarr(nl,ny)
fwhm=dblarr(nl,ny)
cent=dblarr(nl,ny)
dflux=dblarr(nl,ny)
dvel=dblarr(nl,ny)
dcent=dblarr(nl,ny)
dfwhm=dblarr(nl,ny)
; y=indgen(ds[2])
; ny=max(yrange)-min(yrange)
; y=y(min(yrange):max(yrange)-1)
wy=where(y ge min(yrange) and y le max(yrange),ny)
y=y(wy)
y0=min(y)

darint=total(darea(*,wy),2)
ddarint=total(ddarea(*,wy),2)
if keyword_set(smooth) then darint=smooth(med_ext(darint,5),5)
loadct,0
set_plot,'ps'
device,filename=wdir+strtrim(string(median(lar,/even),format='(I10)'),2)+'_fit.ps',/colo
  cont=[indgen(10),dindgen(10)+nwe-11]
  lf=goodpoly(larea(cont),darint(cont),1,3.,lfit)
 res0=multigaus(larea,(darint-poly(larea,lf)),lar*(z+1.),FWHM=replicate(6d,nl),yfit=afit,lim_fwhm=[2.,15.],$
        sigma=sighma,dy=ddarint,chisq=chisq) 
; else $
; afit=gaussfit(larea,(darint-poly(larea,lf)),res0,netrms=3)

loadct,0
  plot,larea,darint,psym=2
  oploterr,larea,darint,ddarint
loadct,27
  oplot,larea,poly(larea,lf)+afit,color=1000
loadct,0
device,/close
set_plot,'x'
loadct,0
for k=0,ny-1 do begin
  vec=reform(darea(*,wy[k]))
  dvec=reform(ddarea(*,wy[k]))
;  if keyword_set(smooth) then vec=smooth(med_ext(vec,5),5)
  cont=where(larea lt min(res0.center)-res0[0].fwhm or larea gt max(res0.center)+res0[0].fwhm)           ;;[indgen(),dindgen(10)+nwe-11]
  lf=goodpoly(larea(cont),vec(cont),1,4.,lfit)
  res=multigaus(larea,(vec-poly(larea,lf)),res0.center,FWHM=res0.fwhm,yfit=afit,$
        sigma=sighma,dy=dvec,chisq=chisq)
;  if nl eq 1 then begin
;    afit=gaussfit(larea,(vec-poly(larea,lf)),g,nterms=3,meas=dvec,chisq=chisq)
;    res.flux=g[0]*g[2]*sqrt(2.D*!DPI)
;    res.center=g[1]
;    res.fwhm=g[2]*sqrt(8.*alog(2.))
;  endif
  plot,larea,vec,psym=2
  oploterr,larea,vec,dvec
for kkk=0,999 do  oplot,larea,poly(larea,lf)+afit,color=1000
  flux(*,k)=res.flux
  fwhm(*,k)=res.fwhm
  cent(*,k)=res.center
  vel(*,k)=(cent(*,k)/lar-1.D)*c
  dflux(*,k)=sighma.flux
  dfwhm(*,k)=sighma.fwhm
  dcent(*,k)=sighma.center ;/sqrt(n_elements(vec))
;  dcent(*,k)=res.fwhm*sighma.flux/res.flux/sqrt(n_elements(vec))
  dvel(*,k)=(dcent(*,k)/lar)*c
endfor
loadct,0

vmed=vel
fmed=flux

for k=0,n_elements(lar)-1 do fmed(k,*)=smooth(med_ext(reform(flux(k,*)),3),3)
for k=0,n_elements(lar)-1 do vmed(k,*)=smooth(med_ext(reform(vel(k,*)),3),3)
wgood=where(dvel(0,*)>abs(vel(0,*)-vmed(0,*)) lt vvar and flux(0,*) gt fmin*max(flux(0,*)))

if keyword_set(smooth) then begin
  wf=where(abs(flux-fmed) gt 2.*dflux,nf)
  if nf gt 0 then flux(wf)=fmed(wf)
  wv=where(abs(vel-vmed) gt 2.*dvel,nv)
  if nv gt 0 then vel(wv)=vmed(wv)
endif

sxaddpar,h,'CDELT1',dy
sxaddpar,h,'CRVAL1',min(yrange)

set_plot,'ps'
for lk=0,nl-1 do begin
sxaddpar,h,'LINE',strtrim(string(lar[lk],format='(F10.2)'),2),'WAVELENGTH'
  out=strtrim(string(lar[lk],format='(I10)'),2)+'_F'+strtrim(string(lk,format='(I5)'),2)
  writefits,wdir+out+'.fts',reform(flux(lk,*)),h
  out=strtrim(string(lar[lk],format='(I10)'),2)+'_df'+strtrim(string(lk,format='(I5)'),2)
  writefits,wdir+out+'.fts',reform(dflux(lk,*)),h
   out=strtrim(string(lar[lk],format='(I10)'),2)+'_V'+strtrim(string(lk,format='(I5)'),2)
  writefits,wdir+out+'.fts',reform(vel(lk,*)),h
   out=strtrim(string(lar[lk],format='(I10)'),2)+'_dv'+strtrim(string(lk,format='(I5)'),2)
  writefits,wdir+out+'.fts',reform(dvel(lk,*)),h
   out=strtrim(string(lar[lk],format='(I10)'),2)+'_w'+strtrim(string(lk,format='(I5)'),2)
  writefits,wdir+out+'.fts',reform(fwhm(lk,*)),h
   out=strtrim(string(lar[lk],format='(I10)'),2)+'_dw'+strtrim(string(lk,format='(I5)'),2)
  writefits,wdir+out+'.fts',reform(dfwhm(lk,*)),h
endfor

lof=floor(alog10(max(flux(where(flux le 1.)))))

out=strtrim(string(median(lar,/even),format='(I10)'),2)+'_FV'
  device,filename=wdir+out+'.ps',/port,xsize=21,ysize=27,yoffset=1,xoffset=0
!p.multi=[0,1,2]

;for lk=0,nl-1 do begin
;  flux(lk,*)=smooth(med_ext(reform(flux(lk,*)),3),3)
;  vel(lk,*)=smooth(med_ext(reform(vel(lk,*)),3),3)
;endfor

    plot,y,flux(0,*)*(10D)^(-lof),yrange=[0,0.5*max(darea)]*(10D)^(1.-lof),psym=1,ytitle='flux, 10!U'+$
       strtrim(string(lof,format='(I8)'),2)+'!Nerg/cm!U2!Ns',xst=1,yst=1,charsize=2.,$
       charthick=3.5,thick=3.,xrange=yrange
    oploterr,y,flux(0,*)*(10D)^(-lof),dflux(0,*)*(10D)^(-lof),1
  ;  xyouts,.8,.95,'Pos = '+strtrim(sxpar(h,'POSANG'),2),/norm
    if nl gt 1 then begin
     for lk=1,nl-1 do begin
      oplot,y,flux(lk,*)*(10D)^(-lof),psym=lk+1 
      oploterr,y,flux(lk,*)*(10D)^(-lof),dflux(lk,*)*(10D)^(-lof),lk+1
     endfor
    endif
 ; device,/close
; out=strtrim(string(median(lar,/even),format='(I10)'),2)+'_V'
 ; device,filename=wdir+out+'.ps'
    plot,y(wgood),vel(0,wgood),yrange=[-1.,1.]*(100.+vvar)+c*z+ddv,xrange=yrange,$
  psym=1,ytitle='v, km/s', xtitle='y, arcsec',xst=1,charsize=2.,$
       charthick=3.5,thick=3.
    oploterr,y(wgood),vel(0,wgood),dvel(0,wgood),1
    if nl gt 1 then begin
     for lk=1,nl-1 do begin
     ; oplot,y*.357,vel(lk,wgood),psym=0 
      oplot,y(wgood),vel(lk,wgood),psym=lk+1 
      oploterr,y(wgood),vel(lk,wgood),dvel(lk,wgood),1
     endfor
    endif
!p.multi=0
  device,/close 
 out=strtrim(string(median(lar,/even),format='(I10)'),2)+'_W'
 device,filename=wdir+out+'.ps',/land
  plot,y,fwhm(0,*),xtitle='y, arcsec',charthick=2.5,thick=2.,ytitle='FWHM,'+string("305B),yrange=[0.,14.]
  oploterr,y,fwhm(0,*),dfwhm(0,*),1
    if nl gt 1 then begin
     for lk=1,nl-1 do begin
      oplot,y,fwhm(lk,*),psym=lk+1 
      oploterr,y,fwhm(lk,*),dfwhm(lk,*),1
     endfor
    endif
 device,/close
set_plot,'x'

end
