;output PS
pro out_PS,LOGFILE,idl_dir,SLITPOS=slitpos,TRESH=tresh
if not(keyword_set(slitpos)) then slitpos=460
if not(keyword_set(tresh)) then tresh=3
wdir=DEF_WDIR(LOGFILE)
map=readfits(wdir+'map_i.fts',h_map)
My=sxpar(h_map,'NAXIS2')
if slitpos-My/2 lt 0 then begin
 M=slitpos*2-1
 dy=(My-M)/2
 map=map(*,dy:M-1+dy)
 My=M
endif
map=map(slitpos-My/2:slitpos+My/2-1,*)
;estimate sky background
s=10
N=My/S
map_tmp=congrid(map,N,N)
fon=fltarr(N,N)
x=findgen(N)
for k=0,N-1 do begin
;fon(*,k)=LOWESS(X,map_tmp(*,k),20,3, 5)
endfor

;fon=congrid(fon,My,My)
;fon= filter_image(fon,FWHM_gaussian=[2*S,2*S],/all_pixels)
;fon=smooth(fon,4*S,/edge_truncate)
;fon=smooth(fon,4*S,/edge_truncate)

map=map;-fon
robomean,map,3,0.5,level_map,rms_map
out_map=255-bytscl(map,level_map-rms_map/tresh,level_map+rms_map*3*tresh)
out_map(My/2-1,*)=100
out_map(0,*)=0 & out_map(My-1,*)=0
out_map(*,0)=0 & out_map(0,My-1)=0
;read sky substracted image
image=readfits(wdir+'obj_sky.fts',h_ima)
Nx=sxpar(h_ima,'NAXIS1') & Ny=sxpar(h_ima,'NAXIS2')
spectra=readfits(wdir+'obj_spect.fts',h)
pos_obj=sxpar(h,'POS_OBJ') & Nobj=sxpar(h,'NAXIS2')
if Nobj eq 0 then Nobj=1
pos_obj=float(str_sep(pos_obj,','))
tra=readfits(wdir+'traectory.fts')
;d_y=tra(0)-tra(Nx/2)
d_y=0.
pos_obj=pos_obj+d_y
sent=readfits(wdir+'sent.fts')
lambda=findgen(Nx)*sxpar(h,'CDELT1')+sxpar(h,'CRVAL1')
gain=sxpar(h,'GAIN') & Texp=sxpar(h,'EXPTIME')
dy=4.5 & dx=19
set_plot,'PS'
device,file=wdir+'out.ps',xsize=dx,bits_per_pixel=24,$
	ysize=6*dy,xoffset=1,yoffset=1.5,/portrait
;plot identefication map
for j=0,Nobj-1 do begin
plot,[0],[0],xst=5,yst=5,/nodata
tv,out_map,dx-dy,dy*5,ysize=dy,/centimeter
;plot initial frame
out=image  ;(*,*,0)
R=where(out lt 0,ind) & if ind gt 1 then out(R)=0
;  out=out+image(*,*,1)
rms=stdev(out(Nx/2-Nx/4:Nx/2+Nx/4,*),level)
tv,255-bytscl(out,level-rms,level+rms),0.1*dx,3.9*dy,$
	xsize=dx*0.9,ysize=dy*0.95,/centimeter
;plot sky substracted frame
out=image(*,*,0)
R=where(out lt 0,ind) & if ind gt 1 then out(R)=0
rms=stdev(out(Nx/2-Nx/4:Nx/2+Nx/4,*),level)
tv,255-bytscl(out,level-rms,level+5*rms),0.1*dx,2.9*dy,$
	xsize=dx*0.9,ysize=dy*0.95,/centimeter

yp=(2.9*dy+dy*0.95*pos_obj(j)/float(Ny))/6./dy
arrow,0,yp,0.1,yp,color=100,/norm
;plot extracted spectra in ADU units
out=spectra(*,j)*Texp/sent(*,0)/gain
ymin=0 & ymax=max(out)
R=where(out lt 0,ind) & if ind gt 1 then ymin=-ymax*0.05
plot,out,xst=1,position=[0.1,0.29,1,0.47],yst=1,$
xtitle='channel',ytitle='flux,ADU',$
yrange=[ymin,max(out)*1.05],/norm,/noerase
oplot,[0,Nx],[0,0],linestyle=2
;plot extracted spectra in absolute units
;determination range output of ordinate
out=spectra(*,j)
order=rfix(alog10(max(out)))
scale=10.^(-order)
;if keyword_set(erg) then begin
scale=10.^(-order)
title_y='Flux, 1E'+string(order,format='(I3)')+' erg/cm^2/s/A'
;endif
out=out*scale
ymin=0 & ymax=max(out)
R=where(out lt 0,ind) & if ind gt 1 then ymin=-0.05*ymax
plot,lambda,out,xst=1,yst=1,yrange=[ymin,ymax*1.05],$
	position=[0.1,0.055,1,0.235],$
	/norm,/noerase,$xrange=[3800,7500],$
	ytitle=title_y,xtitle='wavelength, A'
oplot,[lambda(0),lambda(Nx-1)],[0,0],linestyle=2
;print parameters image
xyouts,0.1,0.99,sxpar(h,'DATE-OBS')+', SCORPIO, LONG-slit mode, grating '+$
	sxpar(h,'disperse'),/norm
; tra=readfits(wdir+'traectory.fts',h_tra,/silent)
seeing=sxpar(h_ima,'seeing')
xyouts,0.1,0.96,'object '+sxpar(h,'object')+$
'  exposure' + string(sxpar(h,'exptime'),format='(I6)')+' s'+$
	'  seeing '+string(seeing,format='(F4.1)'),/norm
RA_DEC=strcompress(sxpar(h,'RA'))+' '+$
	strcompress(sxpar(h,'DEC'))
jd=float(str_sep(sxpar(h,'DATE'),'-'))
RA_DEC=apparent_place(RA_DEC,julday(jd(2),jd(1),jd(0),0),DIRECTION=-1)
RA_DEC='RA(2000)'+strmid(RA_dec,0,13)+' DEC(2000)'+$
	  strmid(RA_dec,13,12)+'    Z='+string(sxpar(h,'z'),format='(I3)')
xyouts,0.1,0.93,RA_DEC,/norm
;calculation magnitudes
coeff=lambda^2*3.3356E7

slit=1
d_mag=corr_magnitudes(seeing,slit)
Bm=string(magn_band('B',spectra(*,j)*coeff,lambda,idl_dir)+d_mag,format='(F5.1)')
Vm=string(magn_band('V',spectra(*,j)*coeff,lambda,idl_dir)+d_mag,format='(F5.1)')
Rm=string(magn_band('R',spectra(*,j)*coeff,lambda,idl_dir)+d_mag,format='(F5.1)')
Im=string(magn_band('I',spectra(*,j)*coeff,lambda,idl_dir)+d_mag,format='(F5.1)')
xyouts,0.1,0.90,'B='+Bm+'  V='+Vm+'  R='+Rm+'  I='+Im,/norm
xyouts,0.1,0.835,'RDIR '+def_rdir(logfile)+'     WDIR '+def_wdir(logfile),/norm
FOV=str_sep(sxpar(h_map,'IMSCALE'),'x') & FOV=float(FOV(0))*Ny/60.
fov=string(FOV,format='(F4.2)') & FOV='FOV '+FOV+'x'+FOV+' arcmin'
xyouts,0.78,1.01,FOV,/norm
xyouts,0.83,0.815,'Texp '+string(sxpar(h_map,'EXPTIME'),format='(I3)')+' s',/norm
files=' '
init_files=def_name(logfile,'obj',N_files)
for i=0,N_files-1 do files=files+' '+init_files(i)
xyouts,0.1,0.865,'files  '+files,/norm

endfor
device,/close
if os_family() eq 'unix' then set_plot,'X' else set_plot,'WIN'

end
