pro redlong,log,ima_type,thresh,exsent=exsent,overscan=overscan,yshift=yshift,specreg=specreg

if not(keyword_set(overscan)) then overscan=[0,0]

dir=def_par(log,'R_DIR')
wdir=def_par(log,'W_DIR')
ext=def_par(log,'EXT')

ima_name=DEF_NAME(LOG,IMA_TYPE,N_ima)
;;redlong_multiframe,log,ftype,overscan=overscan,thresh=thresh

if N_ima gt 10 and ima_type ne 'bias' then redlong_multiframe,log,ima_type,overscan=overscan,thresh=thresh
if N_ima gt 10 and ima_type ne 'bias' then goto,fin

if N_ima eq 0 and (ima_type eq 'star') then begin
  message,'external sent will be needed!',/cont
  goto,fin
endif
;  ima_name=wdir+ima_name+ext

ima0=readfits(dir+ima_name[0]+ext,hdr0)

s=size(ima0)
nx=s[1]  & ny=s[2]

;; ***  Czto dzielac', jsli razmery raznye? 

exps=dblarr(N_ima)  &  gains=dblarr(N_ima)

if N_ima eq 1 then begin
   ima=ima0 
   gains[0]=sxpar(hdr0,'GAIN')
   exps[0]=sxpar(hdr0,'EXPTIME') 
   ima=readfits(dir+ima_name+ext,hdr,/sil)
endif else begin
  if s[1] gt 4000. then ima=fltarr(s[1],s[2],N_ima) else ima=dblarr(s[1],s[2],N_ima)
  hds=strarr(n_elements(hdr0),N_ima)
  for kf=0,N_ima-1 do begin
     itmp=readfits(dir+ima_name[kf]+ext,hd_tmp,/sil)
     if n_elements(itmp) ne n_elements(ima(*,*,kf)) then message,'problems with '+dir+ima_name[kf]+ext
     ima(*,*,kf)=readfits(dir+ima_name[kf]+ext,hd_tmp,/sil)
     hds(*,kf)=hd_tmp
     exps[kf]=sxpar(hd_tmp,'EXPTIME')
     gains[kf]=sxpar(hd_tmp,'GAIN')
  endfor
  itmp=0.
 hdr=add_header(hds)
endelse
ima0=0.
; for kf=0,N_ima-1 do ima(*,*,kf)=ima(*,*,kf)*total(exps)/exps[kf]
 if keyword_set(yshift) then begin
  dy=dblarr(N_ima)
   dy[0]=0
  for kf=1,N_ima-1 do begin
    ima0_tmp=reform(ima(*,*,0))
    ima_tmp=reform(ima(*,*,kf))
    dy[kf]=DEF_SHI(ima0_tmp,ima_tmp,'y',10,100,50);!!!!!!!wx=300,wy=200
    ima(*,*,kf)=shift_image(ima_tmp,0.,dy[kf])
  endfor
  ima0_tmp=0. & ima_tmp=0.
  
  set_plot,'ps'
   device,file=wdir+'shifts.eps',/enc,xsize=27,ysize=20,/land
    plot,dy,xtitle='file No',ytitle='Shift vs No~0',thick=2.,charsize=2.,charthick=2.
    for kf=0,N_ima-1 do xyouts,kf,max(dy),ima_name[kf],orient=90,charsize=0.8,charthick=2.0
   device,/close
  set_plot,'x'
 endif

  if N_ima eq 0 then message,'No files of type '+ima_type+' found!'

if ima_type eq 'bias' then begin
  mean_bias,log,OVERSCAN=overscan,bias_par=20.
  goto,fin 
endif else begin
  message,ima_type+' reduction',/cont 
;  goto,nored
endelse

bias=readfits(wdir+'bias.fts',hb)
;if keyword_set(overscan) then begin
;  imares=imares(overscan[0]>0:s[1]+(overscan[0]<0)-1,overscan[1]>0:s[2]+(overscan[1]<0)-1) 
; if ima_type eq 'obj' and N_ima gt 1 then begin
;  ima3d=ima3d(overscan[0]>0:s[1]+(overscan[0]<0)-1,overscan[1]>0:s[2]+(overscan[1]<0)-1,*)
;  ima3d1=ima3d1(overscan[0]>0:s[1]+(overscan[0]<0)-1,*,overscan[1]>0:s[2]+(overscan[1]<0)-1)
; endif
;  s=size(imares)
;  nx=s[1]  &  ny=s[2]
;endif

if N_ima eq 1 then begin
 if keyword_set(overscan) then ima=ima(overscan[0]>0:s[1]+(overscan[0]<0)-1,overscan[1]>0:s[2]+(overscan[1]<0)-1) 
 case ima_type of 
   'obj'     :  imares=destroy(ima*gains[0],mask,.5,18.,thresh,thresh*5.,wdir=wdir)/gains[0]-bias
   'starslit':  imares=destroy(ima*gains[0],mask,.2,10.,thresh,thresh*5.,wdir=wdir)/gains[0]-bias
   'star'    :  imares=etares(ima-bias,mask=mask,mf=thresh)
   'neon'    :  imares=neores(ima-bias,mask=mask,mf=thresh)
   'flat'    :  imares=flares(ima,mask=mask,thresh=thresh)-bias                ;;;destroy(ima*gains[0],mask,3.,10.,thresh,thresh*3.,wdir=wdir)/gains[0]-bias
   'map'     :  imares=destroy(ima*gains[0],mask,2.,10.,thresh,thresh*5.,wdir=wdir)/gains[0];-bias!!!!!!!! raznye razmery y map i bias
 else: message,'WRONG FORMAT? :'+ima_type
endcase
endif else begin
if keyword_set(overscan) then ima=ima(overscan[0]>0:s[1]+(overscan[0]<0)-1,overscan[1]>0:s[2]+(overscan[1]<0)-1,*) 
 case ima_type of 
   'obj'       :  imares=altermed_long(ima*gains[0],0,thresh,mask=mask,out3d=ima3d)/gains[0]-N_ima*bias
   'starslit'  :  imares=flares(ima,mask=mask,thresh=thresh)-bias*N_ima
   'star'      :  imares=flares(ima,mask=mask,thresh=thresh)-bias*N_ima
   'neon'      :  imares=total(neores(ima,mask=mask,mf=thresh),3)-bias*N_ima
   'flat'      :  imares=flares_long(ima,N_ima,mask=mask,thresh=thresh)-bias*N_ima ;;altermed_long(ima*gains[0],3,thresh,mask=mask)/gains[0]-bias
   'map'       :  imares=altermed(ima*gains[0],3.,thresh,mask=mask)/gains[0]
  else: message,'WRONG FORMAT? :'+ima_type
 endcase
endelse
  s=size(imares)
  nx=s[1]  &  ny=s[2]
;for kf=0,N_ima-1 do ima(*,*,kf)=ima(*,*,kf)*exps[kf]/total(exps)
if ima_type eq 'obj' and N_ima gt 1 and specreg gt 0 then begin
  for k=0,N_ima-1 do ima3d(*,*,k)=(ima3d(*,*,k)-bias)*exps[k]/total(exps)
  ima3d1=dblarr(nx,N_ima,ny)
  for k=0,nx-1 do ima3d1(k,*,*)=transpose(reform(ima3d(k,*,*)))
endif

set_plot,'ps'
  device,filename=wdir+ima_type+'_mask.ps',/port,/color,xsize=20, ysize=27,xoffset=0,yoffset=0
  loadct,16
  a=floor(size(imares)/2.)
 am=size(mask)
    tvscl,-alog(imares(0:a[1]*2-1<(am[1]-1),0:a[2]*2-1<(am[2]-1))>1.),2.,15.,xsize=14,ysize=10,/cent
  loadct,0
    contour,imares(0:a[1]*2-1<(am[1]-1),0:a[2]*2-1<(am[2]-1)),pos=[2.,15.,16.,25.]*1000,/dev,$
      /noda,yticklen=1.0,/noer,xticklen=1.0
    tvscl,mask(0:a[1]*2-1<(am[1]-1),0:a[2]*2-1<(am[2]-1)) eq 0.,2.,3.,xsize=14,ysize=10,/cent
    contour,imares(0:a[1]*2-1<(am[1]-1),0:a[2]*2-1<(am[2]-1)),pos=[2.,3.,16.,13.]*1000,/dev,/noda,$
      /noer,yticklen=1.0,xticklen=1.0
   if ima_type eq 'obj' then xyouts,0,-2.,'cosmic particles graveyard for '+sxpar(hdr,'OBJECT')+'; threshold '+strtrim(string(thresh,format='(F5.1)'))+' used',/norm $
        else xyouts,0,-2.,'cosmic particles graveyard for '+ima_type+'; threshold '+strtrim(string(thresh,format='(F5.1)'))+' used',/norm
  device,/close
set_plot,'x'


scale=strsplit(sxpar(hdr,'IMSCALE'),'x',/ext)

yoffset=sxpar(hdr,'CRVAL2')   ;def_par(log,'YOFFSET')
xoffset=sxpar(hdr,'CRVAL1')   ;def_par(log,'YOFFSET')
bin=strsplit(sxpar(hdr,'BINNING'),'x',/ext)
if n_elements(bin) eq 1 then bin=[1,1]
if n_elements(scale) eq 1 then scale=[1,1]
data=sxpar(hdr,'DATE-OBS')
;t=sxpar(hdr,'START')
time=strsplit(sxpar(hdr,'UT'),':',/ext)
t=ten(time[0],time[1],time[2])
data=strsplit(data,'/',/extract) ;;,t],',')
juldate,[data[0],data[2],data[1],t],jd 
jd=jd+2.4d6 
if jd gt 2453710. then const_pos=132.5  else const_pos=131.
sxaddpar,hdr,'THRESH',thresh
sxaddpar,hdr,'JD',string(jd,for='(F20.7)')
sxaddpar,hdr,'POSANG',sxpar(hdr,'PARANGLE')-sxpar(hdr,'ROTANGLE')+const_pos
sxaddpar,hdr,'FILE',IMA_TYPE+'_i.fts'
sxaddpar,hdr,'CRVAL1',double(xoffset/bin[0]+(overscan[0]>0))*scale[0]
sxaddpar,hdr,'CRVAL2',double(yoffset/bin[1]+(overscan[1]>0))*scale[1]
sxaddpar,hdr,'CDELT1',scale[0]
sxaddpar,hdr,'CDELT2',scale[1]
; if ima_type ne 'map' then sxaddpar,hdr,'CRVAL2',float((yoffset+(overscan[1]>0)))*scale[1]
sxaddpar,hdr,'REDSHIFT',def_par(log,'REDSHIFT')
sxaddhist,'initial FITS-files:',hdr
sxaddpar,hdr,'YPOS',def_pos(log),' POSITION OBJECT ALONG SLIT',BEFORE='DATE'

  writefits,wdir+ima_type+'_i.fts',imares,hdr
  writefits,wdir+ima_type+'_mask.fts',mask,hdr

 if ima_type eq 'obj' and N_ima gt 1 and specreg gt 0  then begin
 for ggg=0,N_ima-1 do begin
      data=sxpar(hds(*,ggg),'DATE-OBS')
      time=strsplit(sxpar(hds(*,ggg),'UT'),':',/ext)
      t=ten(time[0],time[1],time[2])
      data=strsplit(data,'/',/extract) ;;,t],',')
      juldate,[data[0],data[2],data[1],t],jd 
      jd=jd+2.4d6 
 sxaddpar,hdr,'JD'+strtrim(ggg,2),jd
  endfor
   sxaddpar,hdr,'FIELD1',N_ima
   sxaddpar,hdr,'FIELD2',ny
   writefits,wdir+ima_type+'_i3.fts',reform(ima3d1,nx,ny*N_ima),hdr
 endif

fin: 

message,ima_type+' reduction finished successfullyyy...',/cont
if N_ima eq 0 and ima_type eq 'star' then exsent=1
if N_ima eq 0 and ima_type eq 'star' then message,'EXSENT parameter set to 1 !!!',/cont
end
