pro redlong_multiframe,log,ftype,overscan=overscan,thresh=thresh

if not(keyword_set(overscan)) then overscan=[0,0]
;;bias=readfits(wdir+'bias.fts',hb)

  infiles=def_name(log,ftype,nima)
    message,'Beginning multiframe analysis for '+ftype+'('+strtrim(nima,2)+' images)',/cont
  rdir=def_rdir(log)  &  wdir=def_wdir(log)  &  ext=def_par(log,'EXT')
  bias=readfits(wdir+'bias.fts',hb)

  f=readfits(rdir+infiles[0]+ext,hf,/sil) ;;-bias
  hdrs=strarr(n_elements(hf),nima)    &   gain=sxpar(hf,'GAIN')  &  s=size(f)
s=size(f)
   if keyword_set(overscan) then f=f(overscan[0]>0:s[1]+(overscan[0]<0)-1,overscan[1]>0:s[2]+(overscan[1]<0)-1) 
f=f-bias
  ;; cosmic hits can doch be present, and are eliminated by comparison with the adjacent files

  ftot=f*0. ;;(total frame)
  mask=f*0. ;; (comsic graveyard)
dxar=dblarr(nima-1)  &  dyar=dblarr(nima-1)
s1=s
s1(1:2)=s(1:2)-abs(overscan)
mid=mpeg_open(floor([s1[1],s1[2]]/4.),file=wdir+ftype+'_i.mpg',mot=3)

;; *************** main cycle: **************************************
  
for k=0,nima-2 do begin
  f0=f  & hf0=hf
  f=readfits(rdir+infiles[k+1]+ext,hf,/sil) ;;-bias
   if not(array_equal(s,size(f))) then message,'dimensions do not agree!'
  if keyword_set(overscan) then f=f(overscan[0]>0:s[1]+(overscan[0]<0)-1,overscan[1]>0:s[2]+(overscan[1]<0)-1) 
f=f-bias
  hdrs(*,k)=hf

  mrat=total(f(where(f > 0)))/total(f0(where(f > 0)))
  mrat1=total(f(where(f > 0)))/total(ftot(where(f > 0))+f0(where(f > 0)))

;; ************ shifting relative the integral image ***************
;;DEF_SHI,image1,image2,coord,c,wx,wy

   dx=def_shi(ftot+f0,f/mrat1,'x',10,20,100)    ;; Do we need this?
   dy=def_shi(ftot+f0,f/mrat1,'y',10,400,50)
   dxar[k]=dx  &   dyar[k]=dy
   f=shift_image(f,dx,dy)

;; **************************************************
  dfpoi0=sqrt(f0/gain)  &  dfpoi=sqrt(f/gain)  ;; Poisson uncertainties
  wf0=where(f0 gt f+thresh*(dfpoi>dfpoi0) and (f<f0) lt median(f<f0)*5.,nf0)    ;; where the old file contains outbreaks
  wf=where(f gt f0+thresh*(dfpoi>dfpoi0) and (f<f0) lt median(f<f0)*5.,nf);; where the new file contains outbreaks
  if nf0 gt 0 then begin
     masktmp=f0*0.
     masktmp(wf0)=1
      masktmp1=masktmp+(shift(masktmp,-1,-1)+shift(masktmp,1,-1)+shift(masktmp,-1,1)+shift(masktmp,1,1)+$
         shift(masktmp,-1,0)+shift(masktmp,1,0)+shift(masktmp,0,1)+shift(masktmp,0,-1))
     wf0=where(masktmp1 gt 0)
     f0(wf0)=f(wf0)/mrat
  endif
  if nf gt 0 then begin
     masktmp=f*0.
     masktmp(wf)=1
     masktmp1=masktmp+(shift(masktmp,-1,-1)+shift(masktmp,1,-1)+shift(masktmp,-1,1)+shift(masktmp,1,1)+$
         shift(masktmp,-1,0)+shift(masktmp,1,0)+shift(masktmp,0,1)+shift(masktmp,0,-1))
     wf=where(masktmp1 gt 0)
     f(wf)=f0(wf)*mrat
  endif
  if nf gt 0 then mask(wf)=mask(wf)+1  &  if nf0 gt 0 then mask(wf0)=mask(wf0)+1

;  if k gt 0 then begin
    ftot=ftot+f0
    yoffset=sxpar(hf0,'CRVAL2')   ;def_par(log,'YOFFSET')
    xoffset=sxpar(hf0,'CRVAL1')   ;def_par(log,'YOFFSET')
    bin=strsplit(sxpar(hf0,'BINNING'),'x',/ext)
    scale=strsplit(sxpar(hf0,'IMSCALE'),'x',/ext)

    if n_elements(bin) eq 1 then bin=[1,1]
    if n_elements(scale) eq 1 then scale=[1,1]
data=sxpar(hf0,'DATE-OBS')
time=strsplit(sxpar(hf0,'UT'),':',/ext)
t=ten(time[0],time[1],time[2])
data=strsplit(data,'/',/extract) ;;,t],',')
juldate,[data[0],data[2],data[1],t],jd
 jd=jd+2.4d6
    sxaddpar,hf0,'THRESH',thresh
   sxaddpar,hf0,'JD',string(jd,for='(F20.7)')
     sxaddpar,hf0,'POSANG',sxpar(hf0,'PARANGLE')-sxpar(hf0,'ROTANGLE')+131.
  ;  sxaddpar,hf0,'FILE',IMA_TYPE+'_i.fts'
    sxaddpar,hf0,'CRVAL1',double(xoffset/bin[0]+(overscan[0]>0))*scale[0]
    sxaddpar,hf0,'CRVAL2',double(yoffset/bin[1]+(overscan[1]>0))*scale[1]
    sxaddpar,hf0,'CDELT1',scale[0]
    sxaddpar,hf0,'CDELT2',scale[1]
    writefits,wdir+ftype+'_i'+strtrim(k,2)+'.fts',f0,hf0
;  endif
    mpeg_put,mid,frame=k,ima=bytscl(rebin((mrat/mrat1)*f0(0:floor(s1[1]/4.)*4-1,0:floor(s1[2]/4.)*4-1),floor(s1[1]/4.),floor(s1[2]/4.)))
endfor
  hdrs(*,nima-1)=hf

ftot=ftot+f

  yoffset=sxpar(hf,'CRVAL2')   ;def_par(log,'YOFFSET')
  xoffset=sxpar(hf,'CRVAL1')   ;def_par(log,'YOFFSET')
  bin=strsplit(sxpar(hf,'BINNING'),'x',/ext)
  if n_elements(bin) eq 1 then bin=[1,1]
  if n_elements(scale) eq 1 then scale=[1,1]

  sxaddpar,hf,'POSANG',sxpar(hf,'PARANGLE')-sxpar(hf,'ROTANGLE')+131.
  sxaddpar,hf,'FILE',ftype+'_i.fts'
  sxaddpar,hf,'CRVAL1',double(xoffset/bin[0]+(overscan[0]>0))*scale[0]
  sxaddpar,hf,'CRVAL2',double(yoffset/bin[1]+(overscan[1]>0))*scale[1]
  sxaddpar,hf,'CDELT1',scale[0]
  sxaddpar,hf,'CDELT2',scale[1]
  writefits,wdir+ftype+'_i'+strtrim(nima-1,2)+'.fts',f,hf

hdr=add_header(hdrs)
  sxaddpar,hdr,'POSANG',sxpar(hf,'PARANGLE')-sxpar(hf,'ROTANGLE')+131.
  sxaddpar,hdr,'FILE',ftype+'_i.fts'
  sxaddpar,hdr,'CRVAL1',double(xoffset/bin[0]+(overscan[0]>0))*scale[0]
  sxaddpar,hdr,'CRVAL2',double(yoffset/bin[1]+(overscan[1]>0))*scale[1]
  sxaddpar,hdr,'CDELT1',scale[0]
  sxaddpar,hdr,'CDELT2',scale[1]
  writefits,wdir+ftype+'_i.fts',ftot,hdr

set_plot,'ps'
  device,filename=wdir+ftype+'_shift.ps',/port,/color,xsize=20, ysize=27,xoffset=0,yoffset=0
    plot,dxar,dyar,thick=3,psym=0,xtitle='!7D!3x,pxl',ytitle='!7D!3y,pxl'
    xyouts,dxar,dyar,infiles(1:nima-1)
  device,/close
  device,filename=wdir+ftype+'_mask.ps',/port,/color,xsize=20, ysize=27,xoffset=0,yoffset=0
  loadct,16
  a=floor(size(ftot)/2.)
  am=size(mask)
    tvscl,-alog(ftot(0:a[1]*2-1<(am[1]-1),0:a[2]*2-1<(am[2]-1))>1.),2.,15.,xsize=14,ysize=10,/cent
  loadct,0
    contour,ftot(0:a[1]*2-1<(am[1]-1),0:a[2]*2-1<(am[2]-1)),pos=[2.,15.,16.,25.]*1000,/dev,$
      /noda,yticklen=1.0,/noer,xticklen=1.0
    tvscl,mask(0:a[1]*2-1<(am[1]-1),0:a[2]*2-1<(am[2]-1)) eq 0.,2.,3.,xsize=14,ysize=10,/cent
    contour,ftot(0:a[1]*2-1<(am[1]-1),0:a[2]*2-1<(am[2]-1)),pos=[2.,3.,16.,13.]*1000,/dev,/noda,$
      /noer,yticklen=1.0,xticklen=1.0
   if ftype eq 'obj' then xyouts,0,-2.,'cosmic particles graveyard for '+sxpar(hdr,'OBJECT')+'; threshold '+strtrim(string(thresh,format='(F5.1)'))+' used',/norm $
        else xyouts,0,-2.,'cosmic particles graveyard for '+ima_type+'; threshold '+strtrim(string(thresh,format='(F5.1)'))+' used',/norm
  device,/close
set_plot,'x'

;if keyword_set(overscan) then ima=ima(overscan[0]>0:s[1]+(overscan[0]<0)-1,overscan[1]>0:s[2]+(overscan[1]<0)-1,*) 

mpeg_save,mid,file=wdir+ftype+'_i.mpg'
mpeg_close,mid

end
