;reduction at flat field
pro REDUCTION_FLAT,LOGFILE,IMAGE_TYPE,AMPLIFICATION=amplification,multiframe=multiframe
if not(keyword_set(amplification)) then amplification=1
message,'flat-field correction '+IMAGE_TYPE,/cont
wdir=DEF_WDIR(LOGFILE)
flat=readfits(wdir+'flat_ic.fts',h,/silent)
Nx=sxpar(h,'NAXIS1') & Ny=sxpar(h,'NAXIS2')
;normalisation flat
vector=total(flat(*,Ny/2-Ny/4:Ny/2+Ny/4),2)/(Ny/2+1)
vector_norm=LOWESS(findgen(Nx),vector,50,3,5)
;for y=0,Ny-1 do flat(*,y)=(flat(*,y)/vector_norm-1)*amplification+1
for y=0,Ny-1 do flat(*,y)=flat(*,y)/vector_norm
sxaddpar,h,'NORM','yes'
sxaddpar,h,'datamin',0.8
sxaddpar,h,'datamax',1.2
writefits,wdir+'flat.fts',flat,h
;correction flat field
if not(keyword_set(multiframe)) then begin
  obj=readfits(wdir+IMAGE_TYPE+'_ic.fts',h,/silent)
  a=size(obj)
  N_frame=sxpar(h,'NAXIS3')
  if N_frame eq 2 then begin
    for j=0,N_frame-1 do obj(*,*,j)=obj(*,*,j)/flat
  endif
  if N_frame eq 0 then obj=obj/flat
  sxaddhist,'flat-field corrected',h
  writefits,wdir+IMAGE_TYPE+'.fts',obj,h
endif else begin
  ofs=def_name(logfile,IMAGE_TYPE,nobj)
    objk=readfits(wdir+IMAGE_TYPE+'_ic0.fts',hk,/sil)
    s=size(objk)
    mid=mpeg_open(floor([s[1],s[2]]/4.),file=wdir+IMAGE_TYPE+'.mpg',mot=3)

  for k=0,nobj-1 do begin
     objk=readfits(wdir+IMAGE_TYPE+'_ic'+strtrim(k,2)+'.fts',hk,/sil)
     objk=objk/flat
     sxaddhist,'flat-field corrected',hk
     writefits,wdir+IMAGE_TYPE+strtrim(k,2)+'.fts',objk,hk   
     mpeg_put,mid,frame=k,ima=bytscl(rebin(objk(0:floor(s[1]/4.)*4-1,0:floor(s[2]/4.)*4-1),floor(s[1]/4.),floor(s[2]/4.)))
  endfor
  mpeg_save,mid,file=wdir+IMAGE_TYPE+'.mpg'
  mpeg_close,mid
endelse

END
