; *** EASY FOR DEBUGGING SCORPIO DATA REDUCTION SYSTEM ***
;  long-slit mode assumed

  logfile=dialog_PICKFILE(FILTER='/data2/sco_ulxs/*txt',title='select logfile')

      message,'READ LOGFILE '+logfile,/cont

      wdir=DEF_WDIR(LOGFILE)
      message,'output directory: '+wdir,/cont
      SPAWN, 'mkdir '+wdir              ;creation output directory

        init_type=['bias','obj','flat','neon','star','map','starslit']
        thres=[0.,10.,10.,20.,3.,10.,8.]
	red_type=['obj','neon','star','starslit']
     ninit=n_elements(init_type)
     nred=n_elements(red_type)

      	N_exp_init=intarr(ninit)	&	N_exp_red=intarr(nred)

	for k=0,ninit-1 do begin
		tmp=DEF_NAME(LOGFILE,init_type[k],N)
		print,init_type[k],tmp
		N_exp_init[k]=N
	endfor

if min([N_exp_init(0:3),N_exp_init[5]],wmin) le 0 then message,init_type[wmin]+' files absent!'
	
yrange=fix(str_sep(def_pos(logfile),','))
rdir=def_rdir(logfile)
wdir=def_wdir(logfile)

cd,rdir,current=curd
 spawn,'for a in *.ZIP *.zip; do unzip $a; done'
cd,curd

; ********  REDUCTION STEPS TO BE PERFORMED  **********************

    input=''
        read,input,prompt='number of input ? '

        input_tmp=str_sep(input,',')
        output=0
        inputs=output

        for tk=0,n_elements(input_tmp)-1 do begin
          input_tmp1=fix(str_sep(input_tmp[tk],'-'))
  if n_elements(input_tmp1) gt 1 then inputs=[inputs,where(indgen(12) le max(input_tmp1) and indgen(12) ge min(input_tmp1))]$
            else inputs=[inputs,input_tmp1]
        endfor
        outputs=inputs
        outdesc='program launched'

; ****************              PARAMETERS       *******************

unwrap=1
nscor=1
overscan=[20,-20]
exsent=0
idl_dir='/bufm/scorpio.lib_2006/'
strob=1
yobj=double(strsplit(def_par(logfile,'YOBJ'),',',/ext))

; ****************************************************************

dist:
      if n_elements(inputs) gt 1 then inputs=inputs(1:n_elements(inputs)-1) else goto,final
      input=inputs[0]
       
CASE input OF
         '0':   goto,final      ; batch debugging regime ;)
         '1':   goto,inp_1      ; bias subtraction, cosmic particles removal
         '2':   goto,inp_2      ; geometry correction using neon exposures
         '3':   goto,inp_3      ; flat-field correction
         '4':   goto,inp_4      ; dispersion curve creation
         '5':   goto,inp_5      ; linearisation
         '6':   goto,inp_6      ; spectral sensitivity determination (& normalization?)
         '7':   goto,inp_7      ; sky subtraction
         '8':   goto,inp_8      ; total spectra extraction 
         '9':   goto,inp_9      ; rough spectrum analyses (magnitudes; errorframe added)
        '10':   goto,inp_10     ; emission line analysis
ENDCASE

inp_1:
	; mean_bias,logfile,overscan=overscan
	 outdesc=[outdesc,'mean bias creation']
        for k=0,ninit-1 do redlong,logfile,init_type[k],thres[k],exsent=exsent,overscan=overscan,yshift=(init_type[k] eq 'obj')            ; reduction_frame,logfile,init_type[k],ylimit=def_pos(logfile),$
                                                         		;         overscan=overscan,thresh=thres[k]
	 outdesc=[outdesc,'bias subtraction, cosmic particles removal']
		goto,dist

inp_2:
         if exsent gt 0 then ima_geom=['obj','neon','flat'] else ima_geom=[red_type,'flat'] 
	 if unwrap gt 0 then geometry_neon,'neon_i.fts',ima_geom,ima_geom,/plot,w_dir=wdir,Ndeg=2,Nx=10,Ny=30 $            
          else spawn,'cp '+wdir+'obj_i.fts '+wdir+'obj_ic.fts ; cp '+wdir+'neon_i.fts '+wdir+'neon_ic.fts; cp '+wdir+'neon_i.fts '+wdir+'neon_ic.fts; '
; geometry_neon_quasi3d,'neon_i.fts',['obj'],['obj'],/plot,w_dir=wdir,Ndeg=2,Nx=10,Ny=30
	 outdesc=[outdesc,'geometry correction using neon exposures']
		goto,dist

inp_3:
	reduction_flat,logfile,'neon'	
	 outdesc=[outdesc,'neon corrected by flat-field']
	reduction_flat,logfile,'obj'	
;	reduction_flat_quasi3d,logfile	
	 outdesc=[outdesc,'obj corrected by flat-field']
if exsent eq 0 then begin
	reduction_flat,logfile,'star'	
	reduction_flat,logfile,'starslit'	
        outdesc=[outdesc,'star corrected by flat-field']
endif
		goto,dist

inp_4:
   ; create_etalonK
	create_disperse2D,logfile,idl_dir
; CREA_DI2,logfile,5.,3,/manual
        outdesc=[outdesc,'dispersion curve creation']
		goto,dist

inp_5:

	linerisation_2D,logfile,'neon'  ;,lmax,lmin,dl
	linerisation_2D,logfile,'obj'  ;,lmax,lmin,dl
;	linerisation_quasi3D,logfile  ;,lmax,lmin,dl
	if exsent eq 0 then linerisation_2D,logfile,'star'  ;,lmax,lmin,dl
	if exsent eq 0 then linerisation_2D,logfile,'starslit'  ;,lmax,lmin,dl
	 outdesc=[outdesc,'linearization']
        if nscor gt 0. then ns_cor,wdir+'obj_lin.fts',wdir+'obj_lin1.fts',[5577.345,6300.23],wdir,w=50. $
  else spawn,'cp '+wdir+'obj_lin.fts '+wdir+'obj_lin1.fts'
		goto,dist

inp_6:
  if exsent eq 0 then begin
          long_sent,logfile
          outdesc=[outdesc,'creation DQE']
  endif else begin
          spawn,'cp '+dialog_pickfile(filter=wdir+'../sent.fts',title='selest SENT file')+' '+wdir+'sent.fts'
          outdesc=[outdesc,'reading external DQE']
  endelse
          if exsent le 0 then long_corrsent,['obj','star','starslit','cube'],wdir,str_sep(def_par(logfile,'SLITSIZE'),','),ext='_norm.fts' $
else long_corrsent,['obj'],wdir,str_sep(def_par(logfile,'SLITSIZE'),','),ext='_norm.fts'
           outdesc=[outdesc,'normalization']
          if exsent le 0 then plot,starloss(logfile)
	  goto,dist

inp_7:
	; sky_substraction,logfile,'obj',mask=.5*(max(yrange)-min(yrange))
        LS_correlate,wdir+'obj_norm.fts',out=wdir+'obj_norm1.fts'
	subsky_compact,'obj',wdir,median(yrange,/even),w=max(yrange)-min(yrange),/int
	if exsent le 0 then subsky_compact,'star',wdir,180.,w=50.,/int
        outdesc=[outdesc,'sky subtraction']
		goto,dist

inp_8:
	 ; extraction,LOGFILE,DPOS=dpos,PLOT=plot,FWHM=fwhm,BIAS=bias,EXTR=extr
       ;  discor_long,wdir+'obj_sky.fts',wdir+'obj_sky.fts'
;         LS_correlate,wdir+'obj_sky.fts',out=wdir+'obj_sky.fts'
;         LS_correlate,wdir+'obj_norm.fts',out=wdir+'obj_norm1.fts'
         intspectrum,wdir+'obj_norm.fts',median(yrange,/even),.5*(max(yrange)-min(yrange)),log=logfile
	 outdesc=[outdesc,'object spectra extraction']
         if exsent le 0 then intspectrum,wdir+'star_sky.fts',184.,20.,log=logfile,out='star_spect'
	 outdesc=[outdesc,'star spectra extraction']
         out_map,logfile 
	 outdesc=[outdesc,'region map']

inp_9:
         errorframe_long,logfile
	 outdesc=[outdesc,'errorframe construction']
         color_spect,wdir+'obj_spect.fts'
	 outdesc=[outdesc,'object magnitudes estimation']
       	 if exsent le 0 then plot,starloss(logfile)
	goto,dist

inp_10:
	; tocube,'obj_abs.fts'
         LS_correlate,wdir+'obj_sky.fts',out=wdir+'obj_sky.fts'
         LS_correlate,wdir+'obj_norm.fts',out=wdir+'obj_norm.fts'
exspect_interactive,wdir+'obj_norm.fts'
     ;    long_lian,logfile, /two
         long_lian,logfile, /av
         linall_twosp,wdir,llist=[4101.33,4471.48,4685.682,4861.33,4958.91,5006.84,5200.7,5754.80,$
6300.23,6363.82,6678.151,5875.75,7135.8],file1='spect_MH9.fts',file2='spect_MH10.fts',$
dfile1='dsp_MH9.fts',dfile2='dsp_MH10.fts'
          linall_sco,wdir
          linall_2,wdir,llist=[4685.682,4861.33,4958.91,5006.84,5200.7],file='obj_spect.fts'
         ; linall_2,wdir,llist=[5875.75,6678.15,4685.682,6300.23],file='obj_spect.fts'
	 outdesc=[outdesc,'line 1D-mapping']
		goto,dist

final:

message,'SCORPIO FINISHED',/cont
message,'reduction steps made:',/cont
for k=0,n_elements(outdesc)-1 do begin
  print,k,':',outdesc[k]
endfor

end
