;; ****************** Additional tool: interactive spectrum extraction procedure *****************

pro seb_event,ev
 common basicpars,log,opers,indir,outtext,idldir,stalab,screensize,scinfo
 common retail,redmenu,reddetails
 common auxpars,thres,init_type,red_type,unwrap,nscor,exsent,overscan,wdqe,ifysh,auxparsinfo,specreg
 common geopars, geondeg, geo_nx,geo_ny
 common proars,yar,profile1,profile2,yco1,yco2,ygauss,file

wdir=def_wdir(log)

ymean=(yco1+yco2)*0.5
dyco=abs(yco2-yco1)
 widget_control,ev.id,get_uvalue=uv,get_value=val
 
 case uv of
  'close': widget_control,ev.top,/destroy
  'ext': ;if ygauss eq 2 then intspectrum_multigauss,file,ymean,dyco,log=log,/plot else intspectrum,file,ymean,dyco,log=log,gauss=ygauss,/wr,/plot
  'ys1': yco1=double(val[0])
  'ys2': yco2=double(val[0])
  'yg': ygauss=(ygauss+1) mod 3.
  else: message,uv,/cont
 endcase

if uv eq 'ext' then begin
if ygauss eq 2 then intspectrum_multigauss,file,ymean,dyco,log=log,/plot else intspectrum,file,ymean,dyco,log=log,gauss=ygauss,/wr,/plot
  neon_spectr,wdir
  widget_control,ev.top,/destroy
  if specreg gt 0. then extract_spectral_series,wdir+'cube_norm.fts'
  if n_elements(def_name(log,'OBJ')) gt 10 then intspectrum_multiframe,log
if ygauss eq 2 then begin
color_spect,wdir+'obj_spect0.fts',redir=idldir+'/../filters/'
color_spect,wdir+'obj_spect1.fts',redir=idldir+'/../filters/'
endif else color_spect,wdir+'obj_spect.fts',redir=idldir+'/../filters/'
endif
;if yco2 lt yco1 then begin
;  yco2=yco1+yco2
;  yco1=yco2-yco1
;  yco2=yco2-yco1
;endif
;
if uv ne 'close' and uv ne 'ext' then begin
loadct,0,/sil
 plot,yar,profile1,xrange=[min([yco1,yco2])-10.,max([yco2,yco1])+10.],/xst,/yst,xtitle='y, arcsec',ytitle='flux, some units...'
loadct,27,/sil
 oplot,yar,profile1,color=-65000  ;;[-1,170,111111,300000,-65000]
 oplot,yar,profile2,color=1000
loadct,0,/sil
oplot,[yco1,yco1],[min([profile1,profile2]),max([profile1,profile2])]
oplot,[yco2,yco2],[min([profile1,profile2]),max([profile1,profile2])]
oplot,[yco1,yco1]+yco1-yco2,[min([profile1,profile2]),max([profile1,profile2])]
oplot,[yco2,yco2]-yco1+yco2,[min([profile1,profile2]),max([profile1,profile2])]
endif

if ygauss eq 0 and uv eq 'yg' then widget_control,ev.id,set_value='Aperture'
if ygauss eq 1 and uv eq 'yg' then widget_control,ev.id,set_value='Gauss'
if ygauss eq 2 and uv eq 'yg' then widget_control,ev.id,set_value='MultiGauss'

end

pro scorespext,pars
  
 common basicpars,log,opers,indir,outtext,idldir,stalab,screensize,scinfo
 common retail,redmenu,reddetails
 common auxpars,thres,init_type,red_type,unwrap,nscor,exsent,overscan,wdqe,ifysh,auxparsinfo,specreg
 common geopars, geondeg, geo_nx,geo_ny
 common proars,yar,profile1,profile2,yco1,yco2,ygauss,file

ylim=double(strsplit(def_par(log,'YOBJ'),',',/ext))

yco1=min(ylim)  &  yco2=max(ylim)  &  ygauss=0
message,'Yobj = '+strtrim(string(yco1,for='(I10)'),2)+'; '+strtrim(string(yco2,for='(I10)'),2),/cont
  wdir=def_wdir(log)
  file=dialog_pickfile(filter=wdir+'*.fts',title='Select the 2D spectrum')
   
  f=readfits(file,h)
    a=size(f) & dl=sxpar(h,'CDELT1')  &  l0=sxpar(h,'CRVAL1')
    l=dindgen(a[1])*dl+l0 
    dy=sxpar(h,'CDELT2')  &  y0=sxpar(h,'CRVAL2')
    yar=dindgen(a[2])*dy+y0

   profile_blue=total(f(floor(a[1]/4.):floor(a[1]/2.)-1,*),1)
   profile_red=total(f(floor(a[1]/2.):floor(a[1]*3./4.),*),1)

profile1=profile_blue  &  profile2=(profile_red-min(profile_red))/(max(profile_red)-min(profile_red))*(max(profile_blue)-min(profile_blue))+min(profile_blue)

  sbase=widget_base(title='SCOrpio REduction: spectrum extraction',xsize=screensize[0]*0.55,ysize=screensize[1]*0.8,$
     uvalue='sbase') ;,/all_ev) 

   clob=widget_button(sbase,value='Cancel',uv='close',$
  yoffset=0.72*screensize[1],xsize=0.2*screensize[0],ysize=0.05*screensize[1],xoffset=0.15*screensize[0])

   extract=widget_button(sbase,value='Extract',uv='ext',$
  yoffset=0.72*screensize[1],xsize=0.2*screensize[0],ysize=0.05*screensize[1],xoffset=0.35*screensize[0])

  pdraw=widget_draw(sbase,xsize=screensize[0]*0.53,ysize=screensize[1]*0.40,xoffset=screensize[0]*0.02,$
     yoffset=screensize[1]*0.3,uvalue='Profile',/button_events,/expose_ev)

  sbase1=widget_base(sbase,xsize=screensize[0]*0.55,ysize=screensize[1]*0.15,yoffs=screensize[1]*0.025,$
     uvalue='sbase1',grou=sbase) ;,/all_ev) 
  sbase2=widget_base(sbase,xsize=screensize[0]*0.55,ysize=screensize[1]*0.15,yoffs=screensize[1]*0.175,$
     uvalue='sbase2',grou=sbase) ;,/all_ev) 

    yslider1=cw_fslider(sbase1,title='y1',/drag,/edit,scroll=0.1,/frame,$ 
        uval='ys1',val=yco1,min=y0,max=max(yar),xsize=screensize[0]*0.5) ;;,ysize=screensize[1]*0.1) ;,$
;        yoffset=screensize[1]*0.4,xoffset=screensize[0]*0.05)
    yslider2=cw_fslider(sbase2,title='y2',/drag,/edit,scroll=0.1,/frame,$ 
        uval='ys2',val=yco2,min=y0,max=max(yar),xsize=screensize[0]*0.5) ;;,ysize=screensize[1]*0.1) ;,$
;        yoffset=screensize[1]*0.5,xoffset=screensize[0]*0.05)
     
    yg=widget_button(sbase,value='Aperture',uv='yg',xsize=screensize[0]*0.10,ysize=screensize[1]*0.05,$
        yoffset=screensize[1]*0.75,xoffset=screensize[0]*0.025)

 widget_control,pdraw,GET_VALUE=indraw
 wset,indraw
 
  widget_control,sbase,/realize
  widget_control,sbase1,/realize
  widget_control,sbase2,/realize
 xmanager,'seb',sbase,group=sbase,/no_block

end


;; ****************** Code parameters adjustment ***************


pro chaux_event,ev
   common auxpars,thres,init_type,red_type,unwrap,nscor,exsent,overscan,wdqe,ifysh,auxparsinfo,specreg
 common basicpars,log,opers,indir,outtext,idldir,stalab
  
  widget_control,ev.id,get_uvalue=uv,get_value=val
 if uv eq 'boo' then begin unwrap=val[0]  &  nscor=val[1] &  exsent=val[2] &  ifysh=val[3] & specreg=val[4] &endif

   case uv of
    ; 'close': widget_control,ev.top,/destroy
     'boo':  
     'over1':  overscan[0]=long(val[0])
     'over2':  overscan[1]=long(val[0])
     'wdqe':  wdqe=val[0]
     'shift image y':  ifysh=val[3]
      else: ;;message,uv,/cont
   endcase

for k=0,n_elements(thres)-1 do begin
  if uv eq init_type[k] then thres[k]=float(val)
endfor

; if uv eq 'boo' then begin unwrap=val[0]  &  nscor=val[1] &  exsent=val[2] &endif
; if uv 

auxparsinfo=strjoin([strjoin(init_type,',	'),strjoin(strtrim(string(thres,for='(F10.2)'),2),',	'),strjoin(red_type,' '),'Geometry: '+strtrim(string(unwrap),2),$
  'Wavelength correction using night sky lines: '+strtrim(string(nscor),2),'External spectrum normalization:  '+strtrim(string(exsent),2),$
  'Overscan: X='+strtrim(string(overscan[0]),2)+'   Y='+strtrim(string(overscan[1]),2),+' w_dqe = '+strtrim(string(wdqe,for='(I10)'),2),$
  ' shift image y = '+strtrim(string(ifysh,for='(I10)'),2),'Spectral series regime: '+strtrim(string(specreg,for='(I10)'),2)],string(10B))

;; if uv eq 'boo' then begin unwrap=val[0]  &  nscor=val[1] &  exsent=val[2] &endif
widget_control,outtext[1],set_value=auxparsinfo
if uv eq 'close' then widget_control,ev.top,/destroy
end

; *********************************

pro change_auxpars,p
   common auxpars,thres,init_type,red_type,unwrap,nscor,exsent,overscan,wdqe,ifysh,auxparsinfo,specreg
 common basicpars,log,opers,indir,outtext,idldir,stalab

  Device, GET_SCREEN_SIZE = screensize

  chauxbase=widget_base(title='SCOrpio REduction: Changing auxiliary parameters',xsize=screensize[0]*0.5,ysize=screensize[1]*0.65,$
     uvalue='chauxbase') ;;,/tracking_events,/kbrd_focus_ev)

;;;; unwrap, nscor & exsent

Boo=cw_bgroup(chauxbase,['Geometry correction','Dispersion curve correction using night sky lines',$
 'External spectral sensitivity calibration','shift image y','Spectral series regime'],/map,/return_name,/nonex,$
  xoffset=0.1*screensize[0],yoffset=0.05*screensize[1],uvalue='boo',set_valu=[unwrap,nscor,exsent,ifysh,specreg])

;; overscan

overtit=widget_label(chauxbase,uv='overtit',value='Overscan values:',yoffset=0.28*screensize[1],xoffset=0.1*screensize[0])
over1_lab=widget_label(chauxbase,uv='over1_lab',value='X:',yoffset=0.3*screensize[1],xoffset=0.05*screensize[0])
over1=widget_text(chauxbase,uv='over1',value=string(overscan[0]),/edit,yoffset=0.3*screensize[1],/all_ev,xoffset=0.05*screensize[0])
over2_lab=widget_label(chauxbase,uv='over2_lab',value='Y:',yoffset=0.3*screensize[1],xoffset=0.2*screensize[0])
over2=widget_text(chauxbase,uv='over2',value=string(overscan[1]),/edit,yoffset=0.3*screensize[1],/all_ev,xoffset=0.2*screensize[0])

;; wdqe

wdtit=widget_label(chauxbase,uv='wdtit',value='w_dqe:',yoffset=0.24*screensize[1],xoffset=0.1*screensize[0])
wd=widget_text(chauxbase,uv='wdqe',value=string(wdqe),/edit,yoffset=0.24*screensize[1],/all_ev,xoffset=0.15*screensize[0])

;;; thresholds:
;
  threchlab=uintarr(n_elements(thres))
  threch=uintarr(n_elements(thres))
  for k=0,n_elements(thres)-1 do begin  
    threchlab[k]=widget_label(chauxbase,uv=init_type[k]+'lab',value=init_type[k],yoffset=(0.35+0.05*k)*screensize[1],xoffset=0.1*screensize[0],/align_right)
    threch[k]=widget_text(chauxbase,uv=init_type[k],/edit,value=string(thres[k],for='(F10.2)'),yoffset=(0.35+0.05*k)*screensize[1],xoffset=0.2*screensize[0],/all_ev)
  endfor
;

;; close

close=widget_button(chauxbase,value='Close',uv='close',$
  yoffset=0.4*screensize[1],xsize=0.05*screensize[0],ysize=0.1*screensize[1],xoffset=0.4*screensize[0])

  widget_control,chauxbase,/realize

  xmanager,'chaux',chauxbase,group=chauxbase,/no_block

message,'Auxiliary parameters updated',/cont
; widget_control,outtext[1],set_value=auxparsinfo

end

;; *** SINGLE REDUCTION STEP

pro scorpio_recycle,reno
 common basicpars,log,opers,indir,outtext,idldir,stalab,screensize,scinfo
 common retail,redmenu,reddetails
 common auxpars,thres,init_type,red_type,unwrap,nscor,exsent,overscan,wdqe,ifysh,auxparsinfo,specreg
 common geopars, geondeg, geo_nx,geo_ny

message,'Reduction step '+strtrim(string(reno+1,for='(I5)'),2)+' started',/cont

;;readf,!journal,scinfo0
;scinfo=[scinfo,scinfo0]
;as=size(scinfo)
;if as[0] gt 0 then begin
; if n_elements(scinfo) gt 2 then widget_control,outtext[2],set_value=strjoin(reverse(scinfo(n_elements(scinfo)-15>0:n_elements(scinfo)-1)),string(10B))
;endif

ninit=n_elements(init_type)
    ;;    if exsent gt 0 then init_type1=init_type(where(strpos(init_type,'star') lt 0)) else init_type1=init_type
        if exsent gt 0 then ima_geom=['obj','neon','flat'] else ima_geom=[red_type,'flat'] 

if log eq 'none' or log eq '' then begin
  widget_control,outtext[0],set_value='Log file '+log+' not found!',/append
  goto,final
endif

rdir=def_rdir(log)
wdir=def_wdir(log)
  ;    message,'output directory: '+wdir,/cont
      SPAWN, 'mkdir '+wdir        

cd,rdir,current=curd
 spawn,'for a in *.ZIP *.zip; do unzip $a; done'
cd,curd

cd,wdir,cur=curd

CASE reno OF
       ;  0:   goto,final      ; batch debugging regime ;)
         0:   goto,inp_1      ; bias subtraction, cosmic particles removal
         1:   goto,inp_2      ; geometry correction using neon exposures
         2:   goto,inp_3      ; flat-field correction
         3:   goto,inp_4      ; dispersion curve creation
         4:   goto,inp_5      ; linearisation
         5:   goto,inp_6      ; spectral sensitivity determination (& normalization)
         6:   goto,inp_7     ; dispersion diraction alignment
;         7:   goto,inp_8      ; night sky subtruction
         7:   goto,inp_8     ; errorframes
;         '9':   goto,inp_9      ; rough spectrum analyses (magnitudes; errorframe added)
;        '10':   goto,inp_10     ; emission line analysis
         else: goto,final
ENDCASE

inp_1:
	; mean_bias,log,overscan=overscan
        for k=0,ninit-1 do redlong,log,init_type[k],thres[k],exsent=exsent,overscan=overscan,yshift=(init_type[k] eq 'obj')*ifysh,specreg=specreg            ; reduction_frame,log,init_type[k],ylimit=def_pos(log),$
           message,'Primary reduction finished',/cont
		goto,final

inp_2:
         if exsent gt 0 then ima_geom=['obj','neon','flat'] else ima_geom=[red_type,'flat'] 
           if unwrap gt 0 then geometry_neon,'neon_i.fts',ima_geom,ima_geom,/plot,w_dir=wdir,Ndeg=geondeg,Nx=geo_nx,Ny=geo_ny $            
           else spawn,'cp '+wdir+'obj_i.fts '+wdir+'obj_ic.fts ; cp '+wdir+'neon_i.fts '+wdir+'neon_ic.fts; cp '+wdir+'neon_i.fts '+wdir+'neon_ic.fts; '
	 if n_elements(def_name(log,'OBJ')) gt 1 and n_elements(def_name(log,'OBJ')) lt 10 and specreg gt 0.  then begin
           if unwrap gt 0 then geometry_neon_quasi3d,'neon_i.fts',['obj'],['obj'],w_dir=wdir,Ndeg=geondeg,Nx=geo_nx,Ny=geo_ny $
           else spawn,'cp '+wdir+'obj_i3.fts '+wdir+'obj_ic3.fts '
         endif
         if n_elements(def_name(log,'OBJ')) ge 10 then geometry_neon_multiframe,log,'neon_i.fts',/plot,w_dir=wdir,Ndeg=geondeg,Nx=geo_nx,Ny=geo_ny
         set_plot,'x'
          message,'Geometry correction finished',/cont
		goto,final

inp_3:
	reduction_flat1,log,'neon'	
	reduction_flat1,log,'obj',multiframe=(n_elements(def_name(log,'OBJ')) ge 10)
	if n_elements(def_name(log,'OBJ')) gt 1 and specreg gt 0. then reduction_flat_quasi3d,log	
  if exsent eq 0 then begin
	reduction_flat1,log,'star'	
	reduction_flat1,log,'starslit'	
  endif
          message,'Reduction over flat-field finished',/cont
		goto,final
inp_4:
 	create_disperse2D,log,idldir
          message,'Dispersion curve',/cont
		goto,final

inp_5:
	linerisation_2D,log,'neon'  ;,lmax,lmin,dl
	linerisation_2D,log,'obj'  ;,lmax,lmin,dl
	if n_elements(def_name(log,'OBJ')) gt 1 and n_elements(def_name(log,'OBJ')) lt 10 and specreg gt 0. then linerisation_quasi3D,log  ;,lmax,lmin,dl
	if n_elements(def_name(log,'OBJ')) ge 10 then linerisation_2D_multiframe,log
        
        if nscor gt 0. then ns_cor,wdir+'obj_lin.fts',wdir+'obj_lin_ns.fts',[5577.345,6300.23],wdir,w=50. $
  else spawn,'cp '+wdir+'obj_lin.fts '+wdir+'obj_lin_ns.fts'
	 barlincor,wdir+'obj_lin_ns.fts',wdir+'obj_lin_ns.fts'
	
	if exsent eq 0 then begin
	   linerisation_2D,log,'star'  ;,lmax,lmin,dl
;	if exsent eq 0 then 
	   linerisation_2D,log,'starslit'  ;,lmax,lmin,dl
;        if nscor gt 0. then ns_cor,wdir+'obj_lin.fts',wdir+'obj_lin_ns.fts',[5577.345,6300.23],wdir,w=50. $
;  else spawn,'cp '+wdir+'obj_lin.fts '+wdir+'obj_lin_ns.fts'
;         barlincor,wdir+'obj_lin_ns.fts',wdir+'obj_lin_ns.fts'
      barlincor,wdir+'starslit_lin.fts',wdir+'starslit_lin.fts'
      barlincor,wdir+'star_lin.fts',wdir+'star_lin.fts'
  endif
  
         if n_elements(def_name(log,'OBJ')) ge 10 then barlincor_multiframe,log
          message,'Linearisation',/cont
		goto,final
inp_6:
  if exsent eq 0 then begin
          long_sent,log,wdqe=wdqe
  endif else begin
          ;spawn,'cp '+dialog_pickfile(filter=wdir+'../sent.fts',title='selest SENT file')+' '+wdir+'sent.fts'
           filesent=dialog_pickfile(filter=wdir+'../sent.fts',title='selest SENT file')
           spawn,'cp '+filesent+' '+wdir
           spawn,'cp '+exdir(filesent)+'DQE.ps'+' '+wdir
  endelse

    if specreg gt 0. then begin
          if exsent le 0 then long_corrsent,['obj','star','starslit','cube'],wdir,str_sep(def_par(log,'SLITSIZE'),','),ext='_norm.fts' $
else long_corrsent,['obj','cube'],wdir,str_sep(def_par(log,'SLITSIZE'),','),ext='_norm.fts'
          if exsent le 0 then plot,starloss(log)

    endif else begin
          if exsent le 0 then long_corrsent,['obj','star','starslit'],wdir,str_sep(def_par(log,'SLITSIZE'),','),ext='_norm.fts' $
else long_corrsent,['obj'],wdir,str_sep(def_par(log,'SLITSIZE'),','),ext='_norm.fts'
          if exsent le 0 then plot,starloss(log)

    endelse

           if n_elements(def_name(log,'OBJ')) ge 10 then long_corrsent_multiframe,log
          message,'Spectral sensitivity calibration',/cont
	  goto,final

inp_7:
           LS_correlate,wdir+'obj_norm.fts',outfile=wdir+'obj_norm_1.fts'
           message,'Dispersion alignment adjusted',/cont
		goto,final

inp_8:
           errorframe_long,log
           signal_noise_score,log
           message,'Error 2D spectra calculated',/cont
		goto,final

;inp_9:  
;         subsky_compact,'obj',wdir,200.,w=100,/int
;           message,'Night sky subtructed',/cont
;		goto,final
;

           
final:
;; xdisplayfile,outlog
wkiller
widget_control,outtext[0],set_value='Log file '+log+';'+string(10B)+redmenu[reno]+'finished',/append

cd,curd

end

;******************  Event handling:  ************************

pro scored_event,ev
common basicpars,log,opers,indir,outtext,idldir,stalab,screensize,scinfo
common retail,redmenu,reddetails
common auxpars,thres,init_type,red_type,unwrap,nscor,exsent,overscan,wdqe,ifysh,auxparsinfo,specreg
common geopars, geondeg, geo_nx,geo_ny

    widget_control,ev.id,get_uvalue=uv,get_value=val
nr=n_elements(redmenu)
;if val ne 'base' then message,val
scinfo0='' 
; readf,!journal,scinfo0
if scinfo0 ne '' then scinfo=[scinfo,scinfo0]

as=size(scinfo)
;; message,'size '+string(as[1]),/cont
if as[0] gt 0 then begin
 if n_elements(scinfo) gt 2 then widget_control,outtext[2],set_value=strjoin(reverse(scinfo(n_elements(scinfo)-10>0:n_elements(scinfo)-1)),string(10B)),/append
 if n_elements(scinfo) gt 10 then scinfo=scinfo(as[1]-10:as[1]-1)
endif

if uv eq 'negr' then xdisplayfile,idldir+'lines.tab',title='He, Ne, Ar lines',width=17
if uv eq 'Help' then begin
 cd,idldir,current=curd
 spawn,'xpdf instrukcia_2010.pdf &'
endif              
   case uv of
 ;    'Help': cd,idldir,current=curd & spawn,'xpdf instrukcia_2010.pdf &'
     'Exit': widget_control,ev.top,/destroy
     'Load log': log=dialog_pickfile(filter=indir+'*.txt')
     'Create log': log=logmaker(indir)
     'Edit log': xdisplayfile,log,/edit
     'redd': opers=val
     'negr': if log ne '' and log ne 'none' then create_etalon,log,dir=idldir0
     'geo0':  geondeg=long(val[0])
     'geo1':  geo_nx=long(val[0])
     'geo2':  geo_ny=long(val[0])
     'spext': if log ne '' and log ne 'none' then scorespext,log
     'spext_multi': if log ne '' and log ne 'none' then exspect_interactive_multigauss,log,screen=screensize,idldir=idldir
     'mapsh': if log ne '' and log ne 'none' then map_interactive,log ;; out_map,log
     'run': ; for k=0,nr-1 do if opers[k] eq 1 then scorpio_recycle,k
     'dirv': if log ne 'none' and log ne '' then view_anyfile,dialog_pickfile(filter=def_par(log,'W_DIR')+'*',title='directory contents',/multi),gro=ev.top
     'dirvin': if log ne 'none' and log ne '' then view_anyfile,dialog_pickfile(filter=def_par(log,'R_DIR')+'*',title='directory contents',/multi),gro=ev.top
     'chaux': change_auxpars
     'tout2': ;; if n_elements(scinfo) gt 2 then widget_control,outtext[2],set_value=strjoin(scinfo(n_elements(scinfo)-5>0:n_elements(scinfo)-1),string(10B)) ;;,/append
      else: message,uv,/cont
   endcase
     if uv eq 'log' then message,'logfile loaded: '+log,/cont
; message,scinfo,/cont
if string(val[0]) ne 'Exit' and log ne 'none' then widget_control,outtext[0],set_value='Logfile loaded: '+log
  if uv eq 'chaux' then widget_control,outtext[1],set_value=auxparsinfo
  if uv eq 'run' then begin
    widget_control,stalab,set_value='Status:     in process...'
    for k=0,nr-1 do if opers[k] gt 0 then scorpio_recycle,k
    widget_control,stalab,set_value='Status:    IDLe'
    opers=opers*0
    widget_control,reddetails,set_value=opers
  endif
  ;;  widget_control,outtext[2],set_value=scinfo,/append

end

;;      ************ MAIN pro ******************

pro scorpio_v0,noblock=noblock

common basicpars,log,opers,indir,outtext,idldir,stalab,screensize,scinfo
common retail,redmenu,reddetails
common auxpars,thres,init_type,red_type,unwrap,nscor,exsent,overscan,wdqe,ifysh,auxparsinfo,specreg
common geopars, geondeg, geo_nx,geo_ny
common global, idldir0, indir0, ver, stddir0

idldir=idldir0
init_type=['bias','obj','flat','neon','star','map','starslit']
thres=[0.,3.,10.,20.,3.,10.,3.]
red_type=['obj','neon','star','starslit']
scinfo=''
unwrap=1
nscor=0
exsent=0 
overscan=[20,-20]
wdqe=240.0
ifysh=1
specreg=0.

auxparsinfo=strjoin([strjoin(init_type,',	'),strjoin(strtrim(string(thres,for='(F10.2)'),2),',	'),strjoin(red_type,' '),'Geometry: '+strtrim(string(unwrap),2),$
  'Wavelength correction using night sky lines: '+strtrim(string(nscor),2),'External spectrum normalization:  '+strtrim(string(exsent),2),$
  'Overscan: X='+strtrim(string(overscan[0]),2)+'   Y='+strtrim(string(overscan[1]),2),+'  w_dqe = '+strtrim(string(wdqe,for='(I10)'),2),$
  '  shift image y = '+strtrim(string(ifysh,for='(I10)'),2),'Spectral series regime: '+strtrim(string(specreg,for='(I10)'),2)],string(10B))

;idldir='/bufm/scorpio.lib_2006/'

  strmenu=['Exit','Load log','Create log','Edit log','Help']
  redmenu=['1: Mean bias & cosmic removal', '2: Geometry correction', $
  '3: dividing over flat field', '4: dispersion curve', '5: linerisation',$
  '6: spectral sensitivity normalization','7: Dispersion direction adjustment',$
  '8: Error frames calculation'];'8: Night sky spectrum subtruction',

nstr=n_elements(strmenu)  &  nr=n_elements(redmenu)

opers=replicate(0.,nr)   &  log='none'  &  indir=indir0

geondeg=2  &  geo_nx=10  &  geo_ny=30

set_plot,'x'
  Device, GET_SCREEN_SIZE = screensize

    base=widget_base(title='SCOrpio REduction: version '+ver,xsize=screensize[0]*0.90,ysize=screensize[1]*0.55,$
     uvalue='base') ;;,/tracking_events,/kbrd_focus_ev)

  bbut=uintarr(nstr)

  for k=0,nstr-1 do bbut[k]=widget_button(base,val=strmenu[k],uval=strmenu[k],$
   xoffset=round(1.05*screensize[0]*double(k)/double(nstr+1.02)),xsize=1.01*round(screensize[0]*(1.+0.*double(k eq 0))/double(nstr+1.02)),$
   ysize=round(0.05*screensize[1]))

;; ****

;red1_text=widget_text(base,value='1: Primary reduction',uv='red1_text',yoffset=0.06*screensize[1])
;red1_button=widget_button(base,value=idldir+'off.bmp',uv='red1',$
;  yoffset=0.06*screensize[1],/bitmap,xsize=30,ysize=30,xoffset=0.5*screensize[0],/dyna)

redlabel=widget_label(base,value='Reduction steps:',$
  xoffset=0.015*screensize[0],yoffset=0.075*screensize[1])
reddetails=cw_bgroup(base,redmenu,/map,/return_name,/nonex,/frame,$
  xoffset=0.015*screensize[0],yoffset=0.11*screensize[1],uvalue='redd')

negr=widget_button(base,value='New grating',uv='negr',$
  yoffset=0.22*screensize[1],xsize=0.16*screensize[0],ysize=0.035*screensize[1],xoffset=0.275*screensize[0])

spext=widget_button(base,value='Spectum extraction',uv='spext',$
  yoffset=0.29*screensize[1],xsize=0.16*screensize[0],ysize=0.035*screensize[1],xoffset=0.275*screensize[0])

spext_multi=widget_button(base,value='Multi extraction ',uv='spext_multi',$
  yoffset=0.254*screensize[1],xsize=0.16*screensize[0],ysize=0.035*screensize[1],xoffset=0.275*screensize[0])

mapsh=widget_button(base,value='Region map',uv='mapsh',$
  yoffset=0.323*screensize[1],xsize=0.16*screensize[0],ysize=0.035*screensize[1],xoffset=0.275*screensize[0])

;; *** 

geolab=uintarr(3)  &  geowind=uintarr(3)

geotit=widget_label(base,uv='geotit',value='Geometry parameters:',yoffset=0.06*screensize[1],xoffset=0.3*screensize[0])
geolab[0]=widget_label(base,uv='geo0_lab',value='Ndeg:',yoffset=0.1*screensize[1],xoffset=0.32*screensize[0])
geowind[0]=widget_text(base,uv='geo0',value=strtrim(string(geondeg),2),/edit,yoffset=0.09*screensize[1],/all_ev,$
  xoffset=0.36*screensize[0],xsize=0.005*screensize[0])
geolab[1]=widget_label(base,uv='geo1_lab',value='X_pos:',yoffset=0.14*screensize[1],xoffset=0.32*screensize[0])
geowind[1]=widget_text(base,uv='geo1',value=strtrim(string(geo_nx),2),/edit,yoffset=0.13*screensize[1],/all_ev,$
  xoffset=0.36*screensize[0],xsize=0.005*screensize[0])
geolab[2]=widget_label(base,uv='geo2_lab',value='Y_pos:',yoffset=0.18*screensize[1],xoffset=0.32*screensize[0])
geowind[2]=widget_text(base,uv='geo2',value=strtrim(string(geo_ny),2),/edit,yoffset=0.17*screensize[1],/all_ev,$
  xoffset=0.36*screensize[0],xsize=0.005*screensize[0])

;; ***

outtext=uintarr(3)
  outtext[0]=widget_text(base,yoffset=screensize[1]*0.5,uvalue='tout0',xsize=screensize[0]*0.6,$
    ysize=screensize[1]*0.05,/wrap,value='')  ;; Log name
  outtext[1]=widget_text(base,yoffset=screensize[1]*0.21,uvalue='tout1',scr_xsize=screensize[0]*0.4,$
    ysize=screensize[1]*0.15,value=auxparsinfo,xoffset=0.49*screensize[0],/scro,scr_ysize=screensize[1]*0.28)  
;  outtext[2]=widget_text(base,yoffset=screensize[1]*0.4,uvalue='tout2',xsize=screensize[0]*0.063,$
;    ysize=screensize[1]*0.7,value='message box:'+string(10B),xoffset=0.49*screensize[0],/all_ev,/scro,$
;    scr_ysize=screensize[1]*0.12)   ;; procedures suggested

run=widget_button(base,value='RUN',uv='run',$
  yoffset=0.45*screensize[1],xsize=0.1*screensize[0],ysize=0.05*screensize[1],xoffset=0.01*screensize[0])

stalab=widget_label(base,value='Status: IDLe',uv='stal',$
  yoffset=0.45*screensize[1],xsize=0.2*screensize[0],ysize=0.05*screensize[1],xoffset=0.06*screensize[0])

dirv=widget_button(base,value='View output directory',uv='dirv',$
  yoffset=0.1*screensize[1],xsize=0.2*screensize[0],ysize=0.05*screensize[1],xoffset=0.7*screensize[0])

dirvin=widget_button(base,value='View input directory',uv='dirvin',$
  yoffset=0.1*screensize[1],xsize=0.2*screensize[0],ysize=0.05*screensize[1],xoffset=0.5*screensize[0])

chaux=widget_button(base,value='Change auxilliaries',uv='chaux',$
  yoffset=0.15*screensize[1],xsize=0.2*screensize[0],ysize=0.05*screensize[1],xoffset=0.7*screensize[0])

  widget_control,base,/realize
;  widget_control,reddetails,/realize
emblem=idldir+'score_arm1.bmp'
queryStatus = QUERY_IMAGE(emblem, imageInfo)
imageSize = imageInfo.dimensions
image = READ_IMAGE(emblem)
imageDims = SIZE(image, /DIMENSIONS)
 DEVICE, DECOMPOSED = 0 
 interleaving = WHERE((imageDims NE imageSize[0]) AND  (imageDims NE imageSize[1])) + 1
  draw=widget_draw(base,xsize=imageSize[0],ysize=imageSize[1],xoffset=screensize[0]*0.265,$
  yoffset=screensize[1]*0.365,uvalue='Draw',keyboard_events=2,/expose_ev,/button_events)
  TV, image, TRUE = interleaving[0],0,0;imageSize1[0]-20,imageSize1[1]-50
  WIDGET_CONTROL, draw, GET_VALUE=indraw
  wset,indraw
 ; widget_control,base,/realize

;;xdisplayfile,outlog
  xmanager,'scored',base,group=base,no_block=noblock
;  xmanager,'scored',reddetails,group=base,/no_block

end
