pro circ,x,a,f,pder

; a=dblarr(3)
 f=a[0]*sqrt(-((x-a[1])/a[2])^2+1.)+a[3]
w0=where(((x-a[1])/a[2])^2 gt 1.,n0)
if n0 gt 0 then f(w0)=a[3]
if n_params() ge 4 then begin
  pder=dblarr(n_elements(x),n_elements(a))
  pder(*,0)=f/a[0]
  pder(*,1)=(a[0]/a[2])^2*(x-a[1])/(f)
  pder(*,2)=(a[0]/a[2])^2*(x-a[1])^2/(f*a[2])
  pder(*,3)=replicate(1.,n_elements(x))
 if n0 gt 0 then pder(w0,*)=0.
endif
end

pro shellfit,inv,indv,ests,yrange=yrange

wdir=exdir(inv)
v=readfits(inv,hv)
lid=sxpar(hv,'LINE')
; v=smooth(med_ext(v,3),3)
dv=readfits(indv,hdv)
ymin=sxpar(hv,'CRVAL1')  &  dy=sxpar(hv,'CDELT1')
y=dindgen(n_elements(v))*dy+ymin
if not(keyword_set(yrange)) then yrange=[ymin,max(y)]

wv=where(y gt min(yrange) and y lt max(yrange),nv)

y=y(wv)  &  v=v(wv)  &  dv=dv(wv)
wdv=where(dv le 0.,ndv)
if ndv gt 0 then dv(wdv)=median(dv)*100.

wts=replicate(1.,n_elements(v))  ;/dv   ;1./(1.+(y-ests[1])^2)
;wts(where(finite(wts,/NaN)))=0.
;wts(where(finite(wts,/Infinity)))=0.
wts=wts/total(wts)
; wts(where(dv gt 3.*stdev(v)))=0.

pars=ests 
; vfit=curvefit(y,v,wts,pars,sighma,function_name='circ',chisq=chisq,tol=1.e-1,itmax=500,/double)
vfit=gaussfit(y,v,pars,nterms=4,estimates=ests,sigma=sighma,yerror=yrs,meas=dv,chisq=chisq)
 yrs=v-vfit
 wg=where(abs(yrs) le 5.*median(dv))
iter:
; vfit=curvefit(y(wg),v(wg),wts(wg),pars,sighma,function_name='circ',chisq=chisq,itmax=500,/double,tol=1.e-7)
; vfit=curvefit(y(wg),v(wg),wts(wg),pars,sighma,chisq=chisq,itmax=500,/double,tol=1.e-7)
vfit=gaussfit(y(wg),v(wg),pars,nterms=4,estimates=ests,sigma=sighma,yerror=yrs,meas=dv(wg),chisq=chisq)
; yrs=v(wg)-vfit
; wts(wg)=1./(1.+(y(wg)-pars[1])^2)
; wts(wg)=wts(wg)/total(wts(wg))
print,pars[0],'+/-',sighma[0]
print,pars[1],'+/-',sighma[1]
print,pars[2],'+/-',sighma[2]
print,pars[3],'+/-',sighma[3]
print,'chisq='+strtrim(string(chisq),2)
;if chisq gt 3. and n_elements(wg) gt 5 then goto,iter

; circ,y,pars,vfit

set_plot,'ps'
 device,filename=inv+'_shellfit.ps',/land
  plot,y,v,psym=2,yrange=[-300.,100.],yst=1
  oploterr,y,v,dv
  oplot,y(wg),vfit
  xyouts,.2,.9,lid+' Gaussian fit (!4v!3!E2!N = '+strtrim(string(chisq,format='(F5.1)'),2)+'):',/norm
  xyouts,.2,.8,'A = '+strtrim(string(pars[0],format='(F8.2)'),2)+string("261B)+strtrim(string(sighma[0],format='(F8.2)'),2)+'km/s',/norm
  xyouts,.2,.7,'y!Dc!N = '+strtrim(string(pars[1],format='(F8.2)'),2)+string("261B)+strtrim(string(sighma[1],format='(F8.2)'),2)+'arcsec',/norm
  xyouts,.5,.7,'FWHM = '+strtrim(string(pars[2]*sqrt(8.*alog(2)),format='(F8.3)'),2)+string("261B)+strtrim(string(sighma[2]*sqrt(8.*alog(2))+'km/s',format='(F8.2)'),2)+'arcsec',/norm
  xyouts,.2,.6,'V!Do!N = '+strtrim(string(pars[3],format='(F8.2)'),2)+string("261B)+strtrim(string(sighma[3],format='(F8.2)'),2)+'km/s',/norm
 device,/close
set_plot,'x'

print,pars,sighma
print,'chisq = '+strtrim(string(chisq),2)
end
