;show
pro show,LOGFILE,outps=outps,ERG=erg,MJY=mJy,POS_slit=pos_slit
 print,'show'
if not(keyword_set(outps)) then outps='out.ps'
;determination working directory and file extention
wdir=def_wdir(logfile)
rdir=def_rdir(logfile)
 ext=def_ext(logfile)
map=read_fts(wdir+'map.fts',hmap,/silent)
Nx=sxpar(hmap,'NAXIS1') & Ny=sxpar(hmap,'NAXIS2')
Ny=201
;****************
if not(keyword_set(pos_slit)) then pos_slit=510
;determination shift of frame
;EXTRACTION SPECTRA NEON
;check size of frame
y_range=fix(str_sep(def_pos(logfile),','))
N_range=y_range(1)-y_range(0)+1
neon_name=DEF_NAME(LOGFILE,'neon',N_neon)
bias=read_fts(wdir+'bias_i.fts',/silent)
a=size(bias)  &  N_x=a(1)   &  N_y=a(2)
neon_s= fltarr(N_x)
tmp=readfile(rdir,neon_name(0),ext,h)
if sxpar(h,'NAXIS2') gt N_range then tmp=tmp(*,y_range(0):y_range(1))
neon=tmp-bias
WW=10
neon_s=total(neon(*,N_y/2-ww:N_y/2+ww),2)
vc=read_fts('neon_eta.fts',/silent)
dc=150  & xc=findgen(2*dc+1)-dc
gau=gaussfit(xc,cross_norm(neon_s,vc,dc),G)
frame_shift=G(1)
print,frame_shift
pos_slit=pos_slit+frame_shift
;***************
k=20

obj_name=strcompress(sxpar(hmap,'object'))
date_obs=strcompress(sxpar(hmap,'date-obs'))
exp_map=string(sxpar(hmap,'exptime'),format='(I3)')
RA=strmid(sxpar(hmap,'RA'),0,11)
DEC=strmid(sxpar(hmap,'DEC'),0,11)

set_plot,'PS'
device,file=wdir+outps,xsize=18,ysize=26,yoffset=2,xoffset=2
i=range(map,2,10)
vector_y=total(map(pos_slit-2:pos_slit+2,*),1)
tmp=max(vector_y(Ny/2-Ny/4:Ny/2+Ny/4),ymax)
ymax=ymax+Ny/2-Ny/4
map=bytscl(map,i(0),i(1))
map(pos_slit,0:ymax-4)=150
map(pos_slit,ymax+4:Ny-1)=150

tv,255-map(100:Nx-1,*),0.1,0.83,xsize=0.895,/normal
sky=read_fts(wdir+'sky.fts',/silent)
sky=sky(*,0:200)
obj=read_fts(wdir+'obj.fts',/silent)
obj=obj(*,0:200)
i_obj=range(obj,3,10)
;remove negative values
R=where(obj lt 0)
obj(R)=0
sky=sky+obj
i=range(sky,3,3) & i(0)=0
tv,255-bytscl(sky(*,*),i(0),i(1)),0.1,0.69,xsize=.895,/normal

tv,255-bytscl(obj(*,*),0,i_obj(1)/4),0.1,0.55,xsize=.895,/normal

obj_s=read_fts(wdir+'obj_s.fts',h,/silent)
x=findgen(Nx)
Texp=string(sxpar(h,'EXPTIME'),format='(I5)')
s=string(sxpar(h,'seeing'),format='(F4.1)')
z=string(sxpar(h,'Z'),format='(I3)')
plot,x(*),obj_s(*),xst=1,psym=10,$
	ytitle='Intensity, ADU',xtitle='channel',$
	title=date_obs+' '+obj_name+' '+'Texp='+Texp+' s'+' Z='+z+' seeing='+s+'"',$
position=[0.1,0.325,.995,0.525],/norm,/noerase
oplot,[0,Nx-1],[0,0],LINESTYLE=2
if keyword_set(erg) then obj_abs=read_fts(wdir+'obj_erg.fts',h,/silent)
if keyword_set(mJy) then obj_abs=read_fts(wdir+'obj_mJy.fts',h,/silent)
lambda=findgen(sxpar(h,'NAXIS1'))*sxpar(h,'CDELT1')+sxpar(h,'CRVAL1')
unit=strcompress(sxpar(h,'UNIT'))

;determination range output of ordinate
order=rfix(alog10(max(obj_abs)))

scale=10.^(-order)
if keyword_set(erg) then begin
scale=10.^(-order)
title_y='Flux, 1E'+string(order,format='(I3)')+' erg/cm^2/s/A'
endif
if keyword_set(mJy) then begin
scale=1   & title_y='Flux, mJy'
if order lt -1 then begin
scale=1000.
title_y='Flux, !7l!3Jy'
endif
endif
d_mag=corr_magnitudes(S,1.5)
mag='B='+string(sxpar(h,'B')+d_mag,format='(F5.2)')+$
	'  V='+string(sxpar(h,'V')+d_mag,format='(F5.2)')+$

	'  R='+string(sxpar(h,'R')+d_mag,format='(F5.2)')+$
	'  I='+string(sxpar(h,'I')+d_mag,format='(F5.2)')

plot,lambda,scale*obj_abs,xst=1,psym=10,$
	ytitle=title_y,xtitle='Wavelength, A',title=mag,$
	/noerase,position=[0.1,0.05,.995,.25],/norm

	oplot,[3500,11000],[0,0],LINESTYLE=2
xyouts,0.1,.98,date_obs+'  '+obj_name+' RA='+RA+' DEC='+DEC+' Texp='+exp_map+' s',/norm
rdir=def_rdir(logfile)
xyouts,0.1,-0.02,'logfile '+logfile+'  wdir '+wdir+'  rdir '+rdir,charsize=0.7,/norm
device,/close
set_plot,'WIN'

end
