function slitloss,seeing,offset,slitwidth
; seeing, offset and slitwidth in arcsec
sigma=seeing/sqrt(8D*alog(2D))

p=gauss_pdf((double(slitwidth)/double(2.)+offset)/double(sigma))-$
 gauss_pdf((-double(slitwidth)/double(2.)+offset)/double(sigma))

return,p
end

function slit_center,seeing,offset,slitwidth
; seeing, offset and slitwidth in arcsec
sigma=seeing/sqrt(8D*alog(2D))
np=100
ns=n_elements(sigma)
cx=sigma

for k=0,ns-1 do begin
 x=(dindgen(2*np)/double(np)-1D)*slitwidth/(sigma[k]*2D)+offset/sigma[k]
 y=gaussian(x,[1D/sqrt(2D*!DPI),0D,1D])
 cx[k]=abs(int_tabulated(x,y*x)*sigma[k]/int_tabulated(x,y)-offset)
endfor

return,cx
end

pro slit_show,parx

nb=2000 &  nx=1000
b=0.2+dindgen(nb)*0.01
x=dindgen(nx)*0.01
x1=dindgen(nx)*0.001

z=dblarr(nx,nb)
cx=dblarr(nx,nb)
for k=0,nx-1 do z(k,*)=slitloss(b,x[k],.75)
for k=0,nx-1 do cx(k,*)=slit_center(b,x1[k],.75) ;/x1[k]

lev=reverse(10.^(-dindgen(12)*.2))
levx=dindgen(100)
levx=reverse((10D)^(-levx*0.5))

set_plot,'ps'
 device,filename='~/trash/slit_show.ps',/land
  contour,z,x,b,c_annotation=strtrim(string((1.-lev)*100.,for='(F20.1)'),2)+'%',levels=lev,/ylog,$
xtitle='offset,arcsec',ytitle='seeing,arcsec',c_labels=(indgen(n_elements(lev)) mod 3 eq 0),$
title='Gaussian slit losses for 1arcsec slit',charsize=2.,charthick=3.,c_thick=2.,c_charthick=2.
 device,/close
set_plot,'x'
set_plot,'ps'
 device,filename='~/trash/slit_cent.ps',/land
  contour,cx,x1,b,c_annotation=strtrim(string(levx,for='(F20.3)'),2),levels=levx,/ylog,$
xtitle='offset,arcsec',ytitle='seeing,arcsec',c_labels=(indgen(n_elements(levx)) mod 3 eq 0),$
title='center shift',charsize=2.,charthick=3.,c_thick=2.,c_charthick=2.
 device,/close
set_plot,'x'
end
