pro sulfrac_long,wdir,smoo=smoo

  file1=readfits(wdir+'6717_F0.fts',h1)
  file2=readfits(wdir+'6731_F1.fts',h2)
  dfile1=readfits(wdir+'6717_df0.fts',dh1)
  dfile2=readfits(wdir+'6731_df1.fts',dh2)

if keyword_set(smoo) then begin
 file1=smooth(file1,3)
 file2=smooth(file2,3)
endif

fr=file1/file2
dfr=fr*(dfile1/file1+dfile2/file2)

dy=sxpar(h1,'CDELT1')
y0=sxpar(h1,'CRVAL1')

y=dindgen(n_elements(fr))*dy+y0

set_plot,'ps'
device,filename=wdir+'sulfrac.ps',/land
 plot,y,fr,xtitle='y, arcsec',ytitle='[SII] 6717 / 6731',chars=1.5,chart=2.5,thic=2.5,psym=2
 oploterr,y,fr,dfr
device,/close
set_plot,'x'

n_e=sulf_to_ne(fr)
n_e1=sulf_to_ne(fr+.5*dfr)  &  n_e2=sulf_to_ne(fr-.5*dfr)
dn_e=abs(n_e2-n_e) < abs(n_e1-n_e)
www=where(n_e le 0.)
n_e1=n_e(www) & y1=y(www) & dn_e1=dn_e(www)

set_plot,'ps'
device,filename=wdir+'n_e.ps',/land
 plot,y,n_e,/ylog,xtitle='y,arcsec',ytitle='n!De!N,cm!U-3!N',chars=2.5,chart=3.,thic=2.5,psym=2,yrange=[1.,1.e6],yst=1
 oploterr,y,n_e,dn_e
 oplot,y1,dn_e1,psym=8
device,/close
set_plot,'x'

end
