
pro REGIONparam
COMMON IMAblock,file,h,frame,ima,LOGFILE,Nx,Ny,Nz,sc,bin,plane,d_lambda,lambda_0,over,x_size,y_size,range,level
COMMON REG,x_min,y_min,x_max,y_max,region,x,y,a
COMMON BOXblock,map,x1,x2,y1,y2,x_2,y_2,sw
; calculation region coordinates
x_min=min([x1,x2])/sc/bin & x_max=max([x1,x2])/sc/bin
y_min=min([y1,y2])/sc & y_max=max([y1,y2])/sc
region=frame(x_min:x_max,y_min:y_max,plane)
a=size(region)
x=findgen(a(1))+x_min
y=findgen(a(2))+y_min
END

pro  LOADFILE,REP=rep
COMMON IMAblock,file,h,frame,ima,LOGFILE,Nx,Ny,Nz,sc,bin,plane,d_lambda,lambda_0,over,x_size,y_size
COMMON WINblock,win_num,swin,planeW,draw
plane=0
wdir=DEF_WDIR(LOGFILE)
CD,wdir,CURRENT=scorp_dir
file=pickfile(/read,filter='*.fts')
CD,scorp_dir
frame=readfits(file,h)
if os_family() eq 'unix' then sep='/' else sep='\'
file=str_sep(file,sep) & file=file(N_elements(file)-1) & file=str_sep(file,'.') & file=file(0)

Nx=sxpar(h,'NAXIS1') & Ny=sxpar(h,'NAXIS2')
bin=sxpar(h,'binning')
d_lambda=sxpar(h,'CDELT1')
lambda_0=sxpar(h,'CRVAL1')
if bin eq 0 then begin
bin=1
goto, cont1
endif
bin=fix(str_sep(bin,'x')) & bin=float(bin(0))/bin(1)
cont1:
XY=float(Nx)/float(Ny)
y_size=550
sc=float(y_size)/float(Ny)

x_size=y_size*XY*bin
if keyword_set(rep) then begin
WIDGET_CONTROL, draw, GET_VALUE=win_num,DRAW_XSIZE=FIX(x_size)
WIDGET_CONTROL, draw, GET_VALUE=win_num,SET_DRAW_VIEW=[(x_size-y_size)/2,0]
endif
Naxis=sxpar(h,'NAXIS')
if Naxis eq 3 then begin
Nz=sxpar(h,'NAXIS3')
ima=congrid(frame,x_size,y_size,Nz)
endif
if Naxis eq 2 then Nz=0
if Naxis eq 2 then ima=congrid(frame,x_size,y_size)
END

pro BOX
COMMON IMAblock,file,h,frame,ima,LOGFILE,Nx,Ny,Nz,sc,bin,plane,d_lambda,lambda_0,over,x_size,y_size,range,level
COMMON WINblock,win_num,swin,planeW,draw
COMMON BOXblock,map,x1,x2,y1,y2,x_2,y_2,sw
WSET, win_num
slitpos=(DEF_SLIT(LOGFILE)-over)*sc*bin
TV,map
plot,[0,x_size],[0,y_size],/noerase,/nodata,position=[0,0,1,1],$
	xtickinterval=x_size,ytickinterval=y_size,xst=1,yst=1,$
	xminor=1,yminor=1,/norm
if file eq 'map_i' then oplot,[1,1]*slitpos,[0,y_size],color=255
oplot,[x1,x_2,x_2,x1,x1],[y1,y1,y_2,y_2,y1],color=255
end


pro DRAWIMAGE
COMMON IMAblock,file,h,frame,ima,LOGFILE,Nx,Ny,Nz,sc,bin,plane,d_lambda,lambda_0,over,x_size,y_size,range,level
COMMON WINblock,win_num,swin,planeW,draw
COMMON BOXblock,map,x1,x2,y1,y2,x_2,y_2,sw
WSET, win_num
i=50./range
j=50./level

slitpos=(DEF_SLIT(LOGFILE)-over)*sc*bin
rms_ima=stdev(ima(*,*,plane),avg_ima)
map=255-bytscl(ima(*,*,plane),avg_ima*j-rms_ima*i,avg_ima*j+i*2*rms_ima)
TV,map
plot,[0,x_size],[0,y_size],/noerase,/nodata,position=[0,0,1,1],$
	xtickinterval=x_size,ytickinterval=y_size,xst=1,yst=1,$
	xminor=1,yminor=1,/norm
if file eq 'map_i' then oplot,[1,1]*slitpos,[0,y_size],color=255
oplot,[x1,x2,x2,x1,x1],[y1,y1,y2,y2,y1],color=255
;WSET, swin			; Restore the original window
END


PRO viewfits_event, event

; This is the event handler for a draw widget which tracks
; cursor motion events.

; The COMMON block is used because the event handler needs
; widget ID's of the labels:

COMMON LABELblock, pixel_label, value_label,mean_label,rms_label,POS_label,FWHM_label,SEE_label,wave_label
COMMON SLIDEdlock,viewrange,viewbackground
COMMON REG,x_min,y_min,x_max,y_max,region,x,y,a
COMMON IMAblock,file,h,frame,ima,LOGFILE,Nx,Ny,Nz,sc,bin,plane,d_lambda,lambda_0,over,x_size,y_size,range,level
COMMON WINblock,win_num,swin,planeW,draw
COMMON BOXblock,map,x1,x2,y1,y2,x_2,y_2,sw

; When a widget is selected, put its User Value into 'eventval':

WIDGET_CONTROL, event.id, GET_UVALUE = eventval

; Perform actions based on the User Value of the event:

CASE eventval OF
'plane'      :  if Nz ne 0 then begin
				BEGIN WIDGET_CONTROL,event.id,GET_VALUE=plane
				if Nz eq 0 then plane=0
				DRAWIMAGE
				endif
				END
'DRAW_WIN_EVENT': BEGIN
			;HELP, /STRUCT, event
		
            if event.press EQ 1  then begin
            sw=1
            x1=event.x  & y1=event.y
			endif

            if event.release EQ 1 then begin
            sw=0
            x2=event.x  & y2=event.y
			REGIONparam
            endif

            IF (event.press EQ 0) AND (event.release EQ 0) THEN BEGIN
            x_2=event.x  & y_2=event.y
			if sw eq 1 then BOX


				WIDGET_CONTROL,pixel_label, $
				   SET_VALUE='Pixel' + STRCOMPRESS('('+STRING(FIX(event.x/sc/bin))+','+$
				   STRING(FIX(event.y/sc))+')')
				   if d_lambda gt 0 then $
				WIDGET_CONTROL,wave_label, $
				   SET_VALUE='wavelength' + STRCOMPRESS(STRING(FIX((event.x+1)/sc/bin*d_lambda+lambda_0))+'A') $
				   else WIDGET_CONTROL,wave_label,SET_VALUE=' '

				if Nz eq 0 then  $
				WIDGET_CONTROL,value_label,$
				SET_VALUE='Value=' + STRING(ima(event.x,event.y)) ELSE $
				WIDGET_CONTROL,value_label,$
				SET_VALUE='Value=' + STRING(ima(event.x,event.y,plane))


			ENDIF

		    END
'range': BEGIN
			 WIDGET_CONTROL, viewrange, GET_VALUE=range
			 DRAWIMAGE
			 END
'background': BEGIN
			 WIDGET_CONTROL, viewbackground, GET_VALUE=level

			 DRAWIMAGE
			 END
'plot_region': BEGIN
			Wplot
			end
'region_statistic':BEGIN
		robomean,region,3,0.5,avg_region,rms_region
		;rms_region=stdev(region,avg_region)
		WIDGET_CONTROL,mean_label,SET_VALUE='mean ' + STRING(avg_region)
		WIDGET_CONTROL,rms_label,SET_VALUE='rms ' + STRING(rms_region)
		end
'region_fwhm': BEGIN
			res=GAUSS2DFIT(region,G)
			FWHM=(sqrt(G(2)^2+G(3)^2))*2.345
			WIDGET_CONTROL,POS_label,SET_VALUE='x=' + STRING(G(4)+x_min,format='(F6.1)')+' y='+ STRING(G(5)+y_min,format='(F6.1)')
			WIDGET_CONTROL,FWHM_label,SET_VALUE='FWHM='+STRING(FWHM,format='(F6.1)')+' px'
			if file eq 'map_i' then begin
			imascale=sxpar(h,'IMSCALE')
			imascale=str_sep(imascale,'x') & imascale=float(imascale(1))
			WIDGET_CONTROL,SEE_label,SET_VALUE='seeing='+STRING(FWHM*imascale,format='(F4.1)')+'"'
			endif
				END
'FILE':     BEGIN
			LOADFILE,/rep
			DRAWIMAGE
			END
   'DONE': WIDGET_CONTROL, event.top, /DESTROY
ENDCASE

END



PRO viewfits, GROUP=GROUP

; This is the procedure that creates a draw widget that returns
; motion events.

; The COMMON block is used because the event handler needs
; widget ID's of the labels:

COMMON LABELblock, pixel_label, value_label,mean_label,rms_label,POS_label,FWHM_label,SEE_label,wave_label
COMMON SLIDEdlock,viewrange,viewbackground
COMMON IMAblock,file,h,frame,ima,LOGFILE,Nx,Ny,Nz,sc,bin,plane,d_lambda,lambda_0,over,x_size,y_size,range,level
COMMON WINblock,win_num,swin,planeW,draw
COMMON BOXblock,map,x1,x2,y1,y2,x_2,y_2,sw

;Y_size=550 ; & X_size=1000
swin = !D.WINDOW	; Remember the current window so it can be restored


; This example uses keywords to define the size of the draw area:


range=50 & level=50
plane=0 ;set plane 1
sw=0 & x1=0& y1=0 & x2=0 & y2=0 & x_2=0 &y_2=0
; A top-level base widget with the title "Motion Event Widget Example"
; will be created.  The size is left unspecified until the draw widget
; is created:

base = WIDGET_BASE(TITLE = 'View frame',/ROW); $
	;/COLUMN)
BASE1 = WIDGET_BASE(base,col=1,MAP=1)
; Setting the managed attribute indicates our intention to put this application
; under the control of XMANAGER, and prevents our draw widgets from
; becoming candidates for becoming the default window on WSET, -1. XMANAGER
; sets this, but doing it here prevents our own WSETs at startup from
; having that problem.
WIDGET_CONTROL, /MANAGED, base


; A widget called 'draw' is created:

draw = WIDGET_DRAW(base1, X_SCROLL_SIZE=y_size, Y_SCROLL_SIZE=y_size,$
    XSIZE=x_size, YSIZE=y_size, /SCROLL,/FRAME, $
	/MOTION_EVENTS, /BUTTON_EVENTS ,$		;generate LOTS of events
	UVALUE = 'DRAW_WIN_EVENT', 	RETAIN = 1)

BASE2 = WIDGET_BASE(base1,row=1,MAP=1)

base3=WIDGET_BASE(base,col=1,MAP=1)
button1 = WIDGET_BUTTON(base3, $
		UVALUE = 'FILE', $
		VALUE = 'LOAD FILE')
plane_label = WIDGET_LABEL(base3,  $
	VALUE='set plane')
planeW = CW_BGROUP(base3,['1','2'],/row,/EXCLUSIVE,uvalue='plane',set_value=plane)
viewrange = WIDGET_SLIDER(base3,$ TITLE = 'contrast', $
                        MINIMUM = 1, MAXIMUM = 100, VALUE = 50, $
			UVALUE = 'range')
contrast_label = WIDGET_LABEL(base3,  $
	VALUE='contrast')
viewbackground = WIDGET_SLIDER(base3,$ TITLE = 'brigthness', $
                        MINIMUM = 1, MAXIMUM = 100, VALUE = 50, $
			UVALUE = 'background')
background_label = WIDGET_LABEL(base3,  $
	VALUE='background')
label1=WIDGET_LABEL(base3,  $
	VALUE='  ')
pixel_label = WIDGET_LABEL(base3, /DYNAMIC_RESIZE, $
		VALUE='')

value_label = WIDGET_LABEL(base3, /DYNAMIC_RESIZE, $
		VALUE='')
wave_label=WIDGET_LABEL(base3, /DYNAMIC_RESIZE, $
		VALUE=' ')
label2=WIDGET_LABEL(base3,  $
	VALUE='  ')
button3 = WIDGET_BUTTON(base3, $
		UVALUE = 'plot_region', $
		VALUE = 'plot region')
label3=WIDGET_LABEL(base3,  $
	VALUE='  ')
button4 = WIDGET_BUTTON(base3, $
		UVALUE = 'region_statistic', $
		VALUE = 'region statistic')
mean_label = WIDGET_LABEL(base3, /DYNAMIC_RESIZE, $
		VALUE='mean value')
rms_label = WIDGET_LABEL(base3, /DYNAMIC_RESIZE, $
		VALUE='rms value')

button5 = WIDGET_BUTTON(base3, $
		UVALUE = 'region_fwhm', $
		VALUE = 'region centroid')
POS_label = WIDGET_LABEL(base3, /DYNAMIC_RESIZE, $
		VALUE='x    y')

FWHM_label = WIDGET_LABEL(base3, /DYNAMIC_RESIZE, $
		VALUE='FWHM')
SEE_label=WIDGET_LABEL(base3, /DYNAMIC_RESIZE, $
		VALUE=' ')

button2 = WIDGET_BUTTON(base3, $
		UVALUE = 'DONE', $
		VALUE = 'DONE')
; Realize the widgets:


WIDGET_CONTROL, base, /REALIZE

; Get the window number from the draw widget.  This can only be done
; after the widget has been realized:

WIDGET_CONTROL, draw, GET_VALUE=win_num,SET_DRAW_VIEW=[(x_size-y_size)/2,0]
DRAWIMAGE
; Use TVSCL to display an image in the draw widget.  Set the window for
; the TVSCL command since there may be other draw windows.


; Hand off control of the widget to the XMANAGER:
XMANAGER, "viewfits", base, GROUP_LEADER=GROUP;, /NO_BLOCK
END

pro view,FILELOG,overscan
COMMON IMAblock,file,h,frame,ima,LOGFILE,Nx,Ny,Nz,sc,bin,plane,d_lambda,lambda_0,over,x_size,y_size
over=overscan
LOGFILE=FILELOG
plane=0
wdir=DEF_WDIR(LOGFILE)
CD,wdir,CURRENT=scorp_dir
file=pickfile(/read,filter='*.fts')
CD,scorp_dir
frame=readfits(file,h)
if os_family() eq 'unix' then sep='/' else sep='\'
file=str_sep(file,sep) & file=file(N_elements(file)-1) & file=str_sep(file,'.') & file=file(0)
Nx=sxpar(h,'NAXIS1') & Ny=sxpar(h,'NAXIS2')
bin=sxpar(h,'binning')
d_lambda=sxpar(h,'CDELT1')
lambda_0=sxpar(h,'CRVAL1')
if bin eq 0 then begin
bin=1
goto, cont2
endif
bin=fix(str_sep(bin,'x')) & bin=float(bin(0))/bin(1)
cont2:
XY=float(Nx)/float(Ny)
y_size=550
sc=float(y_size)/float(Ny)
x_size=y_size*XY*bin
Naxis=sxpar(h,'NAXIS')
if Naxis eq 3 then begin
Nz=sxpar(h,'NAXIS3')
ima=congrid(frame,x_size,y_size,Nz)
endif
if Naxis eq 2 then Nz=0
if Naxis eq 2 then ima=congrid(frame,x_size,y_size)
y_size=550

viewfits
end
